"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var node_1 = require("../../../node");
node_1.pri.project.onCreateEntry(function (analyseInfo, entry) {
    if (!node_1.pri.sourceConfig.useServiceWorker) {
        return;
    }
    if (!node_1.pri.sourceConfig.clientServerRender) {
        return;
    }
    entry.pipeEntryHeader(function (header) {
        return "\n      " + header + "\n      import { renderToString } from \"react-dom/server\"\n      import StaticRouter from \"react-router-dom/StaticRouter\"\n      import { escapeRegExp, trimEnd } from \"lodash\"\n    ";
    });
    entry.pipeEntryRender(function (render) {
        return "\n    " + render + "\n    if (navigator.serviceWorker) {\n      navigator.serviceWorker.addEventListener(\"message\", event => {\n        if (event.data.type === \"getServerRenderContent\") {\n          const baseHrefRegex = new RegExp(escapeRegExp(\"" + node_1.pri.sourceConfig.baseHref + "\"), \"g\")\n          const matchRouterPath = event.data.pathname.replace(baseHrefRegex, \"\")\n          // const loadableMap = pageLoadableMap.get(matchRouterPath === \"/\" ? \"/\" : trimEnd(matchRouterPath, \"/\"))\n          // if (loadableMap) {\n          //   loadableMap.preload().then(() => {\n          //     const ssrResult = renderToString(\n          //       <StaticRouter location={event.data.pathname} context={{}}>\n          //         <App />\n          //       </StaticRouter>\n          //     );\n\n          //     if (navigator.serviceWorker.controller) {\n          //       navigator.serviceWorker.controller.postMessage({\n          //         type: 'serverRenderContent',\n          //         pathname: event.data.pathname,\n          //         content: ssrResult\n          //       });\n          //     }\n          //   })\n          // }\n        }\n      })\n    }\n  ";
    });
});
node_1.pri.build.afterProdBuild(function (stats) {
    if (!node_1.pri.sourceConfig.useServiceWorker) {
        return;
    }
    if (!node_1.pri.sourceConfig.clientServerRender) {
        return;
    }
    node_1.pri.serviceWorker.pipeAfterProdBuild(function (str) {
        return "\n      " + str + "\n\n      var SSR_BUNDLE_PREFIX = \"__ssr_bundle__\"\n      var SSR_BUNDLE_VERSION = SSR_BUNDLE_PREFIX + \"" + stats.hash + "\";\n\n      var currentCacheSsrRequest = null\n      var currentCacheSsrOriginHtml = null\n\n      /**\n       * Delete all bundle caches except current SSR_BUNDLE_VERSION.\n       */\n      self.addEventListener(\"activate\", event => {\n        event.waitUntil(\n          caches.keys().then(cacheNames => {\n            return Promise.all(\n              cacheNames\n                .filter(cacheName => cacheName.startsWith(SSR_BUNDLE_PREFIX))\n                .filter(cacheName => cacheName !== SSR_BUNDLE_VERSION)\n                .map(cacheName => caches.delete(cacheName))\n            )\n          })\n        )\n      })\n\n      // Get ssr content from client, and save to cache.\n      self.addEventListener('message', event => {\n        if (event.data && event.data.type && event.data.type === 'serverRenderContent') {\n          var responseInit = {\n            status: 200,\n            statusText: 'OK',\n            headers: { 'Content-Type': 'text/html;charset=utf-8' }\n          };\n\n          var ssrFlag = \"<script>window.enableSsr = true;</script>\"\n          var injectBodyContent = `<div id=\"root\">${event.data.content}</div> \\n ${ssrFlag} \\n`\n          var htmlAddContent = currentCacheSsrOriginHtml.replace(/(\\<body\\>)/g, `$1${injectBodyContent}`)\n\n          const ssrResponse = new Response(\n            htmlAddContent,\n            responseInit\n          );\n\n          caches.open(SSR_BUNDLE_VERSION).then(cache => {\n            cache.put(currentCacheSsrRequest, ssrResponse);\n          })\n        }\n      });\n\n      // Replace entry html to ssr result.\n      self.addEventListener('fetch', event => {\n        if (\n          event.request.mode === 'navigate' &&\n          event.request.method === 'GET' &&\n          event.request.headers.get('accept').includes('text/html')\n        ) {\n          event.respondWith(\n            caches.open(SSR_BUNDLE_VERSION).then(cache => {\n              return cache.match(event.request).then(response => {\n                if (response) {\n                  return response;\n                }\n                return fetch(event.request).then(response => {\n                  const newResponse = response.clone();\n                  return newResponse\n                    .text()\n                    .then(text => {\n                      currentCacheSsrRequest = event.request\n                      currentCacheSsrOriginHtml = text\n\n                      // Tell client, i want ssrContent!\n                      setTimeout(() => {\n                        self.clients.matchAll().then(clients => {\n                          if (!clients || !clients.length) {\n                            return\n                          }\n                          clients.forEach(client => {\n                            client.postMessage({\n                              type: \"getServerRenderContent\",\n                              pathname: new URL(event.request.url, location).pathname\n                            })\n                          })\n                        })\n                      }, 1000)\n\n                      return response\n                    })\n                    .catch(err => response);\n                });\n              });\n            })\n          );\n        }\n      });\n    ";
    });
});
//# sourceMappingURL=index.js.map