"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.prepareBuild = exports.buildPlugin = exports.buildComponent = exports.buildProject = void 0;
var fs = require("fs-extra");
var HtmlWebpackPlugin = require("html-webpack-plugin");
var path = require("path");
var prettier = require("prettier");
var node_1 = require("../../../node");
var pipe = require("../../../node/pipe");
var analyse_project_1 = require("../../../utils/analyse-project");
var create_entry_1 = require("../../../utils/create-entry");
var exec_1 = require("../../../utils/exec");
var global_state_1 = require("../../../utils/global-state");
var log_1 = require("../../../utils/log");
var npm_finder_1 = require("../../../utils/npm-finder");
var plugins_1 = require("../../../utils/plugins");
var structor_config_1 = require("../../../utils/structor-config");
var webpack_1 = require("../../../utils/webpack");
var generate_static_html_1 = require("./generate-static-html");
var ts_plus_babel_1 = require("../../../utils/ts-plus-babel");
var buildProject = function (opts) {
    if (opts === void 0) { opts = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var result, _a, staticHtmlPaths, stats, tempSwPath, targetSwPath, tempSwContent, targetSwContent;
        var _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _a = !opts.skipEnsureFiles;
                    if (!_a) return [3 /*break*/, 2];
                    return [4 /*yield*/, log_1.spinner('Analyse project', function () { return __awaiter(void 0, void 0, void 0, function () {
                            var analyseInfo, entryPath;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, analyse_project_1.analyseProject()];
                                    case 1:
                                        analyseInfo = _a.sent();
                                        return [4 /*yield*/, create_entry_1.createEntry()];
                                    case 2:
                                        entryPath = _a.sent();
                                        return [2 /*return*/, {
                                                analyseInfo: analyseInfo,
                                                entryPath: entryPath,
                                            }];
                                }
                            });
                        }); })];
                case 1:
                    _a = (_c.sent());
                    _c.label = 2;
                case 2:
                    result = _a;
                    staticHtmlPaths = generate_static_html_1.getStaticHtmlPaths(result === null || result === void 0 ? void 0 : result.analyseInfo);
                    return [4 /*yield*/, webpack_1.runWebpack({
                            mode: 'production',
                            entryPath: __assign((_b = {}, _b[path.basename(node_1.pri.sourceConfig.outFileName, '.js')] = result.entryPath || path.join(global_state_1.globalState.projectRootPath, path.format(structor_config_1.tempJsEntryPath)), _b), node_1.pri.sourceConfig.entries),
                            outFileName: '[name].js',
                            publicPath: opts.publicPath,
                            pipeConfig: function (config) { return __awaiter(void 0, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    if (node_1.pri.sourceConfig.useHtmlTemplate) {
                                        staticHtmlPaths.forEach(function (staticHtmlPath) {
                                            config.plugins.push(new HtmlWebpackPlugin({
                                                title: node_1.pri.sourceConfig.title || global_state_1.globalState.projectRootPath.split(path.sep).pop(),
                                                filename: staticHtmlPath,
                                                template: path.join(__dirname, '../../../../template-project.ejs'),
                                            }));
                                        });
                                    }
                                    return [2 /*return*/, config];
                                });
                            }); },
                        })];
                case 3:
                    stats = _c.sent();
                    tempSwPath = path.join(node_1.pri.projectRootPath, node_1.tempPath.dir, 'static/sw.js');
                    targetSwPath = path.join(global_state_1.globalState.projectRootPath, node_1.pri.sourceConfig.distDir, 'sw.js');
                    if (!fs.existsSync(tempSwPath)) return [3 /*break*/, 5];
                    tempSwContent = fs.readFileSync(tempSwPath).toString();
                    return [4 /*yield*/, pipe.get('serviceWorkerAfterProdBuild', tempSwContent)];
                case 4:
                    targetSwContent = _c.sent();
                    fs.outputFileSync(targetSwPath, prettier.format(targetSwContent, {
                        semi: true,
                        singleQuote: true,
                        parser: 'babylon',
                    }));
                    _c.label = 5;
                case 5: return [4 /*yield*/, copyAssets()];
                case 6:
                    _c.sent();
                    plugins_1.plugin.buildAfterProdBuild.forEach(function (afterProdBuild) {
                        return afterProdBuild(stats);
                    });
                    return [2 /*return*/];
            }
        });
    });
};
exports.buildProject = buildProject;
var buildComponent = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: 
            // FIXME:
            // Do not minimize in cloud build(def envirenment), because commnets will lead to
            // build error in cloud build.
            // const isCloudBuild = yargs.argv.cloud as boolean;
            // Build component
            // TODO: Wait for webpack5
            // ISSUE: https://github.com/webpack/webpack/issues/2933
            // DOC:   https://github.com/webpack/changelog-v5/blob/master/README.md#runtime-modules
            // const stats = await runWebpack({
            //   mode: 'production',
            //   target: 'node',
            //   libraryTarget: 'commonjs2',
            //   entryPath: path.join(pri.sourceRoot, path.format(componentEntry)),
            //   outFileName: pri.sourceConfig.outFileName,
            //   externals: [nodeExternals()],
            //   pipeConfig: async webpackConfig => {
            //     return {
            //       ...webpackConfig,
            //       optimization: {
            //         ...webpackConfig.optimization,
            //         minimize: isCloudBuild
            //       }
            //     };
            //   }
            // });
            // Add bin file to dist dir.
            // const binJsPath = path.join(pri.projectRootPath, pri.sourceConfig.distDir, 'bin.js');
            // fs.outputFileSync(
            //   binJsPath,
            //   `
            //   #!/usr/bin/env node
            //   require("./${path.parse(pri.sourceConfig.outFileName).name}")
            // `.trim()
            // );
            // TODO:
            return [4 /*yield*/, log_1.spinner("build source files", function () { return __awaiter(void 0, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, ts_plus_babel_1.tsPlusBabel(false)];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); })];
            case 1:
                // FIXME:
                // Do not minimize in cloud build(def envirenment), because commnets will lead to
                // build error in cloud build.
                // const isCloudBuild = yargs.argv.cloud as boolean;
                // Build component
                // TODO: Wait for webpack5
                // ISSUE: https://github.com/webpack/webpack/issues/2933
                // DOC:   https://github.com/webpack/changelog-v5/blob/master/README.md#runtime-modules
                // const stats = await runWebpack({
                //   mode: 'production',
                //   target: 'node',
                //   libraryTarget: 'commonjs2',
                //   entryPath: path.join(pri.sourceRoot, path.format(componentEntry)),
                //   outFileName: pri.sourceConfig.outFileName,
                //   externals: [nodeExternals()],
                //   pipeConfig: async webpackConfig => {
                //     return {
                //       ...webpackConfig,
                //       optimization: {
                //         ...webpackConfig.optimization,
                //         minimize: isCloudBuild
                //       }
                //     };
                //   }
                // });
                // Add bin file to dist dir.
                // const binJsPath = path.join(pri.projectRootPath, pri.sourceConfig.distDir, 'bin.js');
                // fs.outputFileSync(
                //   binJsPath,
                //   `
                //   #!/usr/bin/env node
                //   require("./${path.parse(pri.sourceConfig.outFileName).name}")
                // `.trim()
                // );
                // TODO:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.buildComponent = buildComponent;
var buildPlugin = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exports.buildComponent()];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.buildPlugin = buildPlugin;
// Copy assets dir to distDir
function copyAssets() {
    return __awaiter(this, void 0, void 0, function () {
        var sourceAssetsPath, distAssetsPath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sourceAssetsPath = path.join(node_1.pri.sourceRoot, structor_config_1.assetsPath.dir);
                    if (!fs.existsSync(sourceAssetsPath)) {
                        return [2 /*return*/];
                    }
                    distAssetsPath = path.join(node_1.pri.projectRootPath, node_1.pri.sourceConfig.distDir, structor_config_1.assetsPath.dir);
                    if (!fs.existsSync(distAssetsPath)) return [3 /*break*/, 1];
                    log_1.logInfo('assets path exists in distDir, so skip /assets copy.');
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, fs.copy(sourceAssetsPath, distAssetsPath)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function prepareBuild(opts) {
    if (opts === void 0) { opts = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!opts.skipEnsureFiles) return [3 /*break*/, 2];
                    return [4 /*yield*/, log_1.spinner('Clean project.', function () { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: 
                                    // Clean .temp dir
                                    return [4 /*yield*/, exec_1.exec(npm_finder_1.findNearestNodemodulesFile('.bin/rimraf') + " " + node_1.pri.projectRootPath + "/" + node_1.tempPath.dir)];
                                    case 1:
                                        // Clean .temp dir
                                        _a.sent();
                                        return [4 /*yield*/, node_1.pri.project.ensureProjectFiles()];
                                    case 2:
                                        _a.sent();
                                        if (!!opts.skipLint) return [3 /*break*/, 4];
                                        return [4 /*yield*/, node_1.pri.project.lint({
                                                lintAll: true,
                                                needFix: false,
                                                showBreakError: true,
                                            })];
                                    case 3:
                                        _a.sent();
                                        _a.label = 4;
                                    case 4: return [4 /*yield*/, node_1.pri.project.checkProjectFiles()];
                                    case 5:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    });
}
exports.prepareBuild = prepareBuild;
//# sourceMappingURL=build.js.map