"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.prepareBundle = exports.commandBundle = void 0;
var path = require("path");
var portfinder = require("portfinder");
var webpack = require("webpack");
var urlJoin = require("url-join");
var node_1 = require("../../../node");
var log_1 = require("../../../utils/log");
var plugins_1 = require("../../../utils/plugins");
var webpack_1 = require("../../../utils/webpack");
var webpack_dev_server_1 = require("../../../utils/webpack-dev-server");
var dll_1 = require("../../command-dev/plugin/dll");
var global_state_1 = require("../../../utils/global-state");
var webpack_plugin_wrap_content_1 = require("../../../utils/webpack-plugin-wrap-content");
var commandBundle = function (opts) {
    if (opts === void 0) { opts = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var freePort_1;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (node_1.pri.sourceConfig.type !== 'component') {
                        log_1.logFatal("Only component support 'npm run bundle', try 'npm start'!");
                    }
                    if (!!opts.dev) return [3 /*break*/, 2];
                    return [4 /*yield*/, webpack_1.runWebpack({
                            mode: 'production',
                            outFileName: node_1.pri.sourceConfig.bundleFileName,
                            entryPath: path.join(node_1.pri.sourceRoot, path.format(node_1.componentEntry)),
                            publicPath: opts.publicPath,
                            pipeConfig: function (config) { return __awaiter(void 0, void 0, void 0, function () {
                                var newConfig;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            newConfig = __assign({}, config);
                                            newConfig.output.libraryTarget = node_1.pri.sourceConfig.bundleLibraryTarget;
                                            return [4 /*yield*/, plugins_1.plugin.bundleConfigPipes.reduce(function (nextConfig, fn) { return __awaiter(void 0, void 0, void 0, function () {
                                                    var _a;
                                                    return __generator(this, function (_b) {
                                                        switch (_b.label) {
                                                            case 0:
                                                                _a = fn;
                                                                return [4 /*yield*/, nextConfig];
                                                            case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
                                                        }
                                                    });
                                                }); }, Promise.resolve(config))];
                                        case 1:
                                            newConfig = _a.sent();
                                            return [2 /*return*/, newConfig];
                                    }
                                });
                            }); },
                        })];
                case 1:
                    _b.sent();
                    return [3 /*break*/, 5];
                case 2: return [4 /*yield*/, portfinder.getPortPromise({ port: node_1.pri.sourceConfig.devPort })];
                case 3:
                    freePort_1 = _b.sent();
                    return [4 /*yield*/, webpack_1.bundleDlls({ dllOutPath: dll_1.dllOutPath, dllFileName: dll_1.dllFileName, dllMainfestName: dll_1.dllMainfestName })];
                case 4:
                    _b.sent();
                    webpack_dev_server_1.runWebpackDevServer({
                        mode: (_a = opts.mode) !== null && _a !== void 0 ? _a : 'development',
                        outFileName: node_1.pri.sourceConfig.bundleFileName,
                        devServerPort: freePort_1,
                        publicPath: "https://" + node_1.pri.sourceConfig.host + ":" + freePort_1,
                        jsOnly: true,
                        entryPath: path.join(node_1.pri.sourceRoot, path.format(node_1.componentEntry)),
                        pipeConfig: function (config) { return __awaiter(void 0, void 0, void 0, function () {
                            var newConfig, dllHttpPath;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        newConfig = __assign({}, config);
                                        newConfig.output.libraryTarget = node_1.pri.sourceConfig.bundleLibraryTarget;
                                        return [4 /*yield*/, plugins_1.plugin.bundleConfigPipes.reduce(function (nextConfig, fn) { return __awaiter(void 0, void 0, void 0, function () {
                                                var _a;
                                                return __generator(this, function (_b) {
                                                    switch (_b.label) {
                                                        case 0:
                                                            _a = fn;
                                                            return [4 /*yield*/, nextConfig];
                                                        case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
                                                    }
                                                });
                                            }); }, Promise.resolve(config))];
                                    case 1:
                                        newConfig = _a.sent();
                                        // bundle dev 模式支持 dll
                                        config.plugins.push(new webpack.DllReferencePlugin({
                                            context: '.',
                                            // eslint-disable-next-line import/no-dynamic-require,global-require
                                            manifest: require(path.join(dll_1.dllOutPath, dll_1.dllMainfestName)),
                                        }));
                                        dllHttpPath = urlJoin((global_state_1.globalState.sourceConfig.useHttps ? 'https' : 'http') + "://" + node_1.pri.sourceConfig.host + ":" + freePort_1, dll_1.libraryStaticPath);
                                        config.plugins.push(new webpack_plugin_wrap_content_1.WrapContent("\n            var dllScript = document.createElement(\"script\");\n            dllScript.src = \"" + dllHttpPath + "\";\n            dllScript.onload = runEntry;\n            document.body.appendChild(dllScript);\n            function runEntry() {\n          ", '}'));
                                        return [2 /*return*/, newConfig];
                                }
                            });
                        }); },
                    });
                    _b.label = 5;
                case 5: return [2 /*return*/];
            }
        });
    });
};
exports.commandBundle = commandBundle;
var prepareBundle = function (opts) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, node_1.pri.project.ensureProjectFiles()];
            case 1:
                _a.sent();
                if (!(!opts.dev && !opts.skipLint)) return [3 /*break*/, 3];
                return [4 /*yield*/, node_1.pri.project.lint({
                        lintAll: true,
                        needFix: false,
                        showBreakError: true,
                    })];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3: return [4 /*yield*/, node_1.pri.project.checkProjectFiles()];
            case 4:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.prepareBundle = prepareBundle;
//# sourceMappingURL=command-bundle.js.map