"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var layout_1 = require("./pages/layout");
var stores_1 = require("./stores");
var Root = React.memo(function (props) {
    var _a = React.useReducer(stores_1.ApplicationReducer, {
        plugins: [],
        status: null,
        selectedTreeKey: null,
    }), state = _a[0], dispatch = _a[1];
    React.useEffect(function () {
        dispatch({
            type: 'loadUiPlugins',
            plugins: props.plugins,
        });
    }, [props.plugins]);
    return (React.createElement(stores_1.ApplicationContext.Provider, { value: [state, dispatch] },
        React.createElement(layout_1.LayoutComponent, null)));
});
exports.default = (function (plugins) {
    ReactDOM.render(React.createElement(Root, { plugins: plugins }), document.getElementById('root'));
});
//# sourceMappingURL=index.js.map