"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LayoutComponent = void 0;
var React = require("react");
var io = require("socket.io-client");
var main_1 = require("./main/main");
var menu_1 = require("./menu/menu");
var nav_1 = require("./nav");
var struct_component_1 = require("./struct/struct.component");
var stores_1 = require("../stores");
var functional_1 = require("../utils/functional");
var context_1 = require("../utils/context");
var topContainerStyle = { display: 'flex', height: 40, borderBottom: '1px solid #eee' };
var bottomContainerStyle = {
    display: 'flex',
    flexDirection: 'column',
    flexGrow: 1,
    flexBasis: 0,
};
exports.LayoutComponent = React.memo(function () {
    var _a = React.useContext(stores_1.ApplicationContext), state = _a[0], dispatch = _a[1];
    var socket = React.useRef(null);
    React.useEffect(function () {
        socket.current = io("//" + window.location.hostname + ":" + window.serverPort);
        // Get init project status
        socket.current.emit('getProjectStatus');
        socket.current.on('freshProjectStatus', function (data) {
            dispatch({
                type: 'freshProjectStatus',
                status: data,
            });
        });
        socket.current.on('changeFile', function () {
            //
        });
        return function () {
            socket.current.disconnect();
        };
    }, [dispatch]);
    return (React.createElement(context_1.SocketContext.Provider, { value: socket.current },
        React.createElement("div", { style: { display: 'flex', height: '100%' } },
            React.createElement("div", { style: {
                    display: 'flex',
                    flexDirection: 'column',
                    width: 250,
                    borderRight: '1px solid #eee',
                } },
                React.createElement("div", { style: topContainerStyle },
                    React.createElement(nav_1.NavComponent, null)),
                React.createElement("div", { style: bottomContainerStyle },
                    React.createElement(struct_component_1.StructComponent, null))),
            React.createElement("div", { style: {
                    display: 'flex',
                    flexDirection: 'column',
                    flexGrow: 1,
                    flexBasis: 0,
                } },
                React.createElement("div", { style: topContainerStyle },
                    React.createElement(menu_1.MenuComponent, null),
                    functional_1.loadPluginsByPosition(state.plugins, 'menu')),
                React.createElement("div", { style: bottomContainerStyle },
                    React.createElement(main_1.MainComponent, null))))));
});
//# sourceMappingURL=layout.js.map