"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MainComponent = void 0;
var React = require("react");
var config_1 = require("./config");
var layout_1 = require("./layout");
var not_found_1 = require("./not-found");
var project_root_1 = require("./project-root");
var routes_1 = require("./routes");
var stores_1 = require("../../stores");
var functional_1 = require("../../utils/functional");
exports.MainComponent = React.memo(function () {
    var state = React.useContext(stores_1.ApplicationContext)[0];
    switch (state.selectedTreeKey) {
        case 'project-root':
            return React.createElement(project_root_1.ProjectRoot, null);
        case 'routes':
            return React.createElement(routes_1.Routes, null);
        case 'layout':
            return React.createElement(layout_1.Layout, null);
        case '404':
            return React.createElement(not_found_1.NotFound, null);
        case 'config':
            return React.createElement(config_1.Config, null);
        default:
            return functional_1.loadPluginsByPosition(state.plugins, "tree-" + state.selectedTreeKey);
    }
});
//# sourceMappingURL=main.js.map