"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StructComponent = void 0;
var core_1 = require("@material-ui/core");
var React = require("react");
var _ = require("lodash");
var stores_1 = require("../../stores");
var context_1 = require("../../utils/context");
exports.StructComponent = React.memo(function () {
    var socket = React.useContext(context_1.SocketContext);
    var _a = React.useContext(stores_1.ApplicationContext), state = _a[0], dispatch = _a[1];
    if (!state.status) {
        return null;
    }
    var createLayout = function () {
        socket.emit('createLayout');
    };
    var create404 = function () {
        socket.emit('create404');
    };
    var createConfig = function () {
        socket.emit('createConfig');
    };
    var pages = _.get(state.status, 'analyseInfo.projectAnalysePages.pages', []);
    var hasLayout = _.get(state.status, 'analyseInfo.projectAnalyseLayout.hasLayout', false);
    var hasNotFound = _.get(state.status, 'analyseInfo.projectAnalyseNotFound.hasNotFound', false);
    var hasConfig = _.get(state.status, 'analyseInfo.projectAnalyseConfig.hasConfig', false);
    if (state.status === null || state.status === undefined) {
        return null;
    }
    return (React.createElement(core_1.List, { component: "nav" },
        React.createElement(core_1.ListItem, { button: true, onClick: function () {
                dispatch({
                    type: 'setSelectedTreeKey',
                    selectedTreeKey: 'routes',
                });
            } },
            React.createElement(core_1.ListItemText, { primary: "Pages(" + pages.length + ")" })),
        React.createElement(core_1.ListItem, { button: true, onClick: function () {
                dispatch({
                    type: 'setSelectedTreeKey',
                    selectedTreeKey: 'layout',
                });
            } },
            React.createElement(core_1.ListItemText, { primary: 'Layout' }),
            !hasLayout && (React.createElement(core_1.ListItemSecondaryAction, null,
                React.createElement(core_1.Button, { onClick: createLayout }, "Add")))),
        React.createElement(core_1.ListItem, { button: true, onClick: function () {
                dispatch({
                    type: 'setSelectedTreeKey',
                    selectedTreeKey: '404',
                });
            } },
            React.createElement(core_1.ListItemText, { primary: '404' }),
            !hasNotFound && (React.createElement(core_1.ListItemSecondaryAction, null,
                React.createElement(core_1.Button, { onClick: create404 }, "Add")))),
        React.createElement(core_1.ListItem, { button: true, onClick: function () {
                dispatch({
                    type: 'setSelectedTreeKey',
                    selectedTreeKey: 'config',
                });
            } },
            React.createElement(core_1.ListItemText, { primary: 'Config' }),
            !hasConfig && (React.createElement(core_1.ListItemSecondaryAction, null,
                React.createElement(core_1.Button, { onClick: createConfig }, "Add"))))));
});
//# sourceMappingURL=struct.component.js.map