"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApplicationReducer = exports.ApplicationContext = void 0;
var React = require("react");
exports.ApplicationContext = React.createContext(null);
var ApplicationReducer = function (state, action) {
    switch (action.type) {
        case 'loadUiPlugins':
            if (action.plugins) {
                // Run plugins init function.
                action.plugins.forEach(function (plugin) {
                    if (plugin.init) {
                        plugin.init();
                    }
                });
                return __assign(__assign({}, state), { plugins: action.plugins });
            }
            return state;
        case 'setSelectedTreeKey':
            return __assign(__assign({}, state), { selectedTreeKey: action.selectedTreeKey });
        case 'freshProjectStatus':
            return __assign(__assign({}, state), { status: action.status });
        default:
            return state;
    }
};
exports.ApplicationReducer = ApplicationReducer;
//# sourceMappingURL=index.js.map