"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadPluginsByPosition = exports.pipeEvent = void 0;
var React = require("react");
var pipeEvent = function (func) {
    return function (event) {
        return func(event.target.value, event);
    };
};
exports.pipeEvent = pipeEvent;
var loadPluginsByPosition = function (plugins, position, props) {
    return plugins
        .filter(function (plugin) {
        return plugin.position === position;
    })
        .map(function (plugin, index) {
        return React.createElement(plugin.view, __assign({ key: index }, props));
    });
};
exports.loadPluginsByPosition = loadPluginsByPosition;
//# sourceMappingURL=functional.js.map