"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var KoaCors = require("@koa/cors");
var chokidar = require("chokidar");
var fs = require("fs-extra");
var http = require("http");
var https = require("https");
var Koa = require("koa");
var KoaCompress = require("koa-compress");
var KoaMount = require("koa-mount");
var KoaStatic = require("koa-static");
var path = require("path");
var socketIo = require("socket.io");
var zlib = require("zlib");
var analyse_project_1 = require("../../../../../utils/analyse-project");
var constants_1 = require("../../../../../utils/constants");
var create_entry_1 = require("../../../../../utils/create-entry");
var generate_certificate_1 = require("../../../../../utils/generate-certificate");
var global_state_1 = require("../../../../../utils/global-state");
var plugins_1 = require("../../../../../utils/plugins");
var projectManage = require("../../../../../utils/project-manager");
var structor_config_1 = require("../../../../../utils/structor-config");
exports.default = (function (opts) {
    var app = new Koa();
    app.use(KoaCors());
    app.use(KoaCompress({ flush: zlib.Z_SYNC_FLUSH }));
    app.use(KoaMount('/static', KoaStatic(global_state_1.globalState.projectRootPath, structor_config_1.tempPath.dir, { gzip: true })));
    var server = global_state_1.globalState.sourceConfig.useHttps
        ? https.createServer(generate_certificate_1.generateCertificate(), app.callback())
        : http.createServer(app.callback());
    var io = socketIo(server);
    io.on('connection', function (socket) { return __awaiter(void 0, void 0, void 0, function () {
        function socketListen(name, fn) {
            socket.on(name, function (data, callback) {
                Promise.resolve(fn(data))
                    .then(function (res) {
                    return callback && callback({ success: true, data: res });
                })
                    .catch(function (err) {
                    return callback && callback({ success: false, data: err.toString() });
                });
            });
        }
        return __generator(this, function (_a) {
            socketListen('addPage', function (data) { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, projectManage.addPage(data)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            socketListen('createLayout', function () { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, projectManage.createLayout()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            socketListen('create404', function () { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, projectManage.create404()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            socketListen('createConfig', function () { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, projectManage.createConfig()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            socketListen('getProjectStatus', function () { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, fresh()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            // Load plugin's services
            plugins_1.plugin.devServices.socketListeners.forEach(function (socketListener) {
                socketListen(socketListener.name, socketListener.callback);
            });
            return [2 /*return*/];
        });
    }); });
    // Watch project file's change
    chokidar
        .watch(path.join(global_state_1.globalState.sourceRoot, '/**'), { ignored: /(^|[/\\])\../, ignoreInitial: true })
        .on('add', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fresh()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); })
        .on('unlink', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fresh()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); })
        .on('unlinkDir', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fresh()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); })
        .on('change', function (filePath) { return __awaiter(void 0, void 0, void 0, function () {
        var relativePath, pathInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    relativePath = path.relative(global_state_1.globalState.sourceRoot, filePath);
                    pathInfo = path.parse(filePath);
                    try {
                        io.emit('changeFile', { path: filePath, fileContent: fs.readFileSync(filePath).toString() });
                    }
                    catch (error) {
                        //
                    }
                    if (!(relativePath === constants_1.CONFIG_FILE)) return [3 /*break*/, 2];
                    global_state_1.freshProjectConfig();
                    return [4 /*yield*/, fresh()];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 2:
                    if (!(relativePath.startsWith('src') && pathInfo.ext === '.md')) return [3 /*break*/, 4];
                    return [4 /*yield*/, fresh()];
                case 3:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 4:
                    if (!(relativePath.startsWith('mocks') && pathInfo.ext === '.ts')) return [3 /*break*/, 6];
                    return [4 /*yield*/, fresh()];
                case 5:
                    _a.sent();
                    _a.label = 6;
                case 6: return [2 /*return*/];
            }
        });
    }); });
    function fresh() {
        return __awaiter(this, void 0, void 0, function () {
            var projectStatus;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, getProjectStatus()];
                    case 1:
                        projectStatus = _a.sent();
                        return [4 /*yield*/, create_entry_1.createEntry()];
                    case 2:
                        _a.sent();
                        io.emit('freshProjectStatus', projectStatus);
                        return [2 /*return*/];
                }
            });
        });
    }
    function getProjectStatus() {
        return __awaiter(this, void 0, void 0, function () {
            var analyseInfo;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, analyse_project_1.analyseProject()];
                    case 1:
                        analyseInfo = _a.sent();
                        return [2 /*return*/, { projectConfig: global_state_1.globalState.sourceConfig, analyseInfo: analyseInfo }];
                }
            });
        });
    }
    // Socket
    server.listen(opts.serverPort);
});
//# sourceMappingURL=index.js.map