"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.projectDev = void 0;
var fs = require("fs-extra");
var path = require("path");
var portfinder = require("portfinder");
var prettier = require("prettier");
var urlJoin = require("url-join");
var webpack = require("webpack");
var node_1 = require("../../../node");
var analyse_project_1 = require("../../../utils/analyse-project");
var create_entry_1 = require("../../../utils/create-entry");
var global_state_1 = require("../../../utils/global-state");
var log_1 = require("../../../utils/log");
var webpack_plugin_wrap_content_1 = require("../../../utils/webpack-plugin-wrap-content");
var plugins_1 = require("../../../utils/plugins");
var prettier_config_1 = require("../../../utils/prettier-config");
var projectState = require("../../../utils/project-state");
var structor_config_1 = require("../../../utils/structor-config");
var webpack_1 = require("../../../utils/webpack");
var webpack_dev_server_1 = require("../../../utils/webpack-dev-server");
var client_server_1 = require("./dashboard/server/client-server");
var index_1 = require("./dashboard/server/index");
var dll_1 = require("./dll");
var dashboardBundleFileName = 'main';
var projectDev = function (options) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!(options && options.debugDashboard)) return [3 /*break*/, 2];
                return [4 /*yield*/, debugDashboard()];
            case 1:
                _a.sent();
                return [3 /*break*/, 4];
            case 2: return [4 /*yield*/, debugProject(options)];
            case 3:
                _a.sent();
                _a.label = 4;
            case 4: return [2 /*return*/];
        }
    });
}); };
exports.projectDev = projectDev;
function debugDashboard() {
    return __awaiter(this, void 0, void 0, function () {
        var analyseInfo, freePort, dashboardServerPort, dashboardEntryFilePath;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, log_1.spinner('Analyse project', function () { return __awaiter(_this, void 0, void 0, function () {
                        var scopeAnalyseInfo;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, analyse_project_1.analyseProject()];
                                case 1:
                                    scopeAnalyseInfo = _a.sent();
                                    return [4 /*yield*/, create_entry_1.createEntry()];
                                case 2:
                                    _a.sent();
                                    return [2 /*return*/, scopeAnalyseInfo];
                            }
                        });
                    }); })];
                case 1:
                    analyseInfo = _a.sent();
                    return [4 /*yield*/, portfinder.getPortPromise()];
                case 2:
                    freePort = _a.sent();
                    return [4 /*yield*/, portfinder.getPortPromise({ port: freePort + 1 })];
                case 3:
                    dashboardServerPort = _a.sent();
                    // Start dashboard server
                    index_1.default({ serverPort: dashboardServerPort, analyseInfo: analyseInfo });
                    dashboardEntryFilePath = createDashboardEntry();
                    // Serve dashboard
                    return [4 /*yield*/, webpack_dev_server_1.runWebpackDevServer({
                            mode: 'development',
                            autoOpenBrowser: true,
                            hot: node_1.pri.sourceConfig.hotReload,
                            publicPath: '/static/',
                            entryPath: dashboardEntryFilePath,
                            devServerPort: freePort,
                            outFileName: 'main.[hash].js',
                            htmlTemplatePath: path.join(__dirname, '../../../../template-dashboard.ejs'),
                            htmlTemplateArgs: {
                                dashboardServerPort: dashboardServerPort,
                            },
                        })];
                case 4:
                    // Serve dashboard
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function debugProject(options) {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var freePort, _b, dashboardServerPort, dashboardClientPort, pipeConfig, analyseInfo, dashboardDistDir, dashboardEntryFilePath, status_1, stdoutOfAnyType;
        var _c;
        var _this = this;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _b = node_1.pri.sourceConfig.devPort;
                    if (_b) return [3 /*break*/, 2];
                    return [4 /*yield*/, portfinder.getPortPromise()];
                case 1:
                    _b = (_d.sent());
                    _d.label = 2;
                case 2:
                    freePort = _b;
                    return [4 /*yield*/, portfinder.getPortPromise({ port: freePort + 1 })];
                case 3:
                    dashboardServerPort = _d.sent();
                    return [4 /*yield*/, portfinder.getPortPromise({ port: freePort + 2 })];
                case 4:
                    dashboardClientPort = _d.sent();
                    pipeConfig = function (config) { return __awaiter(_this, void 0, void 0, function () {
                        var dllHttpPath;
                        return __generator(this, function (_a) {
                            if (node_1.pri.sourceConfig.disableDllWhenDev || node_1.pri.sourceConfig.disableDllWrapWhenDev) {
                                return [2 /*return*/, config];
                            }
                            dllHttpPath = urlJoin((global_state_1.globalState.sourceConfig.useHttps ? 'https' : 'http') + "://" + node_1.pri.sourceConfig.host + ":" + freePort, dll_1.libraryStaticPath);
                            config.plugins.push(new webpack_plugin_wrap_content_1.WrapContent("\n        var dllScript = document.createElement(\"script\");\n        dllScript.src = \"" + dllHttpPath + "\";\n        dllScript.onload = runEntry;\n        document.body.appendChild(dllScript);\n        function runEntry() {\n      ", '}'));
                            return [2 /*return*/, config];
                        });
                    }); };
                    debugProjectPrepare(dashboardClientPort);
                    return [4 /*yield*/, node_1.pri.project.ensureProjectFiles()];
                case 5:
                    _d.sent();
                    return [4 /*yield*/, node_1.pri.project.checkProjectFiles()];
                case 6:
                    _d.sent();
                    return [4 /*yield*/, log_1.spinner('Analyse project', function () { return __awaiter(_this, void 0, void 0, function () {
                            var scopeAnalyseInfo;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, analyse_project_1.analyseProject()];
                                    case 1:
                                        scopeAnalyseInfo = _a.sent();
                                        return [4 /*yield*/, create_entry_1.createEntry()];
                                    case 2:
                                        _a.sent();
                                        return [2 /*return*/, scopeAnalyseInfo];
                                }
                            });
                        }); })];
                case 7:
                    analyseInfo = _d.sent();
                    if (!!node_1.pri.sourceConfig.disableDllWhenDev) return [3 /*break*/, 9];
                    return [4 /*yield*/, webpack_1.bundleDlls({ dllOutPath: dll_1.dllOutPath, dllFileName: dll_1.dllFileName, dllMainfestName: dll_1.dllMainfestName })];
                case 8:
                    _d.sent();
                    _d.label = 9;
                case 9:
                    if (global_state_1.globalState.sourceConfig.useHttps) {
                        log_1.logInfo('you should set chrome://flags/#allow-insecure-localhost, to trust local certificate.');
                    }
                    if (!!node_1.pri.sourceConfig.disableDashboard) return [3 /*break*/, 12];
                    dashboardDistDir = path.join(node_1.pri.projectRootPath, structor_config_1.tempPath.dir, 'static/dashboard-bundle');
                    if (!!fs.existsSync(path.join(dashboardDistDir, dashboardBundleFileName + ".js"))) return [3 /*break*/, 11];
                    dashboardEntryFilePath = createDashboardEntry();
                    return [4 /*yield*/, webpack_1.runWebpack({
                            mode: 'production',
                            publicPath: '/bundle/',
                            entryPath: dashboardEntryFilePath,
                            distDir: dashboardDistDir,
                            outFileName: 'main.[hash].js',
                            pipeConfig: pipeConfig,
                        })];
                case 10:
                    status_1 = _d.sent();
                    projectState.set('dashboardHash', status_1.hash);
                    _d.label = 11;
                case 11:
                    stdoutOfAnyType = process.stdout;
                    try {
                        stdoutOfAnyType.clearLine(0);
                    }
                    catch (_e) {
                        //
                    }
                    log_1.logInfo('\nStart dev server.\n');
                    // Start dashboard server
                    index_1.default({ serverPort: dashboardServerPort, analyseInfo: analyseInfo });
                    // Start dashboard client production server
                    client_server_1.default({
                        serverPort: dashboardServerPort,
                        clientPort: dashboardClientPort,
                        staticRootPath: path.join(node_1.pri.projectRootPath, structor_config_1.tempPath.dir, 'static'),
                        hash: projectState.get('dashboardHash'),
                    });
                    _d.label = 12;
                case 12: 
                // Serve project
                return [4 /*yield*/, webpack_dev_server_1.runWebpackDevServer(__assign(__assign({ mode: (_a = options === null || options === void 0 ? void 0 : options.mode) !== null && _a !== void 0 ? _a : 'development', autoOpenBrowser: true, hot: node_1.pri.sourceConfig.hotReload, publicPath: global_state_1.globalState.sourceConfig.publicPath, entryPath: __assign((_c = {}, _c[path.basename(node_1.pri.sourceConfig.outFileName, '.js')] = path.join(global_state_1.globalState.projectRootPath, path.format(structor_config_1.tempJsEntryPath)), _c), node_1.pri.sourceConfig.entries), outFileName: '[name].js', devServerPort: freePort }, (node_1.pri.sourceConfig.useHtmlTemplate && {
                        htmlTemplatePath: path.join(__dirname, '../../../../template-project.ejs'),
                        htmlTemplateArgs: {
                            dashboardServerPort: dashboardServerPort,
                        },
                    })), { pipeConfig: pipeConfig }))];
                case 13:
                    // Serve project
                    _d.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function debugProjectPrepare(dashboardClientPort) {
    node_1.pri.project.onCreateEntry(function (__, entry) {
        if (node_1.pri.isDevelopment) {
            entry.pipeEnvironmentBody(function (envText) {
                return "\n            " + envText + "\n            priStore.globalState = " + JSON.stringify(global_state_1.globalState) + "\n          ";
            });
            // Jump page from iframe dashboard event.
            entry.pipeAppClassDidMount(function (entryDidMount) {
                return "\n          " + entryDidMount + "\n          window.addEventListener(\"message\", event => {\n            const data = event.data\n            switch(data.type) {\n              case \"changeRoute\":\n                customHistory.push(data.path)\n                break\n              default:\n            }\n          }, false)\n        ";
            });
            // React hot loader
            entry.pipeAppHeader(function (header) {
                return "\n        " + header + "\n        import { hot } from \"react-hot-loader/root\"\n        import { setConfig } from \"react-hot-loader\"\n      ";
            });
            entry.pipeAppBody(function (str) {
                return "\n        setConfig({\n          ignoreSFC: true, // RHL will be __completely__ disabled for SFC\n          pureRender: true, // RHL will not change render method\n        })\n        " + str + "\n      ";
            });
            entry.pipe.set('appExportName', function () {
                return 'hot(App)';
            });
            // Load webui iframe
            if (!node_1.pri.sourceConfig.disableDashboard) {
                entry.pipeEntryRender(function (str) {
                    return "\n          " + str + "\n          const webUICss = `\n            #pri-help-button {\n              position: fixed;\n              display: flex;\n              justify-content: center;\n              align-items: center;\n              width: 140px;\n              height: 30px;\n              transform: rotate(90deg);\n              font-size: 14px;\n              right: -55px;\n              top: calc(50% - 15px);\n              border: 1px solid #ddd;\n              border-top: none;\n              border-bottom-left-radius: 5px;\n              border-bottom-right-radius: 5px;\n              color: #666;\n              z-index: 10001;\n              cursor: pointer;\n              transition: all .2s;\n              background-color: white;\n              user-select: none;\n            }\n\n            #pri-help-button.active {\n              right: 744px !important;\n            }\n\n            #pri-help-button:hover {\n              color: black;\n            }\n\n            #pri-help-iframe {\n              position: fixed;\n              right: -810px;\n              z-index: 10000;\n              background-color: white;\n              width: 800px;\n              top: 0;\n              height: 100%;\n              border: 0;\n              outline: 0;\n              box-shadow: -1px 0 1px #d4d4d4;\n              transition: right .2s;\n            }\n\n            #pri-help-iframe.active {\n              right: 0 !important;\n            }\n          `\n          const webUIStyle = document.createElement('style')\n\n          webUIStyle.type = \"text/css\"\n          if ((webUIStyle as any).styleSheet){\n            (webUIStyle as any).styleSheet.cssText = webUICss\n          } else {\n            webUIStyle.appendChild(document.createTextNode(webUICss))\n          }\n\n          document.head.appendChild(webUIStyle)\n\n          // Add dashboard iframe\n          const dashboardIframe = document.createElement(\"iframe\")\n          dashboardIframe.id = \"pri-help-iframe\"\n          dashboardIframe.src = \"//" + node_1.pri.sourceConfig.host + ":" + dashboardClientPort + "\"\n          document.body.appendChild(dashboardIframe)\n\n          // Add dashboard button\n          const dashboardButton = document.createElement(\"div\")\n          dashboardButton.id = \"pri-help-button\"\n          dashboardButton.innerText = \"Toggle dashboard\"\n          dashboardButton.onclick = () => {\n            const activeClassName = \"active\"\n            const isShow = dashboardIframe.classList.contains(activeClassName)\n\n            if (isShow) {\n              dashboardIframe.classList.remove(activeClassName)\n              dashboardButton.classList.remove(activeClassName)\n            } else {\n              dashboardIframe.classList.add(activeClassName)\n              dashboardButton.classList.add(activeClassName)\n            }\n          }\n          document.body.appendChild(dashboardButton)\n        ";
                });
            }
        }
    });
    if (node_1.pri.majorCommand === 'dev') {
        node_1.pri.build.pipeConfig(function (config) {
            if (!node_1.pri.isDevelopment) {
                return config;
            }
            if (node_1.pri.sourceConfig.disableDllWhenDev) {
                return config;
            }
            config.plugins.push(new webpack.DllReferencePlugin({
                context: '.',
                // eslint-disable-next-line import/no-dynamic-require,global-require
                manifest: require(path.join(dll_1.dllOutPath, dll_1.dllMainfestName)),
            }));
            return config;
        });
    }
}
function createDashboardEntry() {
    var dashboardEntryMainPath = path.join(__dirname, 'dashboard/client/index');
    var dashboardEntryFilePath = path.join(node_1.pri.projectRootPath, structor_config_1.tempPath.dir, 'dashboard/main.tsx');
    var webUiEntries = [];
    Array.from(plugins_1.getPluginsByOrder()).forEach(function () {
        // try {
        //   const packageJsonPath = require.resolve(path.join(plugin.pathOrModuleName, 'package.json'), {
        //     paths: [__dirname, globalState.projectRootPath]
        //   });
        //   const packageJson = fs.readJsonSync(packageJsonPath, { throws: false });
        //   const webEntry = _.get(packageJson, 'pri.web-entry', null);
        //   if (webEntry) {
        //     const webEntrys: string[] = typeof webEntry === 'string' ? [webEntry] : webEntry;
        //     webEntrys.forEach(eachWebEntry => {
        //       const webEntryAbsolutePath = path.resolve(path.parse(packageJsonPath).dir, eachWebEntry);
        //       const parsedPath = path.parse(webEntryAbsolutePath);
        //       const importPath = path.join(parsedPath.dir, parsedPath.name);
        //       webUiEntries.push(`
        //       const plugin${webUiEntries.length} = require("${importPath}").default`);
        //     });
        //   }
        // } catch (error) {
        //   //
        // }
    });
    fs.outputFileSync(dashboardEntryFilePath, prettier.format("\n      const dashboard = require(\"" + dashboardEntryMainPath + "\").default\n\n      " + (webUiEntries.length > 0
        ? "\n          " + webUiEntries.join('\n') + "\n          dashboard([" + webUiEntries
            .map(function (each, index) {
            return "plugin" + index;
        })
            .join(',') + "])\n        "
        : "\n          dashboard()\n        ") + "\n    ", __assign(__assign({}, prettier_config_1.prettierConfig), { parser: 'typescript' })));
    return dashboardEntryFilePath;
}
//# sourceMappingURL=project-dev.js.map