"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.devDocs = void 0;
var chokidar = require("chokidar");
var fs = require("fs-extra");
var path = require("path");
var portfinder = require("portfinder");
var prettier = require("prettier");
var node_1 = require("../../../node");
var analyse_project_1 = require("../../../utils/analyse-project");
var log_1 = require("../../../utils/log");
var prettier_config_1 = require("../../../utils/prettier-config");
var structor_config_1 = require("../../../utils/structor-config");
var webpack_dev_server_1 = require("../../../utils/webpack-dev-server");
function devDocs() {
    return __awaiter(this, void 0, void 0, function () {
        var currentSelectedSourceType, targetRoot, customHTML, customIndex, isExistCustomIndex, docsEntryPath, freePort;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    currentSelectedSourceType = node_1.pri.selectedSourceType;
                    targetRoot = currentSelectedSourceType === 'root'
                        ? node_1.pri.projectRootPath
                        : node_1.pri.packages.find(function (p) { return p.name === currentSelectedSourceType; }).rootPath;
                    customHTML = path.join(targetRoot, structor_config_1.docsPath.dir, 'index.ejs');
                    customIndex = path.join(targetRoot, structor_config_1.docsPath.dir, 'index.tsx');
                    isExistCustomIndex = fs.existsSync(customIndex);
                    docsEntryPath = isExistCustomIndex
                        ? customIndex
                        : path.join(node_1.pri.projectRootPath, structor_config_1.tempPath.dir, 'docs-entry.tsx');
                    prepare(docsEntryPath, !isExistCustomIndex);
                    return [4 /*yield*/, node_1.pri.project.ensureProjectFiles()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, node_1.pri.project.checkProjectFiles()];
                case 2:
                    _a.sent();
                    // Anaylse project for init.
                    return [4 /*yield*/, log_1.spinner('Analyse project', function () { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                return [2 /*return*/, analyse_project_1.analyseProject()];
                            });
                        }); })];
                case 3:
                    // Anaylse project for init.
                    _a.sent();
                    chokidar
                        .watch(path.join(node_1.pri.sourceRoot, structor_config_1.docsPath.dir, '/**'), {
                        ignored: /(^|[/\\])\../,
                        ignoreInitial: true,
                    })
                        .on('add', function () { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, analyse_project_1.analyseProject()];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); })
                        .on('unlink', function () { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, analyse_project_1.analyseProject()];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); })
                        .on('unlinkDir', function () { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, analyse_project_1.analyseProject()];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    return [4 /*yield*/, portfinder.getPortPromise()];
                case 4:
                    freePort = _a.sent();
                    return [4 /*yield*/, webpack_dev_server_1.runWebpackDevServer({
                            mode: 'development',
                            publicPath: (node_1.pri.sourceConfig.useHttps ? 'https' : 'http') + "://" + node_1.pri.sourceConfig.host + ":" + freePort,
                            autoOpenBrowser: true,
                            hot: node_1.pri.sourceConfig.hotReload,
                            devUrl: node_1.pri.sourceConfig.devUrl || node_1.pri.sourceConfig.host,
                            entryPath: docsEntryPath,
                            devServerPort: freePort,
                            htmlTemplatePath: fs.existsSync(customHTML) ? customHTML : path.join(__dirname, '../../../../template-project.ejs'),
                            htmlTemplateArgs: {
                                appendHead: "\n        <style>\n          html, body {\n            padding: 0;\n            margin: 0;\n          }\n        </style>\n      ",
                                appendBody: "\n          ",
                            },
                        })];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.devDocs = devDocs;
function prepare(docsEntryPath, generateEntry) {
    node_1.pri.build.pipeSassLoaderOptions(function (options) {
        return __assign(__assign({}, options), { sourceMap: true });
    });
    node_1.pri.build.pipeLessLoaderOptions(function (options) {
        return __assign(__assign({}, options), { sourceMap: true });
    });
    node_1.pri.build.pipeCssLoaderOptions(function (options) {
        return __assign(__assign({}, options), { sourceMap: true });
    });
    node_1.pri.build.pipeJsInclude(function (paths) {
        paths.push(path.join(node_1.pri.sourceRoot, structor_config_1.docsPath.dir));
        return paths;
    });
    node_1.pri.build.pipeLessInclude(function (paths) {
        paths.push(path.join(node_1.pri.sourceRoot, structor_config_1.docsPath.dir));
        return paths;
    });
    node_1.pri.build.pipeSassInclude(function (paths) {
        paths.push(path.join(node_1.pri.sourceRoot, structor_config_1.docsPath.dir));
        return paths;
    });
    if (generateEntry) {
        node_1.pri.project.onAnalyseProject(function (files) {
            var result = {
                projectAnalyseDocs: {
                    docs: files
                        .filter(function (file) {
                        if (!path.format(file).startsWith(path.join(node_1.pri.sourceRoot, structor_config_1.docsPath.dir))) {
                            return false;
                        }
                        if (file.isDir) {
                            return false;
                        }
                        if (['.tsx'].indexOf(file.ext) === -1) {
                            return false;
                        }
                        return true;
                    })
                        .map(function (file) {
                        return { file: file };
                    }),
                },
            };
            // Create entry file for docs
            var docList = [];
            var docsEntryContent = prettier.format("\n        import * as React from \"react\"\n        import * as ReactDOM from 'react-dom'\n        import { hot } from \"react-hot-loader/root\"\n        import { setConfig } from \"react-hot-loader\"\n  \n        setConfig({\n          ignoreSFC: true, // RHL will be __completely__ disabled for SFC\n          pureRender: true, // RHL will not change render method\n        })\n        \n        const DocsWrapper = require(\"" + path.join(__dirname, 'docs-wrapper') + "\").default\n  \n        " + (function () {
                var docFiles = result.projectAnalyseDocs.docs;
                return docFiles
                    .map(function (docFile, index) {
                    var docFilePathWithoutPrefix = path.join(docFile.file.dir, docFile.file.name);
                    var docImportPath = path.relative(path.parse(docsEntryPath).dir, docFilePathWithoutPrefix);
                    var fileName = "Doc" + index;
                    docList.push("\n              {\n                name: \"" + docFile.file.name + "\",\n                element: " + fileName + ",\n                text: " + fileName + "Text\n              }\n            ");
                    return "\n              import * as " + fileName + " from '" + docImportPath + "'\n              const " + fileName + "Text = require('-!raw-loader!" + docImportPath + "')\n            ";
                })
                    .join('\n');
            })() + "\n  \n        const DocComponents: any[] = [" + docList.join(',') + "]\n        window.DocComponents = DocComponents;\n  \n        const Docs = () => <DocsWrapper docs={DocComponents}/>\n  \n        const ROOT_ID = '" + node_1.pri.sourceConfig.projectRootId + "';\n  \n        setConfig({ pureSFC: true, pureRender: true })\n  \n        const HotDocs = hot(Docs);\n  \n        // Create entry div if not exist.\n        if (!document.getElementById(ROOT_ID)) {\n          const rootDiv = document.createElement('div');\n          rootDiv.id = ROOT_ID;\n          document.body.appendChild(rootDiv);\n        }\n  \n        ReactDOM.render(<HotDocs />, document.getElementById(ROOT_ID));\n        ", __assign(__assign({}, prettier_config_1.prettierConfig), { parser: 'typescript' }));
            fs.outputFileSync(docsEntryPath, docsEntryContent);
            return result;
        });
    }
}
//# sourceMappingURL=dev-docs.js.map