"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Props = void 0;
var React = require("react");
var react_router_dom_1 = require("react-router-dom");
var error_boundary_1 = require("./error-boundary");
var Props = /** @class */ (function () {
    function Props() {
        this.docs = [];
    }
    return Props;
}());
exports.Props = Props;
var NotFound = function () { return React.createElement("div", null, "Not found"); };
var Docs = React.memo(function (_a) {
    var _b = _a.docs, docs = _b === void 0 ? [] : _b, location = _a.location;
    var pathname = location.pathname;
    if (docs.length === 0) {
        return null;
    }
    var firstDoc = docs[0];
    return (React.createElement("div", { style: {
            backgroundColor: 'whitesmoke',
            width: '100vw',
            height: '100vh',
            display: 'flex',
            boxSizing: 'border-box',
        } },
        docs.length > 1 && (React.createElement("div", { style: {
                display: 'flex',
                flexDirection: 'column',
                width: 200,
                minWidth: 200,
                borderRight: '1px solid #eee',
                boxSizing: 'border-box',
                overflowY: 'auto',
            } }, docs.map(function (doc) { return (React.createElement(react_router_dom_1.Link, { to: "/" + doc.name, style: {
                display: 'flex',
                alignItems: 'center',
                minHeight: 30,
                cursor: 'pointer',
                paddingLeft: 10,
                boxSizing: 'border-box',
                backgroundColor: pathname === "/" + doc.name ? 'white' : null,
                fontSize: 14,
                color: '#333',
                borderBottom: '1px solid #eee',
            }, key: doc.name }, doc.name)); }))),
        React.createElement("div", { style: {
                display: 'flex',
                flexDirection: 'column',
                flexGrow: 1,
                boxSizing: 'border-box',
            } },
            React.createElement("div", { style: {
                    width: '100%',
                    backgroundColor: 'white',
                    flexGrow: 1,
                    flexBasis: 0,
                    overflowY: 'auto',
                    overflowX: 'hidden',
                    boxSizing: 'border-box',
                } },
                React.createElement(react_router_dom_1.Switch, null,
                    React.createElement(react_router_dom_1.Route, { exact: true, path: "/" },
                        React.createElement(react_router_dom_1.Redirect, { to: "/" + firstDoc.name })),
                    docs.map(function (doc) { return (React.createElement(react_router_dom_1.Route, { path: "/" + doc.name, key: doc.name, component: error_boundary_1.withErrorBoundary(doc.element.default) })); }),
                    React.createElement(react_router_dom_1.Route, { component: NotFound }))))));
});
var DocsWithRouter = react_router_dom_1.withRouter(Docs);
var App = function (props) {
    return (
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore
    React.createElement(react_router_dom_1.HashRouter, null,
        React.createElement(DocsWithRouter, __assign({}, props))));
};
exports.default = App;
//# sourceMappingURL=index.js.map