"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runInit = void 0;
var colors = require("colors");
var fs = require("fs-extra");
var inquirer = require("inquirer");
var path = require("path");
var node_1 = require("../../../node");
var global_state_1 = require("../../../utils/global-state");
var log_1 = require("../../../utils/log");
var plugins_1 = require("../../../utils/plugins");
var text_1 = require("../../../utils/text");
var white_file_helper_1 = require("../../../utils/white-file-helper");
var runInit = function () { return __awaiter(void 0, void 0, void 0, function () {
    var _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (!fs.existsSync(path.join(node_1.pri.projectRootPath, 'package.json'))) {
                    log_1.logFatal('No package.json! please run "npm init" first.');
                }
                if (!!global_state_1.globalState.sourceConfig.type) return [3 /*break*/, 2];
                _a = global_state_1.globalState.sourceConfig;
                return [4 /*yield*/, selectProjectType('Choose project type')];
            case 1:
                _a.type = _c.sent();
                if (global_state_1.globalState.selectedSourceType === 'root') {
                    global_state_1.globalState.projectConfig.type = global_state_1.globalState.sourceConfig.type;
                }
                _c.label = 2;
            case 2:
                if (!!global_state_1.globalState.sourceConfig.type) return [3 /*break*/, 4];
                _b = global_state_1.globalState.sourceConfig;
                return [4 /*yield*/, selectProjectType('Choose source type')];
            case 3:
                _b.type = _c.sent();
                _c.label = 4;
            case 4:
                // Add white files by projectType because we might change project type above.
                white_file_helper_1.addWhiteFilesByProjectType();
                return [4 /*yield*/, node_1.pri.project.ensureProjectFiles()];
            case 5:
                _c.sent();
                return [4 /*yield*/, node_1.pri.project.checkProjectFiles()];
            case 6:
                _c.sent();
                log_1.logText("\n Success init your " + global_state_1.globalState.sourceConfig.type + ", you can run serval commands:\n");
                switch (global_state_1.globalState.sourceConfig.type) {
                    case 'project':
                    case 'plugin':
                        log_1.logText(colors.blue('  npm start'));
                        log_1.logText("  " + text_1.default.commander.dev.description + "\n");
                        break;
                    case 'component':
                        log_1.logText(colors.blue('  npm run docs'));
                        log_1.logText("  " + text_1.default.commander.docs.description + "\n");
                        break;
                    default:
                }
                log_1.logText(colors.blue('  npm run build'));
                log_1.logText("  " + text_1.default.commander.build.description + "\n");
                switch (global_state_1.globalState.sourceConfig.type) {
                    case 'project':
                        log_1.logText(colors.blue('  npm run preview'));
                        log_1.logText("  " + text_1.default.commander.dev.description + "\n");
                        break;
                    case 'component':
                    case 'plugin':
                        log_1.logText(colors.blue('  npm publish'));
                        log_1.logText('  Publish this component to npm package.\n');
                        break;
                    default:
                }
                log_1.logText(colors.blue('  npm test'));
                log_1.logText('  Run tests.\n');
                log_1.logText('\n  Happy hacking!');
                return [2 /*return*/];
        }
    });
}); };
exports.runInit = runInit;
function selectProjectType(message) {
    return __awaiter(this, void 0, void 0, function () {
        var userSelectType, inquirerInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    userSelectType = null;
                    if (!!plugins_1.plugin.initType) return [3 /*break*/, 2];
                    return [4 /*yield*/, inquirer.prompt([
                            {
                                message: message,
                                name: 'projectType',
                                type: 'list',
                                choices: ['Project', 'Component', 'Pri Plugin'],
                            },
                        ])];
                case 1:
                    inquirerInfo = _a.sent();
                    switch (inquirerInfo.projectType) {
                        case 'Project':
                            userSelectType = 'project';
                            break;
                        case 'Component':
                            userSelectType = 'component';
                            break;
                        case 'Pri Plugin':
                            userSelectType = 'plugin';
                            break;
                        default:
                    }
                    return [3 /*break*/, 3];
                case 2:
                    userSelectType = plugins_1.plugin.initType;
                    _a.label = 3;
                case 3: return [2 /*return*/, userSelectType];
            }
        });
    });
}
//# sourceMappingURL=run-init.js.map