"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommandPreview = void 0;
var http = require("http");
var https = require("https");
var Koa = require("koa");
var KoaCompress = require("koa-compress");
var KoaMount = require("koa-mount");
var KoaStatic = require("koa-static");
var open = require("open");
var path = require("path");
var portfinder = require("portfinder");
var url = require("url");
var urlJoin = require("url-join");
var zlib = require("zlib");
var node_1 = require("../../../node");
var functional_1 = require("../../../utils/functional");
var generate_certificate_1 = require("../../../utils/generate-certificate");
var log_1 = require("../../../utils/log");
var build_1 = require("../../command-build/plugin/build");
var CommandPreview = function () { return __awaiter(void 0, void 0, void 0, function () {
    var app, distDir, freePort, _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                app = new Koa();
                distDir = path.join(node_1.pri.projectRootPath, node_1.pri.sourceConfig.distDir);
                return [4 /*yield*/, build_1.buildProject()];
            case 1:
                _b.sent();
                _a = node_1.pri.sourceConfig.devPort;
                if (_a) return [3 /*break*/, 3];
                return [4 /*yield*/, portfinder.getPortPromise()];
            case 2:
                _a = (_b.sent());
                _b.label = 3;
            case 3:
                freePort = _a;
                app.use(KoaCompress({ flush: zlib.Z_SYNC_FLUSH }));
                app.use(KoaMount(url.parse(node_1.pri.sourceConfig.publicPath).pathname, KoaStatic(distDir, {
                    gzip: true,
                    setHeaders: function (res) {
                        res.setHeader('Access-Control-Allow-Origin', '*');
                    },
                })));
                if (!node_1.pri.sourceConfig.useHttps) return [3 /*break*/, 5];
                return [4 /*yield*/, log_1.spinner('Create https server', function () { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            return [2 /*return*/, https.createServer(generate_certificate_1.generateCertificate(), app.callback()).listen(freePort)];
                        });
                    }); })];
            case 4:
                _b.sent();
                return [3 /*break*/, 7];
            case 5: return [4 /*yield*/, log_1.spinner('Create http server', function () { return __awaiter(void 0, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        return [2 /*return*/, http.createServer(app.callback()).listen(freePort)];
                    });
                }); })];
            case 6:
                _b.sent();
                _b.label = 7;
            case 7:
                if (node_1.pri.sourceConfig.devUrl) {
                    open(node_1.pri.sourceConfig.devUrl);
                }
                else {
                    open(functional_1.ensureEndWithSlash(urlJoin((node_1.pri.sourceConfig.useHttps ? 'https' : 'http') + "://" + node_1.pri.sourceConfig.host + ":" + freePort, node_1.pri.sourceConfig.baseHref)));
                }
                return [2 /*return*/];
        }
    });
}); };
exports.CommandPreview = CommandPreview;
//# sourceMappingURL=run-preview.js.map