"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.publish = void 0;
var fs = require("fs-extra");
var path = require("path");
var inquirer = require("inquirer");
var commitLint = require("@commitlint/lint");
var semver = require("semver");
var child_process_1 = require("child_process");
var _ = require("lodash");
var glob = require("glob");
var pkg = require("../../../../package.json");
var exec_1 = require("../../../utils/exec");
var node_1 = require("../../../node");
var build_1 = require("../../command-build/plugin/build");
var command_bundle_1 = require("../../command-bundle/plugin/command-bundle");
var git_operate_1 = require("../../../utils/git-operate");
var log_1 = require("../../../utils/log");
var packages_1 = require("../../../utils/packages");
var npm_1 = require("../../../utils/npm");
var constants_1 = require("../../../utils/constants");
var publish = function (options) { return __awaiter(void 0, void 0, void 0, function () {
    var currentBranchName, _a, developBranchConfig, isDevelopBranch, _b, currentSelectedSourceType_1, selectedPkgJson, _c, depMonoPackages, depMap, includeAllPrompt, _d, unPublishList_1, authList, _i, depMonoPackages_1, eachPackage, _e, _f;
    var _g, _h;
    return __generator(this, function (_j) {
        switch (_j.label) {
            case 0:
                if (!options.branch) return [3 /*break*/, 1];
                _a = options.branch;
                return [3 /*break*/, 3];
            case 1: return [4 /*yield*/, git_operate_1.getCurrentBranchName()];
            case 2:
                _a = _j.sent();
                _j.label = 3;
            case 3:
                currentBranchName = _a;
                developBranchConfig = _.get(node_1.pri.projectConfig, 'customEnv.developBranchConfig.publishBranch', []);
                isDevelopBranch = __spreadArray(['master', 'develop'], developBranchConfig).includes(currentBranchName);
                _b = node_1.pri.sourceConfig.type;
                switch (_b) {
                    case 'component': return [3 /*break*/, 4];
                    case 'plugin': return [3 /*break*/, 4];
                    case 'project': return [3 /*break*/, 31];
                }
                return [3 /*break*/, 31];
            case 4:
                if (!!options.skipNpm) return [3 /*break*/, 30];
                return [4 /*yield*/, node_1.pri.project.ensureProjectFiles()];
            case 5:
                _j.sent();
                return [4 /*yield*/, node_1.pri.project.checkProjectFiles()];
            case 6:
                _j.sent();
                currentSelectedSourceType_1 = node_1.pri.selectedSourceType;
                selectedPkgJson = currentSelectedSourceType_1 === 'root'
                    ? node_1.pri.projectPackageJson
                    : (_g = node_1.pri.packages.find(function (p) { return p.name === currentSelectedSourceType_1; })) === null || _g === void 0 ? void 0 : _g.packageJson;
                if (!!options.skipLint) return [3 /*break*/, 8];
                return [4 /*yield*/, node_1.pri.project.lint({
                        lintAll: true,
                        needFix: false,
                        showBreakError: true,
                    })];
            case 7:
                _j.sent();
                _j.label = 8;
            case 8: return [4 /*yield*/, packages_1.getMonoAndNpmDepsOnce()];
            case 9:
                _c = _j.sent(), depMonoPackages = _c.depMonoPackages, depMap = _c.depMap;
                if (!(depMonoPackages.length > 0)) return [3 /*break*/, 20];
                includeAllPrompt = { includeAll: false };
                if (!_.has(options, 'includeAll')) return [3 /*break*/, 10];
                includeAllPrompt = { includeAll: options.includeAll };
                return [3 /*break*/, 12];
            case 10: return [4 /*yield*/, inquirer.prompt([
                    {
                        message: node_1.pri.selectedSourceType + " depends on monorepo " + depMonoPackages
                            .map(function (eachPackage) { return "\"" + eachPackage.name + "\""; })
                            .join(', ') + " \n Do you want to publish these packages first?",
                        name: 'includeAll',
                        type: 'confirm',
                    },
                ])];
            case 11:
                includeAllPrompt = _j.sent();
                _j.label = 12;
            case 12:
                // eslint-disable-next-line babel/no-unused-expressions
                _d = !options.commitOnly;
                if (!_d) 
                // eslint-disable-next-line babel/no-unused-expressions
                return [3 /*break*/, 14];
                return [4 /*yield*/, buildDeclaration()];
            case 13:
                _d = (_j.sent());
                _j.label = 14;
            case 14:
                // eslint-disable-next-line babel/no-unused-expressions
                _d;
                if (!includeAllPrompt.includeAll) return [3 /*break*/, 19];
                unPublishList_1 = ((_h = node_1.pri.sourceConfig) === null || _h === void 0 ? void 0 : _h.unPublishList) || [];
                authList = __spreadArray([selectedPkgJson === null || selectedPkgJson === void 0 ? void 0 : selectedPkgJson.name], depMonoPackages.map(function (v) { return v.packageJson.name; })).filter(function (n) { return !!n; })
                    .filter(function (item) { return unPublishList_1.indexOf(item) === -1; });
                return [4 /*yield*/, authPublish(authList)];
            case 15:
                _j.sent();
                _i = 0, depMonoPackages_1 = depMonoPackages;
                _j.label = 16;
            case 16:
                if (!(_i < depMonoPackages_1.length)) return [3 /*break*/, 19];
                eachPackage = depMonoPackages_1[_i];
                if (!(unPublishList_1.indexOf(eachPackage.packageJson.name) === -1)) return [3 /*break*/, 18];
                return [4 /*yield*/, publishByPackageName(eachPackage.name, options, depMap, isDevelopBranch, currentBranchName)];
            case 17:
                _j.sent();
                _j.label = 18;
            case 18:
                _i++;
                return [3 /*break*/, 16];
            case 19: return [3 /*break*/, 23];
            case 20:
                // eslint-disable-next-line babel/no-unused-expressions
                _e = !options.commitOnly;
                if (!_e) 
                // eslint-disable-next-line babel/no-unused-expressions
                return [3 /*break*/, 22];
                return [4 /*yield*/, buildDeclaration()];
            case 21:
                _e = (_j.sent());
                _j.label = 22;
            case 22:
                // eslint-disable-next-line babel/no-unused-expressions
                _e;
                _j.label = 23;
            case 23:
                if (!(selectedPkgJson === null || selectedPkgJson === void 0 ? void 0 : selectedPkgJson.name)) return [3 /*break*/, 25];
                return [4 /*yield*/, authPublish([selectedPkgJson.name])];
            case 24:
                _j.sent();
                _j.label = 25;
            case 25: return [4 /*yield*/, publishByPackageName(currentSelectedSourceType_1, options, depMap, isDevelopBranch, currentBranchName)];
            case 26:
                _j.sent();
                return [4 /*yield*/, fs.remove(path.join(node_1.pri.projectRootPath, node_1.tempPath.dir, node_1.declarationPath.dir))];
            case 27:
                _j.sent();
                // eslint-disable-next-line babel/no-unused-expressions
                _f = !options.publishOnly;
                if (!_f) 
                // eslint-disable-next-line babel/no-unused-expressions
                return [3 /*break*/, 29];
                return [4 /*yield*/, exec_1.exec("git push origin " + currentBranchName)];
            case 28:
                _f = (_j.sent());
                _j.label = 29;
            case 29:
                // eslint-disable-next-line babel/no-unused-expressions
                _f;
                _j.label = 30;
            case 30: return [3 /*break*/, 31];
            case 31:
                // eslint-disable-next-line babel/no-unused-expressions
                options.exitAfterPublish && process.exit(0);
                return [2 /*return*/];
        }
    });
}); };
exports.publish = publish;
function authPublish(packageNames) {
    return __awaiter(this, void 0, void 0, function () {
        var getUserName, failedPkgSet, checkOwner, pkgsP;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    getUserName = function (npmClient) {
                        if (npmClient === void 0) { npmClient = 'npm'; }
                        var name;
                        try {
                            var nameRet = child_process_1.execSync(npmClient + " whoami");
                            name = nameRet.toString().trim();
                        }
                        catch (error) {
                            log_1.logFatal(error);
                        }
                        return name;
                    };
                    failedPkgSet = new Set();
                    checkOwner = function (uName, pName, npmClient) {
                        return new Promise(function (res, rej) {
                            npm_1.isOwner(uName, pName, npmClient)
                                .then(function (v) {
                                if (!v) {
                                    failedPkgSet.add(pName);
                                }
                                res(v);
                            })
                                .catch(function (e) { return rej(e); });
                        });
                    };
                    pkgsP = packageNames.map(function (p) {
                        var _a;
                        var packageConfig = p === node_1.pri.projectPackageJson.name
                            ? node_1.pri.projectConfig
                            : (_a = node_1.pri.packages.find(function (eachPackage) { return eachPackage.packageJson.name === p; })) === null || _a === void 0 ? void 0 : _a.config;
                        return checkOwner(getUserName(packageConfig === null || packageConfig === void 0 ? void 0 : packageConfig.npmClient), p, packageConfig === null || packageConfig === void 0 ? void 0 : packageConfig.npmClient);
                    });
                    return [4 /*yield*/, Promise.all(pkgsP)];
                case 1:
                    _a.sent();
                    if (failedPkgSet.size > 0) {
                        log_1.logFatal("Permission error: need ownership to publish these packages. \n " + Array.from(failedPkgSet).join('\n'));
                    }
                    return [2 /*return*/];
            }
        });
    });
}
function publishByPackageName(sourceType, options, depMap, isDevelopBranch, currentBranchName) {
    return __awaiter(this, void 0, void 0, function () {
        var targetPackageJson, targetConfig, targetRoot, _a, inquirerInfo, result, versionResult, versionResultExec, basicVersion, branchNameInVersion_1, publishedVersions, tempVersions, maxBetaVersionNum_1, betaVersionReg_1, versionPrompt;
        var _this = this;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    log_1.logInfo("Start publish " + sourceType + ".");
                    targetPackageJson = sourceType === 'root'
                        ? node_1.pri.projectPackageJson || {}
                        : node_1.pri.packages.find(function (eachPackage) { return eachPackage.name === sourceType; }).packageJson || {};
                    targetConfig = sourceType === 'root'
                        ? node_1.pri.projectConfig
                        : node_1.pri.packages.find(function (eachPackage) { return eachPackage.name === sourceType; }).config;
                    targetRoot = sourceType === 'root'
                        ? node_1.pri.projectRootPath
                        : node_1.pri.packages.find(function (eachPackage) { return eachPackage.name === sourceType; }).rootPath;
                    return [4 /*yield*/, fs.remove(path.join(node_1.pri.projectRootPath, node_1.pri.sourceConfig.distDir))];
                case 1:
                    _b.sent();
                    // Change source config here
                    node_1.pri.sourceConfig = targetConfig;
                    node_1.pri.sourceRoot = targetRoot;
                    node_1.pri.selectedSourceType = sourceType;
                    if (!targetPackageJson.name) {
                        log_1.logFatal("No name found in " + sourceType + " package.json");
                    }
                    if (!targetPackageJson.version) {
                        log_1.logFatal("No version found in " + sourceType + " package.json");
                    }
                    _a = !options.publishOnly;
                    if (!_a) return [3 /*break*/, 3];
                    return [4 /*yield*/, git_operate_1.isWorkingTreeClean()];
                case 2:
                    _a = !(_b.sent());
                    _b.label = 3;
                case 3:
                    if (!_a) return [3 /*break*/, 7];
                    return [4 /*yield*/, inquirer.prompt([
                            {
                                message: 'Working tree is not clean, your commit message:',
                                name: 'message',
                                type: 'input',
                            },
                        ])];
                case 4:
                    inquirerInfo = _b.sent();
                    if (!inquirerInfo.message) {
                        log_1.logFatal("Need commit message");
                    }
                    return [4 /*yield*/, commitLint(inquirerInfo.message, {
                            'body-leading-blank': [1, 'always'],
                            'footer-leading-blank': [1, 'always'],
                            'header-max-length': [2, 'always', 72],
                            'scope-case': [2, 'always', 'lower-case'],
                            'subject-case': [2, 'never', ['sentence-case', 'start-case', 'pascal-case', 'upper-case']],
                            'subject-empty': [2, 'never'],
                            'subject-full-stop': [2, 'never', '.'],
                            'type-case': [2, 'always', 'lower-case'],
                            'type-empty': [2, 'never'],
                            'type-enum': [2, 'always', ['build', 'ci', 'docs', 'feat', 'fix', 'perf', 'refactor', 'revert', 'style', 'test']],
                        })];
                case 5:
                    result = _b.sent();
                    if (!result.valid) {
                        log_1.logFatal("\n" + result.errors.map(function (eachError) { return eachError.message; }).join('\n'));
                    }
                    if (!inquirerInfo.message) return [3 /*break*/, 7];
                    return [4 /*yield*/, exec_1.exec("git add -A; git commit -m \"" + inquirerInfo.message + "\" -n", {
                            cwd: node_1.pri.projectRootPath,
                        })];
                case 6:
                    _b.sent();
                    _b.label = 7;
                case 7:
                    versionResult = null;
                    if (options.tag !== 'beta' && isDevelopBranch) {
                        log_1.logInfo('Check if npm package exist');
                        try {
                            versionResultExec = child_process_1.execSync(targetConfig.npmClient + " view " + targetPackageJson.name + "@" + targetPackageJson.version + " version");
                            if (versionResultExec) {
                                versionResult = versionResultExec.toString().trim();
                            }
                            else {
                                versionResult = null;
                            }
                        }
                        catch (error) {
                            // Throw error means not exist
                            versionResult = null;
                        }
                    }
                    if (!!options.publishOnly) return [3 /*break*/, 19];
                    if (!(options.tag === 'beta' || !isDevelopBranch)) return [3 /*break*/, 12];
                    basicVersion = '1.0.0';
                    branchNameInVersion_1 = currentBranchName.replace(/\//g, '').replace(/\./g, '');
                    publishedVersions = [];
                    try {
                        tempVersions = child_process_1.execSync(targetConfig.npmClient + " view " + targetPackageJson.name + " versions");
                        if (tempVersions) {
                            publishedVersions = tempVersions
                                .toString()
                                .trim()
                                .replace(/\n|'| |\[|\]/g, '')
                                .split(',');
                        }
                        else {
                            publishedVersions = [];
                        }
                    }
                    catch (e) {
                        publishedVersions = [];
                    }
                    maxBetaVersionNum_1 = 0;
                    betaVersionReg_1 = new RegExp("\\d+\\.\\d+\\.\\d+-" + branchNameInVersion_1 + "\\.\\d+");
                    // get max beta version
                    publishedVersions.forEach(function (v) {
                        if (betaVersionReg_1.test(v)) {
                            var tempBetaVersion = Number(v.split(branchNameInVersion_1 + ".")[1]);
                            if (maxBetaVersionNum_1 < tempBetaVersion) {
                                maxBetaVersionNum_1 = tempBetaVersion;
                            }
                        }
                    });
                    // basic version without branchName -> use basic version + branch name + beta version
                    targetPackageJson.version = basicVersion + "-" + branchNameInVersion_1 + "." + (maxBetaVersionNum_1 + 1);
                    return [4 /*yield*/, fs.outputFile(path.join(targetRoot, 'package.json'), JSON.stringify(targetPackageJson, null, 2) + "\n")];
                case 8:
                    _b.sent();
                    return [4 /*yield*/, git_operate_1.isWorkingTreeClean()];
                case 9:
                    if (!!(_b.sent())) return [3 /*break*/, 11];
                    return [4 /*yield*/, exec_1.exec("git add -A; git commit -m \"upgrade " + sourceType + " version to " + targetPackageJson.version + "\" -n", {
                            cwd: node_1.pri.projectRootPath,
                        })];
                case 10:
                    _b.sent();
                    _b.label = 11;
                case 11: return [3 /*break*/, 19];
                case 12:
                    if (!versionResult) return [3 /*break*/, 19];
                    if (!!options.semver) return [3 /*break*/, 14];
                    return [4 /*yield*/, inquirer.prompt([
                            {
                                message: targetPackageJson.name + "@" + targetPackageJson.version + " exist, can upgrade to",
                                name: 'version',
                                type: 'list',
                                choices: [
                                    {
                                        name: "Patch(" + semver.inc(targetPackageJson.version, 'patch') + ")",
                                        value: semver.inc(targetPackageJson.version, 'patch'),
                                    },
                                    {
                                        name: "Minor(" + semver.inc(targetPackageJson.version, 'minor') + ")",
                                        value: semver.inc(targetPackageJson.version, 'minor'),
                                    },
                                    {
                                        name: "Major(" + semver.inc(targetPackageJson.version, 'major') + ")",
                                        value: semver.inc(targetPackageJson.version, 'major'),
                                    },
                                ],
                            },
                        ])];
                case 13:
                    versionPrompt = _b.sent();
                    targetPackageJson.version = versionPrompt.version;
                    return [3 /*break*/, 15];
                case 14:
                    if (['patch', 'minor', 'major'].some(function (each) { return each === options.semver; })) {
                        targetPackageJson.version = semver.inc(targetPackageJson.version, options.semver);
                    }
                    else {
                        log_1.logFatal("semver must be \"patch\" \"minor\" or \"major\"");
                    }
                    _b.label = 15;
                case 15: 
                // Upgrade package.json's version
                return [4 /*yield*/, fs.outputFile(path.join(targetRoot, 'package.json'), JSON.stringify(targetPackageJson, null, 2) + "\n")];
                case 16:
                    // Upgrade package.json's version
                    _b.sent();
                    return [4 /*yield*/, git_operate_1.isWorkingTreeClean()];
                case 17:
                    if (!!(_b.sent())) return [3 /*break*/, 19];
                    return [4 /*yield*/, exec_1.exec("git add -A; git commit -m \"upgrade " + sourceType + " version to " + targetPackageJson.version + "\" -n", {
                            cwd: node_1.pri.projectRootPath,
                        })];
                case 18:
                    _b.sent();
                    _b.label = 19;
                case 19:
                    // Update version in depMao
                    if (depMap) {
                        depMap.forEach(function (value) {
                            value.depMonoPackages.forEach(function (eachPackage) {
                                if (eachPackage.name === sourceType) {
                                    // eslint-disable-next-line no-param-reassign
                                    eachPackage.packageJson.version = targetPackageJson.version;
                                }
                            });
                        });
                    }
                    if (!!options.commitOnly) return [3 /*break*/, 24];
                    return [4 /*yield*/, build_1.buildComponent()];
                case 20:
                    _b.sent();
                    if (!options.bundle) return [3 /*break*/, 22];
                    return [4 /*yield*/, command_bundle_1.commandBundle({ skipLint: true })];
                case 21:
                    _b.sent();
                    _b.label = 22;
                case 22: return [4 /*yield*/, log_1.spinner("Publish", function () { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, moveSourceFilesToTempFolderAndPublish(sourceType, options, targetConfig, targetRoot, depMap, isDevelopBranch)];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 23:
                    _b.sent();
                    _b.label = 24;
                case 24:
                    log_1.logText("+ " + targetPackageJson.name + "@" + targetPackageJson.version);
                    return [2 /*return*/];
            }
        });
    });
}
function moveSourceFilesToTempFolderAndPublish(sourceType, options, targetConfig, targetRoot, depMap, isDevelopBranch) {
    return __awaiter(this, void 0, void 0, function () {
        var publishTempName, tempRoot, targetPackageJson, addedPackageJson, finalTag;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    publishTempName = 'publish-temp';
                    tempRoot = path.join(node_1.pri.projectRootPath, node_1.tempPath.dir, publishTempName);
                    return [4 /*yield*/, fs.remove(tempRoot)];
                case 1:
                    _a.sent();
                    if (!node_1.pri.sourceConfig.materialComponent) return [3 /*break*/, 4];
                    return [4 /*yield*/, fs.copy(path.join(node_1.pri.sourceRoot, 'es'), path.join(tempRoot, 'es'))];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, fs.copy(path.join(node_1.pri.sourceRoot, 'lib'), path.join(tempRoot, 'lib'))];
                case 3:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 4: return [4 /*yield*/, fs.copy(path.join(node_1.pri.projectRootPath, targetConfig.distDir), path.join(tempRoot, targetConfig.distDir))];
                case 5:
                    _a.sent();
                    _a.label = 6;
                case 6: return [4 /*yield*/, copyDeclaration(sourceType, publishTempName)];
                case 7:
                    _a.sent();
                    return [4 /*yield*/, fs.copy(path.join(targetRoot, 'package.json'), path.join(tempRoot, 'package.json'))];
                case 8:
                    _a.sent();
                    if (!fs.existsSync(path.join(targetRoot, constants_1.README_FILE))) return [3 /*break*/, 10];
                    return [4 /*yield*/, fs.copy(path.join(targetRoot, constants_1.README_FILE), path.join(tempRoot, constants_1.README_FILE))];
                case 9:
                    _a.sent();
                    return [3 /*break*/, 12];
                case 10:
                    if (!fs.existsSync(path.join(targetRoot, constants_1.README_FILE.toLowerCase()))) return [3 /*break*/, 12];
                    return [4 /*yield*/, fs.copy(path.join(targetRoot, constants_1.README_FILE.toLowerCase()), path.join(tempRoot, constants_1.README_FILE))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12: return [4 /*yield*/, fs.readJson(path.join(tempRoot, 'package.json'))];
                case 13:
                    targetPackageJson = _a.sent();
                    return [4 /*yield*/, addMissingDeps(options, sourceType, depMap, targetConfig, isDevelopBranch)];
                case 14:
                    addedPackageJson = _a.sent();
                    _.merge(targetPackageJson, addedPackageJson);
                    return [4 /*yield*/, fs.outputFile(path.join(tempRoot, 'package.json'), JSON.stringify(targetPackageJson, null, 2))];
                case 15:
                    _a.sent();
                    finalTag = options.tag || 'latest';
                    if (!isDevelopBranch) {
                        finalTag = 'beta';
                    }
                    return [4 /*yield*/, exec_1.exec(targetConfig.npmClient + " publish " + tempRoot + " --ignore-scripts --tag " + finalTag, {
                            cwd: tempRoot,
                        })];
                case 16:
                    _a.sent();
                    return [4 /*yield*/, fs.remove(tempRoot)];
                case 17:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function addMissingDeps(options, sourceType, depMap, targetConfig, isDevelopBranch) {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var newPackageJson, excludeRootDepList, _b, depMonoPackages, depNpmPackages, projectPackageJsonDeps, sourceDeps_1;
        return __generator(this, function (_c) {
            newPackageJson = {};
            if (targetConfig.npmClient === 'tnpm') {
                newPackageJson.publishConfig = {
                    registry: 'https://registry.npm.alibaba-inc.com',
                };
            }
            excludeRootDepList = ((_a = node_1.pri.projectConfig.publishConfig) === null || _a === void 0 ? void 0 : _a.excludeRootDepList) || ['react', 'react-dom', 'antd'];
            if (depMap) {
                _b = depMap.get(sourceType), depMonoPackages = _b.depMonoPackages, depNpmPackages = _b.depNpmPackages;
                newPackageJson.dependencies = depMonoPackages.reduce(function (root, next) {
                    var _a;
                    if (!next.packageJson.version) {
                        log_1.logFatal(sourceType + " depend on " + next.name + ", but missing \"version\" in " + next.name + "'s package.json");
                    }
                    var prefix = '^';
                    if (options.tag === 'beta' || !isDevelopBranch) {
                        prefix = '';
                    }
                    return __assign(__assign({}, root), (_a = {}, _a[next.packageJson.name] = "" + prefix + next.packageJson.version, _a));
                }, {});
                if (sourceType !== 'root') {
                    projectPackageJsonDeps = node_1.pri.projectPackageJson.dependencies || {};
                    sourceDeps_1 = {};
                    sourceDeps_1 = __assign(__assign({}, sourceDeps_1), projectPackageJsonDeps);
                    // If root type is project, also find in pri deps.
                    if (node_1.pri.projectConfig.type === 'project') {
                        sourceDeps_1 = __assign(__assign({}, sourceDeps_1), (pkg.dependencies || {}));
                    }
                    // add nested deps
                    sourceDeps_1 = __assign(__assign({}, sourceDeps_1), { history: '*' });
                    newPackageJson.dependencies = __assign(__assign({}, newPackageJson.dependencies), depNpmPackages
                        .filter(function (npmName) { return !excludeRootDepList.includes(npmName); })
                        .reduce(function (root, next) {
                        var _a;
                        if (!sourceDeps_1[next]) {
                            log_1.logFatal(node_1.pri.selectedSourceType + "'s code depends on " + next + ", but it doesn't exist in root package.json");
                        }
                        return __assign(__assign({}, root), (_a = {}, _a[next] = sourceDeps_1[next], _a));
                    }, {}));
                }
            }
            if (sourceType !== 'root') {
                if (node_1.pri.sourceConfig.materialComponent) {
                    _.set(newPackageJson, 'main', "lib");
                    _.set(newPackageJson, 'module', "es");
                }
                else {
                    _.set(newPackageJson, 'main', node_1.pri.projectConfig.distDir + "/main");
                    _.set(newPackageJson, 'module', node_1.pri.projectConfig.distDir + "/module");
                    _.set(newPackageJson, 'esm5', node_1.pri.projectConfig.distDir + "/esm5");
                }
                _.set(newPackageJson, 'types', 'declaration/index.d.ts');
            }
            return [2 /*return*/, newPackageJson];
        });
    });
}
function buildDeclaration() {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: 
                // Create d.ts
                return [4 /*yield*/, log_1.spinner("create declaration", function () { return __awaiter(_this, void 0, void 0, function () {
                        var _a;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    _b.trys.push([0, 2, , 3]);
                                    return [4 /*yield*/, exec_1.exec("npx tsc --declaration --declarationDir " + path.join(node_1.pri.projectRootPath, "./" + node_1.tempPath.dir + "/" + node_1.declarationPath.dir) + " --emitDeclarationOnly >> /dev/null 2>&1", {
                                            cwd: node_1.pri.projectRootPath,
                                        })];
                                case 1:
                                    _b.sent();
                                    return [3 /*break*/, 3];
                                case 2:
                                    _a = _b.sent();
                                    return [3 /*break*/, 3];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    // Create d.ts
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function copyDeclaration(sourceType, publishTempName) {
    return __awaiter(this, void 0, void 0, function () {
        var declarationRoot, srcPathExtra, declarationSourceRoot_1, declarationFiles, declarationFiles;
        return __generator(this, function (_a) {
            declarationRoot = path.join(node_1.pri.projectRootPath, node_1.tempPath.dir, node_1.declarationPath.dir);
            srcPathExtra = node_1.pri.packages.length > 0 ? node_1.srcPath.dir : '';
            // If select packages, pick it's own declaration
            if (sourceType !== 'root') {
                declarationSourceRoot_1 = path.join(declarationRoot, path.relative(node_1.pri.projectRootPath, node_1.pri.packages.find(function (each) { return each.name === sourceType; }).rootPath), srcPathExtra);
                declarationFiles = glob.sync(path.join(declarationSourceRoot_1, '/**/*.d.ts'));
                declarationFiles.map(function (eachFile) {
                    var targetPath = path.relative(declarationSourceRoot_1, eachFile);
                    fs.copySync(eachFile, path.join(node_1.pri.projectRootPath, node_1.tempPath.dir, publishTempName, node_1.declarationPath.dir, targetPath));
                });
            }
            else {
                declarationFiles = glob.sync(path.join(declarationRoot, srcPathExtra, '**/*.d.ts'));
                declarationFiles.map(function (eachFile) {
                    var targetPath = path.relative(path.join(declarationRoot, srcPathExtra), eachFile);
                    fs.copySync(eachFile, path.join(node_1.pri.projectRootPath, node_1.tempPath.dir, publishTempName, node_1.declarationPath.dir, targetPath));
                });
            }
            return [2 /*return*/];
        });
    });
}
//# sourceMappingURL=run-publish.js.map