"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runTest = void 0;
var path = require("path");
var jest = require("jest");
var node_1 = require("../../../node");
var plugins_1 = require("../../../utils/plugins");
var log_1 = require("../../../utils/log");
var structor_config_1 = require("../../../utils/structor-config");
var global_state_1 = require("../../../utils/global-state");
var runTest = function (options) { return __awaiter(void 0, void 0, void 0, function () {
    var jestConfig, result;
    var _a;
    var _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                jestConfig = {
                    rootDir: node_1.pri.sourceRoot,
                    testRegex: (_b = options.testRegex) !== null && _b !== void 0 ? _b : path.join(node_1.pri.sourceRoot, structor_config_1.testsPath.dir) + "/.*\\.tsx?$",
                    moduleFileExtensions: ['ts', 'tsx', 'js', 'jsx'],
                    coverage: true,
                    updateSnapshot: options.updateSnapshot,
                    watch: options.watch,
                    watchAll: options.watchAll,
                    transform: JSON.stringify(__assign((_a = {}, _a[node_1.pri.sourceRoot + "/.*\\.tsx?$"] = path.join(__dirname, './jest-transformer'), _a), global_state_1.globalState.packages.reduce(function (obj, eachPackage) {
                        var _a;
                        if (eachPackage.rootPath) {
                            return __assign(__assign({}, obj), (_a = {}, _a[path.join(eachPackage.rootPath, 'src') + "/.*\\.tsx?$"] = path.join(__dirname, './jest-transformer'), _a));
                        }
                        return obj;
                    }, {}))),
                    moduleNameMapper: JSON.stringify(global_state_1.globalState.packages.reduce(function (obj, eachPackage) {
                        var _a;
                        if (eachPackage.packageJson && eachPackage.packageJson.name) {
                            return __assign(__assign({}, obj), (_a = {}, _a["^" + eachPackage.packageJson.name + "$"] = path.join(eachPackage.rootPath, 'src'), _a));
                        }
                        return obj;
                    }, {})),
                };
                return [4 /*yield*/, jest.runCLI(__assign({ _: options._, $0: options.$0 }, plugins_1.plugin.jestConfigPipes.reduce(function (config, fn) { return fn(config); }, jestConfig)), [node_1.pri.projectRootPath])];
            case 1:
                result = _c.sent();
                plugins_1.plugin.afterTestRunCallbacks.forEach(function (callback) {
                    return callback(result);
                });
                log_1.logText("Open this url to see code coverage: file://" + path.join(node_1.pri.sourceRoot, 'coverage/lcov-report/index.html'));
                return [2 /*return*/];
        }
    });
}); };
exports.runTest = runTest;
//# sourceMappingURL=run-test.js.map