"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ensurePluginFiles = void 0;
var fs = require("fs-extra");
var path = require("path");
var node_1 = require("../../../node");
var constants_1 = require("../../../utils/constants");
var global_state_1 = require("../../../utils/global-state");
var log_1 = require("../../../utils/log");
var prettier_config_1 = require("../../../utils/prettier-config");
function ensurePluginFiles() {
    ensureEntry();
    ensureTest();
}
exports.ensurePluginFiles = ensurePluginFiles;
function ensureEntry() {
    var _this = this;
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.sourceRoot, path.format(node_1.pluginEntry)),
        pipeContent: function (text) { return __awaiter(_this, void 0, void 0, function () {
            var prettier;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (text) {
                            return [2 /*return*/, text];
                        }
                        return [4 /*yield*/, Promise.resolve().then(function () { return require('prettier'); })];
                    case 1:
                        prettier = _a.sent();
                        return [2 /*return*/, prettier.format("\n        export const getPlugin = () => import(\"./plugin\");\n\n        export const getConfig = () => ({\n          name: \"pri-plugin-" + node_1.pri.projectPackageJson.name + "\"\n        });\n      ")];
                }
            });
        }); },
    });
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.sourceRoot, node_1.srcPath.dir, 'plugin/index.ts'),
        pipeContent: function (text) { return __awaiter(_this, void 0, void 0, function () {
            var prettier;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (text) {
                            return [2 /*return*/, text];
                        }
                        return [4 /*yield*/, Promise.resolve().then(function () { return require('prettier'); })];
                    case 1:
                        prettier = _a.sent();
                        return [2 /*return*/, prettier.format("\n        import * as path from \"path\"\n        import { pri } from \"" + constants_1.PRI_PACKAGE_NAME + "\"\n\n        interface IResult {\n          customPlugin: {\n            hasComponents: boolean\n          }\n        }\n\n        pri.commands.registerCommand({\n          name: [\"deploy\"],\n          action: async () => {\n            //\n          }\n        })\n\n        pri.project.onAnalyseProject(files => {\n          const result: IResult = { customPlugin: { hasComponents: judgeHasComponents(pri.projectRootPath, files) } };\n          return result;\n        })\n\n        pri.project.onCreateEntry((analyseInfo: IResult, entry) => {\n          if (!analyseInfo.customPlugin.hasComponents) {\n            return\n          }\n\n          entry.pipeAppHeader(header => {\n            return `\n              ${header}\n              import \"src/components/xxx\"\n            `\n          })\n        })\n\n        export function judgeHasComponents(projectRootPath: string, files: path.ParsedPath[]) {\n          return files.some(file => {\n            const relativePath = path.relative(projectRootPath, path.join(file.dir, file.name))\n            if (relativePath.startsWith(\"src/components\")) {\n              return true\n            }\n            return false\n          })\n        }\n      ", __assign(__assign({}, prettier_config_1.prettierConfig), { parser: 'typescript' }))];
                }
            });
        }); },
    });
}
function ensureTest() {
    var _this = this;
    var filePath = path.join(global_state_1.globalState.projectRootPath, node_1.testsPath.dir, 'index.ts');
    if (fs.existsSync(filePath)) {
        log_1.logSuccess('Test file already exist.');
        return;
    }
    node_1.pri.project.addProjectFiles({
        fileName: filePath,
        pipeContent: function () { return __awaiter(_this, void 0, void 0, function () {
            var prettier;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.resolve().then(function () { return require('prettier'); })];
                    case 1:
                        prettier = _a.sent();
                        return [2 /*return*/, prettier.format("\n          test('test', () => {\n            expect(true).toBe(true);\n          });\n          ", __assign(__assign({}, prettier_config_1.prettierConfig), { parser: 'typescript' }))];
                }
            });
        }); },
    });
}
//# sourceMappingURL=ensure-plugin.js.map