"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.main = void 0;
var fs = require("fs-extra");
var _ = require("lodash");
var path = require("path");
var yargs = require("yargs");
var pkg = require("../../../../package.json");
var node_1 = require("../../../node");
var constants_1 = require("../../../utils/constants");
var functional_1 = require("../../../utils/functional");
var global_state_1 = require("../../../utils/global-state");
var structor_config_1 = require("../../../utils/structor-config");
var ensure_component_1 = require("./ensure-component");
var ensure_plugin_1 = require("./ensure-plugin");
var ensure_project_1 = require("./ensure-project");
var main = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        ensureGitignore();
        ensureNpmignore();
        ensureNpmrc();
        ensureTsconfig();
        ensureVscode();
        ensureEslint();
        ensurePrettier();
        ensurePriConfig();
        ensureDeclares();
        switch (node_1.pri.sourceConfig.type) {
            case 'project':
                ensure_project_1.ensureProjectFiles();
                ensureRootPackageJson();
                break;
            case 'component':
                ensure_component_1.ensureComponentFiles();
                ensureRootPackageJson();
                break;
            case 'plugin':
                ensure_plugin_1.ensurePluginFiles();
                ensureRootPackageJson();
                break;
            default:
            // don't need ensure root package.json for extend type
        }
        return [2 /*return*/];
    });
}); };
exports.main = main;
var maxSizePri = 'node --max-old-space-size=16384 --max_old_space_size=16384 ./node_modules/.bin/pri';
var commonComponentPackageJson = {
    scripts: {
        start: maxSizePri + " dev",
        docs: maxSizePri + " docs",
        build: maxSizePri + " build",
        bundle: maxSizePri + " bundle",
        preview: maxSizePri + " preview",
        analyse: maxSizePri + " analyse",
        publish: maxSizePri + " publish",
        lint: maxSizePri + " lint",
        test: maxSizePri + " test",
    },
    husky: {
        hooks: {
            'pre-commit': 'npm test -- --package root',
        },
    },
};
function ensureDeclares() {
    fs.copySync(path.join(__dirname, '../../../../declare'), path.join(node_1.pri.projectRootPath, structor_config_1.declarePath.dir));
}
function ensureTsconfig() {
    var _this = this;
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.projectRootPath, 'tsconfig.json'),
        pipeContent: function () { return __awaiter(_this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                return [2 /*return*/, JSON.stringify({
                        compilerOptions: {
                            module: 'esnext',
                            moduleResolution: 'node',
                            strict: true,
                            strictNullChecks: false,
                            incremental: true,
                            jsx: 'react',
                            target: 'esnext',
                            experimentalDecorators: true,
                            skipLibCheck: true,
                            outDir: global_state_1.globalState.sourceConfig.distDir,
                            baseUrl: '.',
                            lib: ['dom', 'es5', 'es6', 'es7', 'scripthost', 'es2018.promise'],
                            emitDecoratorMetadata: true,
                            preserveConstEnums: true,
                            isolatedModules: true,
                            paths: __assign(__assign((_a = {}, _a[constants_1.PRI_PACKAGE_NAME + "/*"] = [constants_1.PRI_PACKAGE_NAME, path.join(structor_config_1.tempTypesPath.dir, '*')], _a), (node_1.pri.sourceConfig.type === 'project' && { 'src/*': ['src/*'] })), global_state_1.globalState.packages.reduce(function (obj, eachPackage) {
                                var _a;
                                if (eachPackage.packageJson && eachPackage.packageJson.name) {
                                    return __assign(__assign({}, obj), (_a = {}, _a[eachPackage.packageJson.name] = [
                                        path.join(path.relative(node_1.pri.projectRootPath, eachPackage.rootPath), 'src'),
                                    ], _a));
                                }
                                return obj;
                            }, {})),
                        },
                        include: __spreadArray([
                            structor_config_1.tempPath.dir + "/**/*",
                            structor_config_1.typingsPath.dir + "/**/*"
                        ], global_state_1.transferToAllAbsolutePaths(structor_config_1.srcPath.dir).map(function (filePath) {
                            return path.relative(node_1.pri.projectRootPath, filePath) + "/**/*";
                        })),
                        exclude: ['node_modules', global_state_1.globalState.projectConfig.distDir, structor_config_1.tempPath.dir],
                    }, null, 2) + "\n"]; // Make sure ./src structor. # https://github.com/Microsoft/TypeScript/issues/5134
            });
        }); },
    });
}
function ensureEslint() {
    var _this = this;
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.projectRootPath, '.eslintrc'),
        pipeContent: function () { return __awaiter(_this, void 0, void 0, function () {
            var eslintConfig;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fs.readFile(path.join(__dirname, '../../../../.eslintrc'))];
                    case 1:
                        eslintConfig = _a.sent();
                        return [2 /*return*/, eslintConfig.toString() + "\n"];
                }
            });
        }); },
    });
}
function ensurePrettier() {
    var _this = this;
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.projectRootPath, '.prettierrc'),
        pipeContent: function () { return __awaiter(_this, void 0, void 0, function () {
            var prettierConfig;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fs.readFile(path.join(__dirname, '../../../../.prettierrc'))];
                    case 1:
                        prettierConfig = _a.sent();
                        return [2 /*return*/, prettierConfig.toString() + "\n"];
                }
            });
        }); },
    });
}
function ensureVscode() {
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.projectRootPath, '.vscode/settings.json'),
        pipeContent: function (prev) {
            var pickedPrev = _.omit(functional_1.safeJsonParse(prev), 'eslint.provideLintTask');
            return JSON.stringify(_.merge({}, pickedPrev, {
                'editor.formatOnSave': true,
                'typescript.tsdk': 'node_modules/typescript/lib',
                'eslint.codeActionsOnSave': true,
                'eslint.validate': ['javascript', 'javascriptreact', 'typescript', 'typescriptreact'],
                'eslint.lintTask.enable': true,
                'typescript.format.enable': true,
                'javascript.format.enable': true,
                '[typescriptreact]': {
                    'editor.defaultFormatter': 'esbenp.prettier-vscode',
                },
                '[typescript]': {
                    'editor.defaultFormatter': 'esbenp.prettier-vscode',
                },
            }), null, 2) + "\n";
        },
    });
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.projectRootPath, '.vscode/extensions.json'),
        pipeContent: function (prev) {
            return JSON.stringify(_.merge({}, functional_1.safeJsonParse(prev), {
                recommendations: [
                    'dbaeumer.vscode-eslint',
                    'eamodio.gitlens',
                    'zhuangtongfa.material-theme',
                    'jasonhzq.vscode-pont',
                ],
            }), null, 2) + "\n";
        },
    });
}
function ensureGitignore() {
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.projectRootPath, '.gitignore'),
        pipeContent: function (prev) {
            if (prev === void 0) { prev = ''; }
            var values = prev.split('\n').filter(function (eachRule) {
                return !!eachRule;
            });
            var gitIgnoresInRoot = structor_config_1.gitIgnores.map(function (name) {
                return "/" + name;
            });
            return _.union(values, gitIgnoresInRoot).join('\n');
        },
    });
}
function ensureNpmignore() {
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.projectRootPath, '.npmignore'),
        pipeContent: function (prev) {
            if (prev === void 0) { prev = ''; }
            var values = prev.split('\n').filter(function (eachRule) {
                return !!eachRule;
            });
            var npmIgnoresInRoot = structor_config_1.npmIgnores.map(function (name) {
                return "/" + name;
            });
            return _.union(values, npmIgnoresInRoot).join('\n');
        },
    });
}
function ensureNpmrc() {
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.projectRootPath, '.npmrc'),
        pipeContent: function () {
            return "package-lock=" + (global_state_1.globalState.projectConfig.packageLock ? 'true' : 'false');
        },
    });
}
function ensureRootPackageJson() {
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.projectRootPath, 'package.json'),
        pipeContent: function (prev) {
            var prevJson = functional_1.safeJsonParse(prev);
            var priDeps = pkg.dependencies || {};
            if (node_1.pri.sourceConfig.type === 'project') {
                // Remove all packages which already exists in pri dependencies.
                if (prevJson.dependencies) {
                    prevJson.dependencies = _.omit(prevJson.dependencies, Object.keys(priDeps));
                }
                if (prevJson.devDependencies) {
                    prevJson.devDependencies = _.omit(prevJson.devDependencies, Object.keys(priDeps));
                }
                if (prevJson.peerDependencies) {
                    prevJson.peerDependencies = _.omit(prevJson.peerDependencies, Object.keys(priDeps));
                }
            }
            else {
                // Not project type, just reset it's version if exist.
                setVersionIfExist(prevJson, 'dependencies', priDeps);
                // Remove devDeps which already exists in pri dependencies.
                if (prevJson.devDependencies) {
                    prevJson.devDependencies = _.omit(prevJson.devDependencies, Object.keys(priDeps));
                }
                if (prevJson.peerDependencies) {
                    prevJson.peerDependencies = _.omit(prevJson.peerDependencies, Object.keys(priDeps));
                }
            }
            // Mv pri-plugins to devDeps except plugin
            if (node_1.pri.projectConfig.type === 'plugin') {
                prevJson = mvPriPlugins(prevJson, 'devDependencies', 'dependencies');
                prevJson = mvPriPlugins(prevJson, 'peerDependencies', 'dependencies');
            }
            else {
                prevJson = mvPriPlugins(prevJson, 'dependencies', 'devDependencies');
                prevJson = mvPriPlugins(prevJson, 'peerDependencies', 'devDependencies');
            }
            switch (node_1.pri.projectConfig.type) {
                case 'project':
                    {
                        // Move pri from devDeps to deps
                        var projectPriVersion = _.get(prevJson, "devDependencies." + constants_1.PRI_PACKAGE_NAME) ||
                            _.get(prevJson, "dependencies." + constants_1.PRI_PACKAGE_NAME) ||
                            pkg.version;
                        _.unset(prevJson, "devDependencies." + constants_1.PRI_PACKAGE_NAME);
                        _.set(prevJson, "dependencies." + constants_1.PRI_PACKAGE_NAME, projectPriVersion);
                    }
                    break;
                case 'plugin':
                    {
                        // Move pri from deps to devDeps
                        var projectPriVersion = _.get(prevJson, "devDependencies." + constants_1.PRI_PACKAGE_NAME) ||
                            _.get(prevJson, "dependencies." + constants_1.PRI_PACKAGE_NAME) ||
                            pkg.version;
                        _.unset(prevJson, "dependencies." + constants_1.PRI_PACKAGE_NAME);
                        _.set(prevJson, "devDependencies." + constants_1.PRI_PACKAGE_NAME, projectPriVersion);
                        // Add babel-runtime
                        _.set(prevJson, 'dependencies.@babel/runtime', priDeps['@babel/runtime']);
                    }
                    break;
                case 'component':
                    {
                        // Move pri from deps to devDeps
                        var projectPriVersion = _.get(prevJson, "devDependencies." + constants_1.PRI_PACKAGE_NAME) ||
                            _.get(prevJson, "dependencies." + constants_1.PRI_PACKAGE_NAME) ||
                            pkg.version;
                        _.unset(prevJson, "dependencies." + constants_1.PRI_PACKAGE_NAME);
                        _.set(prevJson, "devDependencies." + constants_1.PRI_PACKAGE_NAME, projectPriVersion);
                        // Add babel-runtime
                        _.set(prevJson, 'dependencies.@babel/runtime', priDeps['@babel/runtime']);
                    }
                    break;
                default:
            }
            switch (node_1.pri.projectConfig.type) {
                case 'project':
                    _.set(prevJson, 'main', node_1.pri.projectConfig.distDir + "/" + node_1.pri.projectConfig.outFileName);
                    break;
                case 'plugin':
                case 'component':
                    if (yargs.argv._[0] === 'dev') {
                        // Component dev mode, has a whole project struct
                        if (node_1.pri.selectedSourceType === 'root') {
                            _.set(prevJson, 'main', node_1.pri.projectConfig.distDir + "/main/src");
                            _.set(prevJson, 'module', node_1.pri.projectConfig.distDir + "/module/src");
                            _.set(prevJson, 'types', 'src');
                        }
                        else {
                            _.set(prevJson, 'main', node_1.pri.projectConfig.distDir + "/main/packages/" + node_1.pri.selectedSourceType + "/src");
                            _.set(prevJson, 'module', node_1.pri.projectConfig.distDir + "/module/packages/" + node_1.pri.selectedSourceType + "/src");
                            _.set(prevJson, 'types', "packages/" + node_1.pri.selectedSourceType + "/src");
                        }
                    }
                    else {
                        _.set(prevJson, 'main', node_1.pri.projectConfig.distDir + "/main");
                        _.set(prevJson, 'module', node_1.pri.projectConfig.distDir + "/module");
                        _.set(prevJson, 'types', 'declaration/index.d.ts');
                    }
                    break;
                default:
            }
            return JSON.stringify(_.merge({}, prevJson, commonComponentPackageJson), null, 2) + "\n";
        },
    });
}
function ensurePriConfig() {
    node_1.pri.project.addProjectFiles({
        fileName: path.join(node_1.pri.sourceRoot, constants_1.CONFIG_FILE),
        pipeContent: function (prev) {
            return JSON.stringify(_.merge({}, functional_1.safeJsonParse(prev), {
                type: node_1.pri.sourceConfig.type,
            }), null, 2) + "\n";
        },
    });
}
function setVersionIfExist(sourceObj, key, targetObj) {
    if (!_.isEmpty(_.get(sourceObj, key))) {
        Object.keys(_.get(sourceObj, key)).forEach(function (sourceObjKey) {
            if (targetObj[sourceObjKey]) {
                _.set(sourceObj, [key, sourceObjKey], targetObj[sourceObjKey]);
            }
        });
    }
}
function mvPriPlugins(obj, sourceKey, targetKey) {
    var newObj = __assign({}, obj);
    if (!obj[sourceKey]) {
        newObj[sourceKey] = {};
    }
    if (!obj[targetKey]) {
        newObj[targetKey] = {};
    }
    var priPlugins = Object.keys(obj[sourceKey] || {}).filter(function (packageName) {
        return packageName.startsWith('pri-plugin') || packageName.startsWith('@ali/pri-plugin');
    });
    // Add plugins to targetKey
    priPlugins.forEach(function (packageName) {
        newObj[targetKey][packageName] = obj[sourceKey][packageName];
    });
    // Remove plugins from sourceKey
    newObj[sourceKey] = _.omit(obj[sourceKey], priPlugins);
    return newObj;
}
//# sourceMappingURL=index.js.map