"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs-extra");
var path = require("path");
var node_1 = require("../../../node");
var constants_1 = require("../../../utils/constants");
// config
var whiteList = ['config'];
node_1.pri.project.whiteFileRules.add(function (file) {
    return whiteList.some(function (whiteName) {
        return path.format(file) === path.join(node_1.pri.projectRootPath, whiteName);
    });
});
// config/config.default|local|prod.ts
node_1.pri.project.whiteFileRules.add(function (file) {
    var relativePath = path.relative(node_1.pri.projectRootPath, file.dir);
    return (relativePath === 'config' &&
        file.ext === '.ts' &&
        (file.name === 'config.default' || file.name === 'config.local' || file.name === 'config.prod'));
});
node_1.pri.project.onAnalyseProject(function () {
    return {
        projectAnalyseConfig: {
            hasConfig: fs.existsSync(path.join(node_1.pri.projectRootPath, constants_1.CONFIG_FILE)),
        },
    };
});
//# sourceMappingURL=index.js.map