"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var normalizePath = require("normalize-path");
var path = require("path");
var node_1 = require("../../../node");
var structor_config_1 = require("../../../utils/structor-config");
var global_state_1 = require("../../../utils/global-state");
node_1.pri.project.whiteFileRules.add(function (file) {
    return global_state_1.transferToAllAbsolutePaths(path.format(structor_config_1.notFoundPath)).some(function (notFoundAbsolutePath) {
        return path.format(file) === notFoundAbsolutePath;
    });
});
node_1.pri.project.onAnalyseProject(function (files) {
    var notFoundFiles = files.filter(function (file) {
        if (path.format(file) !== path.join(node_1.pri.sourceRoot, path.format(structor_config_1.notFoundPath))) {
            return false;
        }
        return true;
    });
    return {
        projectAnalyseNotFound: { hasNotFound: notFoundFiles.length === 1 },
    };
});
node_1.pri.project.onCreateEntry(function (analyseInfo, entry) {
    if (!analyseInfo.projectAnalyseNotFound.hasNotFound) {
        return;
    }
    entry.pipeAppHeader(function (header) {
        return "\n        " + header + "\n        import NotFoundComponent from \"" + normalizePath(path.relative(path.join(node_1.pri.projectRootPath, structor_config_1.tempPath.dir), path.join(node_1.pri.sourceRoot, path.join(structor_config_1.notFoundPath.dir, structor_config_1.notFoundPath.name)))) + "\"\n      ";
    });
    entry.pipeAppRoutes(function (renderRoutes) {
        return "\n        " + renderRoutes + "\n        <Route component={NotFoundComponent} />\n      ";
    });
});
//# sourceMappingURL=index.js.map