"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var normalizePath = require("normalize-path");
var path = require("path");
var yargs = require("yargs");
var node_1 = require("../../../node");
var md5_1 = require("../../../utils/md5");
var structor_config_1 = require("../../../utils/structor-config");
var global_state_1 = require("../../../utils/global-state");
var functional_1 = require("../../../utils/functional");
var log_1 = require("../../../utils/log");
var safeName = function (str) {
    return _.upperFirst(_.camelCase(str));
};
node_1.pri.project.whiteFileRules.add(function (file) {
    return global_state_1.transferToAllAbsolutePaths(structor_config_1.pagesPath.dir).some(function (pagePath) {
        return path.format(file).startsWith(pagePath);
    });
});
node_1.pri.project.onAnalyseProject(function (files) {
    var _a;
    if (node_1.pri.sourceConfig.routes.length === 0) {
        return {
            projectAnalysePages: {
                pages: files
                    .filter(function (file) {
                    if (!functional_1.matchStructor(file, structor_config_1.pagesPath, node_1.pri.sourceRoot)) {
                        return false;
                    }
                    if (file.name !== 'index') {
                        return false;
                    }
                    if (['.tsx', '.md', '.mdx'].indexOf(file.ext) === -1) {
                        return false;
                    }
                    return true;
                })
                    .map(function (file) {
                    var routerPath = normalizePath("/" + path.relative(path.join(node_1.pri.sourceRoot, structor_config_1.pagesPath.dir), file.dir));
                    var chunkName = _.camelCase(routerPath) || 'index';
                    var relativePageFilePath = path.relative(node_1.pri.sourceRoot, file.dir + "/" + file.name);
                    var componentName = safeName(relativePageFilePath) + md5_1.md5(relativePageFilePath).slice(0, 5);
                    return {
                        routerPath: routerPath,
                        file: file,
                        chunkName: chunkName,
                        componentName: componentName,
                    };
                }),
            },
        };
    }
    var paths = ((_a = yargs.argv.path) !== null && _a !== void 0 ? _a : '').split(',').filter(function (each) { return !!each; });
    return {
        projectAnalysePages: {
            pages: node_1.pri.sourceConfig.routes
                .filter(function (route) {
                if (paths.length <= 0) {
                    return true;
                }
                return paths.includes(route.path);
            })
                .filter(function (route) {
                if (route.redirect && route.component) {
                    log_1.logFatal('route "redirect" and "component" are mutually exclusive.');
                }
                if (route.path && route.component) {
                    return true;
                }
                if (route.path && route.redirect) {
                    return true;
                }
                return false;
            })
                .map(function (route, index) {
                if (route.component) {
                    var componentFile = files.find(function (file) {
                        var relativePath = path.relative(node_1.pri.sourceRoot, path.join(file.dir, file.name));
                        return ((route.component === relativePath && !file.isDir && ['.tsx', '.md', '.mdx'].indexOf(file.ext) > -1) ||
                            (path.join(route.component, 'index') === relativePath &&
                                !file.isDir &&
                                ['.tsx', '.md', '.mdx'].indexOf(file.ext) > -1));
                    });
                    if (!componentFile) {
                        return null;
                    }
                    var routerPath = route.path;
                    var chunkName = _.camelCase(routerPath) || 'index';
                    var relativePageFilePath = path.relative(node_1.pri.sourceRoot, componentFile.dir + "/" + componentFile.name);
                    var componentName = safeName(relativePageFilePath) + md5_1.md5(relativePageFilePath).slice(0, 5);
                    return {
                        routerPath: routerPath,
                        file: componentFile,
                        chunkName: chunkName + index,
                        componentName: componentName + index,
                        redirect: route.redirect,
                    };
                }
                return {
                    routerPath: route.path,
                    redirect: route.redirect,
                };
            })
                .filter(function (route) {
                return route !== null;
            }),
        },
    };
});
node_1.pri.project.onCreateEntry(function (analyseInfo, entry) {
    if (analyseInfo.projectAnalysePages.pages.length === 0) {
        return;
    }
    entry.pipeAppComponent(function (entryComponent) { return __awaiter(void 0, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = "\n        ";
                    return [4 /*yield*/, Promise.all(analyseInfo.projectAnalysePages.pages
                            .filter(function (page) { return !!page.file; })
                            .map(function (page) { return __awaiter(void 0, void 0, void 0, function () {
                            var pageRequirePath, importCode, _a, _b;
                            return __generator(this, function (_c) {
                                switch (_c.label) {
                                    case 0:
                                        pageRequirePath = normalizePath(path.relative(path.join(node_1.pri.projectRootPath, structor_config_1.tempPath.dir), path.join(page.file.dir, page.file.name)));
                                        _a = "import(/* webpackChunkName: \"" + page.componentName + "\" */ \"" + pageRequirePath + "\").then(code => {\n                const filePath = \"" + path.format(page.file) + "\"\n\n                ";
                                        return [4 /*yield*/, entry.pipe.get('afterPageLoad', '')];
                                    case 1:
                                        _b = _a + (_c.sent()) + "\n                ";
                                        return [4 /*yield*/, entry.pipe.get('returnPageInstance', 'return code')];
                                    case 2:
                                        importCode = _b + (_c.sent()) + "\n              }),";
                                        return [2 /*return*/, "\n              const " + page.componentName + "Lazy: any = React.lazy(() => " + importCode + ");\n              const " + page.componentName + ": React.FC = props => (\n                <React.Suspense fallback={<PageLazyFallback />}>\n                  <" + page.componentName + "Lazy {...props} />\n                </React.Suspense>\n              );\n            "];
                                }
                            });
                        }); }))];
                case 1: return [2 /*return*/, _a + (_b.sent()).join('\n') + "\n          " + entryComponent + "\n      "];
            }
        });
    }); });
    entry.pipeAppComponent(function (str) {
        return "\n      " + str + "\n      " + analyseInfo.projectAnalysePages.pages
            .map(function (page) {
            return "\n            // pageLoadableMap.set(\"" + page.routerPath + "\", " + page.componentName + ")\n          ";
        })
            .join('\n') + "\n    ";
    });
    entry.pipeAppRoutes(function (renderRoutes) { return __awaiter(void 0, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = "\n        ";
                    return [4 /*yield*/, Promise.all(analyseInfo.projectAnalysePages.pages.map(function (page) { return __awaiter(void 0, void 0, void 0, function () {
                            var _a;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        if (!page.file) return [3 /*break*/, 2];
                                        _a = "\n              <";
                                        return [4 /*yield*/, entry.pipe.get('commonRoute', 'Route')];
                                    case 1: return [2 /*return*/, _a + (_b.sent()) + " exact path=\"" + page.routerPath + "\" component={" + page.componentName + "} />\n\n            "];
                                    case 2:
                                        if (page.redirect) {
                                            return [2 /*return*/, "\n              <Redirect from=\"" + page.routerPath + "\" to=\"" + page.redirect + "\" />\n\n            "];
                                        }
                                        return [2 /*return*/];
                                }
                            });
                        }); }))];
                case 1: return [2 /*return*/, _a + (_b.sent()).join('\n') + "\n        " + renderRoutes + "\n      "];
            }
        });
    }); });
});
//# sourceMappingURL=index.js.map