"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var path = require("path");
var node_1 = require("../../../node");
var constants_1 = require("../../../utils/constants");
var structor_config_1 = require("../../../utils/structor-config");
var white_file_helper_1 = require("../../../utils/white-file-helper");
var global_state_1 = require("../../../utils/global-state");
var whiteList = __spreadArray([
    constants_1.CONFIG_FILE,
    structor_config_1.srcPath.dir,
    structor_config_1.docsPath.dir,
    '.git',
    "src" + path.sep + "components"
], (node_1.pri.projectConfig.packageLock ? ['package-lock.json', 'yarn.lock'] : []));
var allIgnores = _.union(structor_config_1.gitIgnores, structor_config_1.npmIgnores).concat(whiteList);
var allAbsoluteIgnores = _.flatten(allIgnores.map(function (fileName) {
    return global_state_1.transferToAllAbsolutePaths(fileName);
}));
// Add ignore file/dir to whiteRules
node_1.pri.project.whiteFileRules.add(function (file) {
    return allAbsoluteIgnores.some(function (absoluteFilePath) {
        return path.format(file) === absoluteFilePath;
    });
});
node_1.pri.project.whiteFileRules.add(function (file) {
    return global_state_1.transferToAllAbsolutePaths(structor_config_1.utilPath.dir)
        .concat(global_state_1.transferToAllAbsolutePaths(structor_config_1.pagesPath.dir))
        .concat(global_state_1.transferToAllAbsolutePaths(structor_config_1.docsPath.dir))
        .concat(global_state_1.transferToAllAbsolutePaths(structor_config_1.typingsPath.dir))
        .concat(global_state_1.transferToAllAbsolutePaths(structor_config_1.componentPath.dir))
        .concat(global_state_1.transferToAllAbsolutePaths(structor_config_1.requestsPath.dir))
        .concat(global_state_1.transferToAllAbsolutePaths(structor_config_1.expandPath.dir))
        .concat(global_state_1.transferToAllAbsolutePaths("src" + path.sep + "layouts"))
        .concat(path.join(node_1.pri.projectRootPath, structor_config_1.packagesPath.dir))
        .concat(path.join(node_1.pri.projectRootPath, structor_config_1.pluginsPath.dir))
        .some(function (absoluteFilePath) {
        return path.format(file).startsWith(absoluteFilePath);
    });
});
white_file_helper_1.addWhiteFilesByProjectType();
//# sourceMappingURL=index.js.map