"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkProjectFiles = void 0;
var _ = require("lodash");
var path = require("path");
var global_state_1 = require("../../utils/global-state");
var log_1 = require("../../utils/log");
var plugins_1 = require("../../utils/plugins");
var walk_project_files_1 = require("../../utils/walk-project-files");
var checkProjectFiles = function () { return __awaiter(void 0, void 0, void 0, function () {
    var files, whiteFileRules;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!global_state_1.globalState.projectConfig.unexpectedFileCheck) {
                    return [2 /*return*/];
                }
                return [4 /*yield*/, walk_project_files_1.walkProjectFiles()];
            case 1:
                files = _a.sent();
                whiteFileRules = plugins_1.plugin.whiteFileRules.slice();
                files.forEach(function (file) {
                    if (!whiteFileRules.some(function (whiteFileRule) {
                        return whiteFileRule(file);
                    })) {
                        log_1.logFatal("Unexpected file or directory: " + path.format(file));
                    }
                });
                // Check for depsCheckLevel
                switch (global_state_1.globalState.projectConfig.allowDepsSemver) {
                    case 'major':
                        checkDepsLevel([]);
                        break;
                    case 'minor':
                        checkDepsLevel(['*']);
                        break;
                    case 'patch':
                        checkDepsLevel(['*', '^']);
                        break;
                    case 'fixed':
                        checkDepsLevel(['*', '^', '~']);
                        break;
                    default:
                }
                return [2 /*return*/];
        }
    });
}); };
exports.checkProjectFiles = checkProjectFiles;
function checkDepsLevel(illegalPrefixs) {
    var allDeps = __assign(__assign(__assign({}, _.get(global_state_1.globalState.projectPackageJson, 'devDependencies', {})), _.get(global_state_1.globalState.projectPackageJson, 'dependencies', {})), _.get(global_state_1.globalState.projectPackageJson, 'peerDependencies', {}));
    Object.keys(allDeps).forEach(function (depName) {
        var depVersion = allDeps[depName];
        illegalPrefixs.forEach(function (illegalPrefix) {
            switch (illegalPrefix) {
                case '*':
                    if (depVersion === '*') {
                        log_1.logFatal("Deps: \"" + depName + "\": \"" + depVersion + "\" is illegal!");
                    }
                    break;
                default:
                    if (depVersion.startsWith(illegalPrefix)) {
                        log_1.logFatal("Deps: \"" + depName + "\": \"" + depVersion + "\" is illegal!");
                    }
            }
        });
    });
}
//# sourceMappingURL=check-project-files.js.map