"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBabelOptions = void 0;
var plugin_proposal_class_properties_1 = require("@babel/plugin-proposal-class-properties");
var plugin_proposal_decorators_1 = require("@babel/plugin-proposal-decorators");
var plugin_proposal_export_namespace_from_1 = require("@babel/plugin-proposal-export-namespace-from");
var plugin_proposal_function_sent_1 = require("@babel/plugin-proposal-function-sent");
var plugin_proposal_json_strings_1 = require("@babel/plugin-proposal-json-strings");
var plugin_proposal_numeric_separator_1 = require("@babel/plugin-proposal-numeric-separator");
var plugin_proposal_optional_catch_binding_1 = require("@babel/plugin-proposal-optional-catch-binding");
var plugin_proposal_throw_expressions_1 = require("@babel/plugin-proposal-throw-expressions");
var plugin_proposal_optional_chaining_1 = require("@babel/plugin-proposal-optional-chaining");
var plugin_proposal_nullish_coalescing_operator_1 = require("@babel/plugin-proposal-nullish-coalescing-operator");
var plugin_syntax_dynamic_import_1 = require("@babel/plugin-syntax-dynamic-import");
var plugin_syntax_import_meta_1 = require("@babel/plugin-syntax-import-meta");
var plugin_transform_runtime_1 = require("@babel/plugin-transform-runtime");
var preset_env_1 = require("@babel/preset-env");
var preset_react_1 = require("@babel/preset-react");
var preset_typescript_1 = require("@babel/preset-typescript");
var babelPluginReactHotLoader = require("react-hot-loader/babel");
var _ = require("lodash");
var babel_plugin_react_wrapped_display_name_1 = require("./babel-plugin-react-wrapped-display-name");
var global_state_1 = require("./global-state");
var DefaultOptions = /** @class */ (function () {
    function DefaultOptions() {
        this.modules = 'auto';
        this.plugins = [];
    }
    return DefaultOptions;
}());
function getBabelOptions(options) {
    var mergedOptions = _.defaults(options || {}, new DefaultOptions());
    return {
        babelrc: false,
        comments: global_state_1.globalState.isDevelopment,
        presets: [[preset_env_1.default, { modules: mergedOptions.modules }], [preset_react_1.default], [preset_typescript_1.default]],
        plugins: __spreadArray(__spreadArray(__spreadArray([
            [plugin_transform_runtime_1.default]
        ], (global_state_1.globalState.isDevelopment ? [[babelPluginReactHotLoader]] : [])), [
            [plugin_proposal_decorators_1.default, { legacy: true }],
            [plugin_proposal_export_namespace_from_1.default],
            [plugin_proposal_function_sent_1.default],
            [plugin_proposal_numeric_separator_1.default],
            [plugin_proposal_throw_expressions_1.default],
            [plugin_proposal_optional_chaining_1.default],
            [babel_plugin_react_wrapped_display_name_1.babelPluginReactWrappedDisplayName],
            [plugin_proposal_nullish_coalescing_operator_1.default],
            [plugin_syntax_dynamic_import_1.default],
            [plugin_syntax_import_meta_1.default],
            [plugin_proposal_class_properties_1.default, { loose: true }],
            [plugin_proposal_json_strings_1.default],
            [plugin_proposal_optional_catch_binding_1.default]
        ]), mergedOptions.plugins),
    };
}
exports.getBabelOptions = getBabelOptions;
//# sourceMappingURL=babel-options.js.map