"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createEntry = exports.Entry = void 0;
var fs = require("fs-extra");
var path = require("path");
var node_1 = require("../node");
var pipe = require("../node/pipe");
var constants_1 = require("./constants");
var global_state_1 = require("./global-state");
var plugins_1 = require("./plugins");
var prettier_config_1 = require("./prettier-config");
var structor_config_1 = require("./structor-config");
var Entry = /** @class */ (function () {
    function Entry() {
    }
    Entry.prototype.getApp = function () {
        return __awaiter(this, void 0, void 0, function () {
            var appHeader, appBody, appComponent;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getAppHeader()];
                    case 1:
                        appHeader = _a.sent();
                        return [4 /*yield*/, this.getAppBody()];
                    case 2:
                        appBody = _a.sent();
                        return [4 /*yield*/, this.getAppComponent()];
                    case 3:
                        appComponent = _a.sent();
                        return [2 /*return*/, [appHeader, appBody, appComponent].join('\n')];
                }
            });
        });
    };
    Entry.prototype.getEntry = function () {
        return __awaiter(this, void 0, void 0, function () {
            var entryHeader, entryRender;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getEntryHeader()];
                    case 1:
                        entryHeader = _a.sent();
                        return [4 /*yield*/, this.getEntryRender()];
                    case 2:
                        entryRender = _a.sent();
                        return [2 /*return*/, [entryHeader, entryRender].join('\n')];
                }
            });
        });
    };
    Entry.prototype.getEnvironment = function () {
        return __awaiter(this, void 0, void 0, function () {
            var environmentHeader, environmentBody;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getEnvironmentHeader()];
                    case 1:
                        environmentHeader = _a.sent();
                        return [4 /*yield*/, this.getEnvironmentBody()];
                    case 2:
                        environmentBody = _a.sent();
                        return [2 /*return*/, [environmentHeader, environmentBody].join('\n')];
                }
            });
        });
    };
    Object.defineProperty(Entry.prototype, "pipe", {
        get: function () {
            return pipe;
        },
        enumerable: false,
        configurable: true
    });
    Entry.prototype.pipeAppHeader = function (fn) {
        pipe.set('appHeader', fn);
    };
    Entry.prototype.pipeAppBody = function (fn) {
        pipe.set('appBody', fn);
    };
    Entry.prototype.pipeAppComponent = function (fn) {
        pipe.set('appComponent', fn);
    };
    Entry.prototype.pipeAppClassDidMount = function (fn) {
        pipe.set('appClassDidMount', fn);
    };
    Entry.prototype.pipeAppRoutes = function (fn) {
        pipe.set('appRoutes', fn);
    };
    Entry.prototype.pipeAppRouter = function (fn) {
        pipe.set('appRouter', fn);
    };
    Entry.prototype.pipeEntryHeader = function (fn) {
        pipe.set('entryHeader', fn);
    };
    Entry.prototype.pipeEntryRender = function (fn) {
        pipe.set('entryRender', fn);
    };
    Entry.prototype.pipeEnvironmentHeader = function (fn) {
        pipe.set('environmentHeader', fn);
    };
    Entry.prototype.pipeEnvironmentBody = function (fn) {
        pipe.set('environmentBody', fn);
    };
    Entry.prototype.getAppHeader = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, pipe.get('appHeader', "\n      import './environment'\n\n      import { createBrowserHistory } from \"history\"\n      import { history as customHistory } from \"" + constants_1.PRI_PACKAGE_NAME + "/client\"\n      import * as React from \"react\"\n      import * as ReactDOM from \"react-dom\"\n      import { Redirect, Route, Router, Switch, HashRouter } from \"react-router-dom\"\n    ")];
            });
        });
    };
    Entry.prototype.getAppBody = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, pipe.get('appBody', "\n      // export const pageLoadableMap = new Map<string, any>()\n      const PageLazyFallback = () => <div />;\n    ")];
            });
        });
    };
    Entry.prototype.getAppComponent = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d, _e, _f;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        _b = (_a = pipe).get;
                        _c = ['appComponent'];
                        _d = "\n      class App extends React.PureComponent<any, any> {\n        public componentDidMount() {\n          ";
                        return [4 /*yield*/, this.getAppClassDidMount()];
                    case 1:
                        _e = _d + (_g.sent()) + "\n        }\n\n        public render() {\n          return (\n            ";
                        return [4 /*yield*/, this.getAppRouter()];
                    case 2:
                        _f = _e + (_g.sent()) + "\n          )\n        }\n      }\n\n      export default ";
                        return [4 /*yield*/, pipe.get('appExportName', 'App')];
                    case 3: return [2 /*return*/, _b.apply(_a, _c.concat([_f + (_g.sent()) + "\n    "]))];
                }
            });
        });
    };
    Entry.prototype.getAppRoutes = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, pipe.get('appRoutes', '')];
            });
        });
    };
    Entry.prototype.getAppRouter = function () {
        return __awaiter(this, void 0, void 0, function () {
            var routerName, historyInfo, _a, _b, _c, _d, _e, _f;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        routerName = global_state_1.globalState.sourceConfig.useHashRouter ? 'HashRouter' : 'Router';
                        if (!global_state_1.globalState.sourceConfig.useHashRouter) return [3 /*break*/, 1];
                        _a = '';
                        return [3 /*break*/, 3];
                    case 1:
                        _b = "\n      history={";
                        return [4 /*yield*/, pipe.get('appRouterHistory', 'customHistory')];
                    case 2:
                        _a = _b + (_g.sent()) + "}\n    ";
                        _g.label = 3;
                    case 3:
                        historyInfo = _a;
                        _d = (_c = pipe).get;
                        _e = ['appRouter'];
                        _f = "\n      <" + routerName + " " + historyInfo + ">\n        <Switch>\n          ";
                        return [4 /*yield*/, this.getAppRoutes()];
                    case 4: return [2 /*return*/, _d.apply(_c, _e.concat([_f + (_g.sent()) + "\n        </Switch>\n      </" + routerName + ">\n    "]))];
                }
            });
        });
    };
    Entry.prototype.getAppClassDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, pipe.get('appClassDidMount', '')];
            });
        });
    };
    Entry.prototype.getEntryHeader = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, pipe.get('entryHeader', "\n      import * as React from \"react\"\n      import * as ReactDOM from \"react-dom\"\n      import App from \"./app\"\n\n      const ROOT_ID = \"" + node_1.pri.sourceConfig.projectRootId + "\"\n    ")];
            });
        });
    };
    Entry.prototype.getEntryRender = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d, _e;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        _b = (_a = pipe).get;
                        _c = ['entryRender'];
                        _d = "\n      // Create entry div if not exist.\n      if (!document.getElementById(ROOT_ID)) {\n        const rootDiv = document.createElement(\"div\")\n        rootDiv.id = ROOT_ID\n        document.body.appendChild(rootDiv)\n      }\n\n      if ((window as any).enableSsr) {\n        // Need wait preloadAll, because we already have ssr html.\n        // TODO:\n        // Loadable.preloadAll().then(() => {\n        //   (ReactDOM as any).hydrate(";
                        return [4 /*yield*/, pipe.get('entryRenderApp', '<App />')];
                    case 1:
                        _e = _d + (_f.sent()) + ", document.getElementById(ROOT_ID))\n        // })\n      } else {\n        ReactDOM.render(";
                        return [4 /*yield*/, pipe.get('entryRenderApp', '<App />')];
                    case 2: return [2 /*return*/, _b.apply(_a, _c.concat([_e + (_f.sent()) + ", document.getElementById(ROOT_ID))\n      }\n    "]))];
                }
            });
        });
    };
    Entry.prototype.getEnvironmentHeader = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, pipe.get('environmentHeader', '')];
            });
        });
    };
    Entry.prototype.getEnvironmentBody = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, pipe.get('environmentBody', "\n      let priStore: any = {};\n        \n      const tag = 'pri';\n      if ((window as any)[tag]) {\n        priStore = (window as any)[tag];\n      } else {\n        (window as any)[tag] = priStore;\n      }\n\n      export {};\n    ")];
            });
        });
    };
    return Entry;
}());
exports.Entry = Entry;
function createEntry() {
    return __awaiter(this, void 0, void 0, function () {
        var newEntryObject, _i, _a, projectCreateEntry, environmentPath, entryPath, appPath, environment, app, entry, prettier;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    newEntryObject = new Entry();
                    _i = 0, _a = plugins_1.plugin.projectCreateEntrys;
                    _b.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 4];
                    projectCreateEntry = _a[_i];
                    return [4 /*yield*/, projectCreateEntry(plugins_1.plugin.analyseInfo, newEntryObject)];
                case 2:
                    _b.sent();
                    _b.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4:
                    environmentPath = path.join(global_state_1.globalState.projectRootPath, path.format(structor_config_1.tempEnvironmentPath));
                    entryPath = path.join(global_state_1.globalState.projectRootPath, path.format(structor_config_1.tempJsEntryPath));
                    appPath = path.join(global_state_1.globalState.projectRootPath, path.format(structor_config_1.tempJsAppPath));
                    return [4 /*yield*/, newEntryObject.getEnvironment()];
                case 5:
                    environment = _b.sent();
                    return [4 /*yield*/, newEntryObject.getApp()];
                case 6:
                    app = _b.sent();
                    return [4 /*yield*/, newEntryObject.getEntry()];
                case 7:
                    entry = _b.sent();
                    return [4 /*yield*/, Promise.resolve().then(function () { return require('prettier'); })];
                case 8:
                    prettier = _b.sent();
                    fs.outputFileSync(environmentPath, prettier.format(environment, __assign(__assign({}, prettier_config_1.prettierConfig), { parser: 'typescript' })));
                    fs.outputFileSync(appPath, prettier.format(app, __assign(__assign({}, prettier_config_1.prettierConfig), { parser: 'typescript' })));
                    fs.outputFileSync(entryPath, prettier.format(entry, __assign(__assign({}, prettier_config_1.prettierConfig), { parser: 'typescript' })));
                    return [2 /*return*/, entryPath];
            }
        });
    });
}
exports.createEntry = createEntry;
//# sourceMappingURL=create-entry.js.map