"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ensureFile = exports.ensureFiles = void 0;
var fs = require("fs-extra");
var _ = require("lodash");
var path = require("path");
var log_1 = require("./log");
var plugins_1 = require("./plugins");
var pri_events_1 = require("./pri-events");
var global_state_1 = require("./global-state");
var ensureFiles = function () { return __awaiter(void 0, void 0, void 0, function () {
    var ensureProjectFilesQueueGroupByPath;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!global_state_1.globalState.sourceConfig.ensureFiles) {
                    return [2 /*return*/];
                }
                pri_events_1.priEvent.emit('beforeEnsureFiles');
                ensureProjectFilesQueueGroupByPath = _.groupBy(plugins_1.plugin.ensureProjectFilesQueue, 'fileName');
                return [4 /*yield*/, Promise.all(Object.keys(ensureProjectFilesQueueGroupByPath).map(function (filePath) { return __awaiter(void 0, void 0, void 0, function () {
                        var ensureProjectFilesQueue;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    ensureProjectFilesQueue = ensureProjectFilesQueueGroupByPath[filePath];
                                    return [4 /*yield*/, ensureFile(filePath, ensureProjectFilesQueue.map(function (ensureProjectFiles) {
                                            return ensureProjectFiles.pipeContent;
                                        }))];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); }))];
            case 1:
                _a.sent();
                // Fresh package.json
                return [4 /*yield*/, global_state_1.freshGlobalState(global_state_1.globalState.selectedSourceType)];
            case 2:
                // Fresh package.json
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.ensureFiles = ensureFiles;
function ensureFile(filePath, pipeContents) {
    return __awaiter(this, void 0, void 0, function () {
        var fileExist, exitFileContent, nextContent;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!path.isAbsolute(filePath)) {
                        log_1.logFatal("Plugin error: ensureProjectFiles path need be absolute path, not: " + filePath);
                    }
                    fileExist = fs.existsSync(filePath);
                    exitFileContent = '';
                    try {
                        exitFileContent = fs.readFileSync(filePath, 'utf8').toString();
                    }
                    catch (error) {
                        //
                    }
                    return [4 /*yield*/, pipeContents.reduce(function (preContent, pipeContent) { return __awaiter(_this, void 0, void 0, function () {
                            var _a, _b, _c;
                            return __generator(this, function (_d) {
                                switch (_d.label) {
                                    case 0:
                                        _b = (_a = Promise).resolve;
                                        _c = pipeContent;
                                        return [4 /*yield*/, preContent];
                                    case 1: return [2 /*return*/, _b.apply(_a, [_c.apply(void 0, [_d.sent()])])];
                                }
                            });
                        }); }, Promise.resolve(exitFileContent))];
                case 1:
                    nextContent = _a.sent();
                    if (fileExist) {
                        if (exitFileContent === nextContent) {
                            // skipped not log
                        }
                        else {
                            log_1.logWarn(filePath + " exist, but the content is not correct, has been recovered.");
                        }
                    }
                    else {
                        log_1.logInfo(filePath + " not exist, created.");
                    }
                    fs.outputFileSync(filePath, nextContent);
                    return [2 /*return*/];
            }
        });
    });
}
exports.ensureFile = ensureFile;
//# sourceMappingURL=ensure-files.js.map