"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.exec = void 0;
var child_process_1 = require("child_process");
var _ = require("lodash");
var global_state_1 = require("./global-state");
function exec(shell, options) {
    return new Promise(function (resolve, reject) {
        var newOptions = options ? __assign({}, options) : {};
        // 默认在 projectRootPath 下执行
        if (!newOptions.cwd) {
            newOptions.cwd = global_state_1.globalState.projectRootPath;
        }
        child_process_1.exec(shell, newOptions, function (error, stdOut) {
            if (error) {
                reject(error.toString());
            }
            else {
                resolve(_.trim(stdOut.toString()));
            }
        });
    });
}
exports.exec = exec;
//# sourceMappingURL=exec.js.map