"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writePackageJson = exports.getPackageJson = exports.runInTempFolderAndDestroyAfterFinished = void 0;
var crypto = require("crypto");
var fs = require("fs-extra");
var path = require("path");
var exec_1 = require("./exec");
var log_1 = require("./log");
function getRandomFolderPath() {
    var ramdomId = crypto.randomBytes(20).toString('hex');
    return path.join(process.env.HOME, ".cardTemp" + ramdomId);
}
function runInTempFolderAndDestroyAfterFinished(fn) {
    return __awaiter(this, void 0, void 0, function () {
        var tempFolderPath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    tempFolderPath = getRandomFolderPath();
                    if (fs.existsSync(tempFolderPath)) {
                        log_1.logFatal('error code: 1');
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, , 4, 6]);
                    // Create temp folder
                    return [4 /*yield*/, exec_1.exec("mkdir -p " + tempFolderPath)];
                case 2:
                    // Create temp folder
                    _a.sent();
                    // Run callback
                    return [4 /*yield*/, fn.apply(null, [tempFolderPath])];
                case 3:
                    // Run callback
                    _a.sent();
                    return [3 /*break*/, 6];
                case 4: 
                // Remove when finished it.
                return [4 /*yield*/, exec_1.exec("rm -rf " + tempFolderPath)];
                case 5:
                    // Remove when finished it.
                    _a.sent();
                    return [7 /*endfinally*/];
                case 6: return [2 /*return*/];
            }
        });
    });
}
exports.runInTempFolderAndDestroyAfterFinished = runInTempFolderAndDestroyAfterFinished;
function getPackageJson(projectPath) {
    return __awaiter(this, void 0, void 0, function () {
        var packageJsonPath;
        return __generator(this, function (_a) {
            packageJsonPath = path.join(projectPath, 'package.json');
            if (!fs.existsSync(projectPath)) {
                return [2 /*return*/, {}];
            }
            return [2 /*return*/, fs.readJson(packageJsonPath)];
        });
    });
}
exports.getPackageJson = getPackageJson;
function writePackageJson(projectPath, packageJson) {
    return __awaiter(this, void 0, void 0, function () {
        var packageJsonPath;
        return __generator(this, function (_a) {
            packageJsonPath = path.join(projectPath, 'package.json');
            fs.outputFileSync(packageJsonPath, JSON.stringify(packageJson, null, 2) + "\n");
            return [2 /*return*/];
        });
    });
}
exports.writePackageJson = writePackageJson;
//# sourceMappingURL=file-operate.js.map