"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.matchStructor = exports.safeJsonParse = exports.ensureStartWithWebpackRelativePoint = exports.ensureStartWithSlash = exports.ensureEndWithSlash = exports.pipeEvent = void 0;
var path = require("path");
var pipeEvent = function (func) {
    return function (event) {
        return func(event.target.value, event);
    };
};
exports.pipeEvent = pipeEvent;
function ensureEndWithSlash(str) {
    if (str.endsWith('/')) {
        return str;
    }
    return str + "/";
}
exports.ensureEndWithSlash = ensureEndWithSlash;
function ensureStartWithSlash(str) {
    if (str.startsWith('/')) {
        return str;
    }
    return "/" + str;
}
exports.ensureStartWithSlash = ensureStartWithSlash;
function ensureStartWithWebpackRelativePoint(str) {
    if (str.startsWith('/')) {
        throw Error(str + " is an absolute path!");
    }
    if (!str.startsWith('./') && !str.startsWith('../')) {
        return "./" + str;
    }
    return str;
}
exports.ensureStartWithWebpackRelativePoint = ensureStartWithWebpackRelativePoint;
function safeJsonParse(text) {
    try {
        return JSON.parse(text);
    }
    catch (_a) {
        return {};
    }
}
exports.safeJsonParse = safeJsonParse;
function matchStructor(file, target, prefixPath) {
    var fileAbsolutePath = path.format(file);
    if (!target.name && !target.ext) {
        // target is a dir
        return fileAbsolutePath.startsWith(path.join(prefixPath, target.dir));
    }
    // target is a file
    return fileAbsolutePath === path.join(prefixPath, path.format(target));
}
exports.matchStructor = matchStructor;
//# sourceMappingURL=functional.js.map