"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCurrentBranchName = exports.isWorkingTreeClean = exports.getStatus = exports.checkGitVersion = void 0;
var semver = require("semver");
var exec_1 = require("./exec");
var log_1 = require("./log");
var hasCheckGitVersion = false;
var gitVersionWarning = null;
var checkGitVersion = function (cwd) { return __awaiter(void 0, void 0, void 0, function () {
    var gitVersion, gitVersionPorcelain;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (hasCheckGitVersion) {
                    return [2 /*return*/, validateGitVersion()];
                }
                hasCheckGitVersion = true;
                return [4 /*yield*/, exec_1.exec('git --version', { cwd: cwd })];
            case 1:
                gitVersion = _a.sent();
                try {
                    gitVersionPorcelain = /git\s+version\s+([0-9.]+)/g.exec(gitVersion)[1];
                    if (semver.lte(gitVersionPorcelain, '2.14.0')) {
                        log_1.logFatal("Your git version is outdate, should upgrade to 2.14.1 and above, current version: " + gitVersionPorcelain);
                    }
                }
                catch (_b) {
                    //
                }
                validateGitVersion();
                return [2 /*return*/];
        }
    });
}); };
exports.checkGitVersion = checkGitVersion;
function validateGitVersion() {
    if (gitVersionWarning === null) {
        //
    }
    else {
        log_1.logFatal(gitVersionWarning);
    }
}
var getStatus = function (cwd) { return __awaiter(void 0, void 0, void 0, function () {
    var gitStatus;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exports.checkGitVersion(cwd)];
            case 1:
                _a.sent();
                return [4 /*yield*/, exec_1.exec('git status --porcelain', { cwd: cwd })];
            case 2:
                gitStatus = _a.sent();
                return [2 /*return*/, gitStatus];
        }
    });
}); };
exports.getStatus = getStatus;
var isWorkingTreeClean = function (cwd) { return __awaiter(void 0, void 0, void 0, function () {
    var status;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exports.getStatus(cwd)];
            case 1:
                status = _a.sent();
                if (status.trim() === '') {
                    return [2 /*return*/, true];
                }
                return [2 /*return*/, false];
        }
    });
}); };
exports.isWorkingTreeClean = isWorkingTreeClean;
var getCurrentBranchName = function (cwd) { return __awaiter(void 0, void 0, void 0, function () {
    var branchName;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exec_1.exec('git rev-parse --abbrev-ref HEAD 2>/dev/null', { cwd: cwd })];
            case 1:
                branchName = _a.sent();
                return [2 /*return*/, branchName];
        }
    });
}); };
exports.getCurrentBranchName = getCurrentBranchName;
//# sourceMappingURL=git-operate.js.map