"use strict";
/**
 * Collect some information for current project.
 * Global state will be assigned in highest priority.
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transferToAllAbsolutePaths = exports.globalState = exports.freshProjectConfig = exports.freshGlobalState = exports.initGlobalState = void 0;
var fs = require("fs-extra");
var lodash_1 = require("lodash");
var path = require("path");
var yargs = require("yargs");
var inquirer = require("inquirer");
var pkg = require("../../package.json");
var constants_1 = require("./constants");
var log_1 = require("./log");
var define_1 = require("./define");
var globalState = new define_1.GlobalState();
exports.globalState = globalState;
function initGlobalState(preSelectPackage) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    globalState.priPackageJson = pkg;
                    globalState.majorCommand = yargs.argv._.length === 0 ? 'dev' : yargs.argv._[0];
                    globalState.isDevelopment = ['dev', 'docs'].some(function (operate) {
                        return operate === globalState.majorCommand;
                    });
                    return [4 /*yield*/, freshGlobalState(preSelectPackage)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.initGlobalState = initGlobalState;
function freshGlobalState(preSelectPackage) {
    return __awaiter(this, void 0, void 0, function () {
        var cliCurrentPath, projectPackageJsonPath, projectPackageJson;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cliCurrentPath = yargs.argv.cwd || process.cwd();
                    globalState.projectRootPath = cliCurrentPath;
                    return [4 /*yield*/, initPackages(cliCurrentPath, preSelectPackage)];
                case 1:
                    _a.sent();
                    freshProjectConfig();
                    projectPackageJsonPath = path.join(globalState.projectRootPath, 'package.json');
                    if (fs.existsSync(projectPackageJsonPath)) {
                        projectPackageJson = fs.readJsonSync(projectPackageJsonPath, { throws: false }) || {};
                        globalState.projectPackageJson = projectPackageJson;
                    }
                    else {
                        log_1.logFatal('No package.json, please run "npm init" first.');
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.freshGlobalState = freshGlobalState;
function freshProjectConfig() {
    globalState.projectConfig = lodash_1.merge(new define_1.ProjectConfig(), getPriConfig(globalState.projectRootPath));
    globalState.packages = globalState.packages.map(function (eachPackage) {
        return __assign(__assign({}, eachPackage), { 
            // Merge projectConfig and sourceConfig
            config: __assign(__assign({}, lodash_1.omit(globalState.projectConfig, ['type'])), getPriConfig(eachPackage.rootPath)) });
    });
    if (globalState.selectedSourceType === 'root') {
        globalState.sourceConfig = __assign({}, globalState.projectConfig);
    }
    else {
        globalState.sourceConfig = globalState.packages.find(function (eachPackage) {
            return eachPackage.name === globalState.selectedSourceType;
        }).config;
    }
}
exports.freshProjectConfig = freshProjectConfig;
function getPriConfig(rootPath) {
    var configFilePath = path.join(rootPath, constants_1.CONFIG_FILE);
    return fs.readJsonSync(configFilePath, { throws: false }) || {};
}
function collectPackages(packageRootPath, packageDir, deep) {
    if (packageDir === void 0) { packageDir = constants_1.PACKAGES_NAME; }
    if (deep === void 0) { deep = 0; }
    // Only support three level packages
    if (deep >= 3) {
        return;
    }
    var currentPackagesPath = path.join(packageRootPath, packageDir);
    if (fs.existsSync(currentPackagesPath)) {
        fs.readdirSync(currentPackagesPath)
            .filter(function (folderName) {
            if (folderName === '.DS_Store') {
                return false;
            }
            return true;
        })
            .forEach(function (folderName) {
            var packagePath = path.join(packageRootPath, packageDir, folderName);
            var packageJson = fs.readJSONSync(path.join(packagePath, 'package.json'), { throws: false });
            var config = fs.readJsonSync(path.join(packagePath, constants_1.CONFIG_FILE), { throws: false }) || {};
            var eachPackage = {
                name: folderName,
                rootPath: packagePath,
                packageJson: packageJson,
                config: config,
            };
            if (packageDir === constants_1.PLUGINS_NAME) {
                globalState.plugins.push(eachPackage);
            }
            else {
                globalState.packages.push(eachPackage);
            }
            // find nested packages
            if (packageDir !== constants_1.PLUGINS_NAME) {
                collectPackages(eachPackage.rootPath, packageDir, deep + 1);
            }
        });
    }
}
function initPackages(projectRootPath, preSelectPackage) {
    return __awaiter(this, void 0, void 0, function () {
        var inquirerInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    collectPackages(projectRootPath);
                    collectPackages(projectRootPath, constants_1.PLUGINS_NAME);
                    if (!(globalState.packages.length > 0)) return [3 /*break*/, 3];
                    if (!!preSelectPackage) return [3 /*break*/, 2];
                    return [4 /*yield*/, inquirer.prompt([
                            {
                                message: 'Choose packages',
                                name: 'packageName',
                                type: 'list',
                                choices: __spreadArray([
                                    { name: 'Root (Current Project)', value: 'root' },
                                    new inquirer.Separator()
                                ], globalState.packages.map(function (eachPackage) {
                                    return {
                                        name: "Package: " + eachPackage.name,
                                        value: eachPackage.name,
                                    };
                                })),
                            },
                        ])];
                case 1:
                    inquirerInfo = _a.sent();
                    globalState.selectedSourceType = inquirerInfo.packageName;
                    return [3 /*break*/, 3];
                case 2:
                    if (preSelectPackage !== 'root' &&
                        !globalState.packages.some(function (eachPackage) {
                            return eachPackage.name === preSelectPackage;
                        })) {
                        log_1.logFatal("No package " + preSelectPackage);
                    }
                    globalState.selectedSourceType = preSelectPackage;
                    _a.label = 3;
                case 3:
                    switch (globalState.selectedSourceType) {
                        case 'root':
                            globalState.sourceRoot = projectRootPath;
                            break;
                        default:
                            globalState.sourceRoot = globalState.packages.find(function (eachPackage) { return eachPackage.name === globalState.selectedSourceType; }).rootPath;
                    }
                    return [2 /*return*/];
            }
        });
    });
}
/**
 * Transfer relative path to absolute paths, include root and pacakges.
 */
function transferToAllAbsolutePaths(relatePath) {
    if (path.isAbsolute(relatePath)) {
        throw Error(relatePath + " is not a relative path.");
    }
    return __spreadArray([
        path.join(globalState.projectRootPath, relatePath)
    ], globalState.packages.map(function (eachPackage) {
        return path.join(eachPackage.rootPath, relatePath);
    }));
}
exports.transferToAllAbsolutePaths = transferToAllAbsolutePaths;
//# sourceMappingURL=global-state.js.map