"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.lint = exports.eslintParam = void 0;
var child_process_1 = require("child_process");
var colors = require("colors");
var _ = require("lodash");
var path = require("path");
var glob = require("glob");
var fs = require("fs-extra");
var log_1 = require("./log");
var global_state_1 = require("./global-state");
var structor_config_1 = require("./structor-config");
var type_checker_1 = require("./type-checker");
exports.eslintParam = "'./?(src|packages|docs|tests)/**/*.?(ts|tsx)'";
var DefaultOptions = /** @class */ (function () {
    function DefaultOptions() {
        this.lintAll = false;
        this.needFix = true;
        this.showBreakError = true;
        this.typeCheck = false;
    }
    return DefaultOptions;
}());
function lint(options) {
    var _a, _b, _c, _d;
    return __awaiter(this, void 0, void 0, function () {
        var CLIEngine, lintRules, mergedOptions, eslintIgnorePath, eslintIgnoreExist, cli, lintFiles, prettierFiles, lintFilesPattern, lintResult, summaryText, fixedFilePaths;
        var _this = this;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    // https://nodejs.org/api/process.html#process_a_note_on_process_i_o
                    // 通过 child_process 运行 pri，stdio 设置 pipe 模式时, 标准输出是异步的, 导致输出被截断,
                    // 此处判断在 pipe 模式设置成同步输出
                    if (!process.stdout.isTTY) {
                        // eslint-disable-next-line no-underscore-dangle
                        (_b = (_a = process.stdout) === null || _a === void 0 ? void 0 : _a._handle) === null || _b === void 0 ? void 0 : _b.setBlocking(true);
                        // eslint-disable-next-line no-underscore-dangle
                        (_d = (_c = process.stderr) === null || _c === void 0 ? void 0 : _c._handle) === null || _d === void 0 ? void 0 : _d.setBlocking(true);
                    }
                    return [4 /*yield*/, Promise.resolve().then(function () { return require('eslint'); })];
                case 1:
                    CLIEngine = (_e.sent()).CLIEngine;
                    lintRules = fs.readJsonSync(path.join(global_state_1.globalState.projectRootPath, '.eslintrc'));
                    mergedOptions = _.defaults(options || {}, new DefaultOptions());
                    eslintIgnorePath = path.join(global_state_1.globalState.projectRootPath, '.eslintignore');
                    eslintIgnoreExist = fs.existsSync(eslintIgnorePath);
                    cli = new CLIEngine(__assign(__assign({}, lintRules), { fix: mergedOptions.needFix, ignore: true, ignorePath: eslintIgnoreExist ? eslintIgnorePath : null, 
                        // TODO: 临时加进来，@琳峰 记得改造
                        globals: ['API', 'defs'] }));
                    lintFiles = [];
                    prettierFiles = [];
                    lintFilesPattern = '';
                    if (mergedOptions.lintAll) {
                        if (global_state_1.globalState.selectedSourceType === 'root') {
                            lintFilesPattern = global_state_1.globalState.projectRootPath + "/{" + structor_config_1.srcPath.dir + "," + structor_config_1.packagesPath.dir + "}/**/*.{ts,tsx}";
                            lintFiles = glob.sync(lintFilesPattern);
                            lintFilesPattern = "\"" + lintFilesPattern + "\"";
                        }
                        else {
                            // eslint-disable-next-line max-len
                            lintFilesPattern = global_state_1.globalState.projectRootPath + "/" + structor_config_1.packagesPath.dir + "/" + global_state_1.globalState.selectedSourceType + "/**/*.{ts,tsx}";
                            lintFiles = glob.sync(lintFilesPattern);
                            lintFilesPattern = "\"" + lintFilesPattern + "\"";
                        }
                    }
                    else {
                        lintFiles = _.compact(child_process_1.execSync('git diff --cached --name-only --diff-filter=ACM').toString().split('\n'))
                            .filter(function (file) {
                            return file.match(/^(src|packages).+(ts|tsx)$/);
                        })
                            .map(function (file) {
                            return path.join(global_state_1.globalState.projectRootPath, file);
                        });
                        lintFilesPattern = lintFiles.filter(function (file) { return !cli.isPathIgnored(file); }).join(' ');
                    }
                    lintFiles = lintFiles.filter(function (file) { return !cli.isPathIgnored(file); });
                    return [4 /*yield*/, log_1.spinner("Lint " + (mergedOptions.lintAll ? 'all' : '') + " " + lintFiles.length + " files.", function () { return __awaiter(_this, void 0, void 0, function () {
                            var files;
                            return __generator(this, function (_a) {
                                files = child_process_1.execSync("npx prettier --ignore-path " + eslintIgnorePath + " --list-different --write " + lintFilesPattern);
                                prettierFiles = _.compact(files.toString().split('\n'));
                                return [2 /*return*/, cli.executeOnFiles(lintFiles)];
                            });
                        }); })];
                case 2:
                    lintResult = _e.sent();
                    summaryText = [
                        lintResult.errorCount + lintResult.warningCount + " problems (" + lintResult.errorCount + " errors, " + lintResult.warningCount + " warnings)",
                        lintResult.fixableErrorCount + " error and " + lintResult.fixableWarningCount + " warnings potentially fixable.",
                    ].join('\n');
                    if (mergedOptions.needFix) {
                        CLIEngine.outputFixes(lintResult);
                    }
                    if (lintResult.errorCount > 0) {
                        if (lintResult.warningCount > 0) {
                            // eslint-disable-next-line no-console
                            console.log('');
                            // eslint-disable-next-line no-console
                            console.log(colors.yellow('Warnings:'));
                            // eslint-disable-next-line no-console
                            console.log('');
                        }
                        // Warnings
                        lintResult.results
                            .filter(function (eachMessage) { return eachMessage.warningCount > 0; })
                            .forEach(function (eachLintResult) {
                            eachLintResult.messages
                                .filter(function (eachMessage) { return eachMessage.severity === 1; })
                                .forEach(function (eachMessage) {
                                var colorText = colors.yellow('warning');
                                // eslint-disable-next-line no-console
                                console.log(colors.underline(eachLintResult.filePath + ":" + eachMessage.line + ":" + eachMessage.column));
                                // eslint-disable-next-line no-console
                                console.log("  " + colorText + "  " + eachMessage.message + "  " + colors.grey(eachMessage.ruleId));
                            });
                        });
                        if (lintResult.errorCount > 0) {
                            // eslint-disable-next-line no-console
                            console.log('');
                            // eslint-disable-next-line no-console
                            console.log(colors.red('Errors:'));
                            // eslint-disable-next-line no-console
                            console.log('');
                        }
                        // Errors
                        lintResult.results
                            .filter(function (eachMessage) { return eachMessage.errorCount > 0; })
                            .forEach(function (eachLintResult) {
                            eachLintResult.messages
                                .filter(function (eachMessage) { return eachMessage.severity === 2; })
                                .forEach(function (eachMessage) {
                                var colorText = mergedOptions.showBreakError ? colors.red('error') : colors.yellow('error');
                                // eslint-disable-next-line no-console
                                console.log(colors.underline(eachLintResult.filePath + ":" + eachMessage.line + ":" + eachMessage.column));
                                // eslint-disable-next-line no-console
                                console.log("  " + colorText + "  " + eachMessage.message + "  " + colors.grey(eachMessage.ruleId));
                            });
                        });
                        if (mergedOptions.showBreakError) {
                            // eslint-disable-next-line no-console
                            console.log("\n" + colors.red(summaryText));
                        }
                        else {
                            // eslint-disable-next-line no-console
                            console.log("\n" + colors.yellow(summaryText));
                        }
                        if (mergedOptions.showBreakError) {
                            process.exit(1);
                        }
                    }
                    if (mergedOptions.needFix && (lintResult.results.some(function (each) { return each.output; }) || prettierFiles.length > 0)) {
                        fixedFilePaths = _.uniq(lintResult.results
                            .filter(function (each) { return each.output; })
                            .map(function (item) { return item.filePath; })
                            .concat(prettierFiles));
                        // eslint-disable-next-line no-console
                        console.log(colors.yellow(fixedFilePaths.length + " files autofixed, please recheck your code."));
                        child_process_1.execSync("git add " + fixedFilePaths.join(' '));
                    }
                    if (mergedOptions.typeCheck) {
                        type_checker_1.typeChecker();
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.lint = lint;
//# sourceMappingURL=lint.js.map