"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findNearestNodemodulesFile = exports.findNearestNodemodules = void 0;
var fs = require("fs");
var path = require("path");
var log_1 = require("./log");
var findNearestNodemodules = function () {
    return findNearestNodemodulesByPath(__dirname);
};
exports.findNearestNodemodules = findNearestNodemodules;
var findNearestNodemodulesFile = function (tryRelativeFilePath) {
    try {
        var nodemodulePath = findNearestNodemodulesByPath(__dirname, tryRelativeFilePath);
        return path.join(nodemodulePath, tryRelativeFilePath);
    }
    catch (error) {
        log_1.logFatal(tryRelativeFilePath + " not found!");
    }
};
exports.findNearestNodemodulesFile = findNearestNodemodulesFile;
function findNearestNodemodulesByPath(filePath, tryRelativeFilePath) {
    if (filePath === '/') {
        throw Error('Not found');
    }
    var findPath = path.join(filePath, 'node_modules');
    if (fs.existsSync(findPath)) {
        if (!tryRelativeFilePath) {
            return findPath;
        }
        var tryAbsoluteFilePath = path.join(findPath, tryRelativeFilePath);
        if (fs.existsSync(tryAbsoluteFilePath)) {
            return findPath;
        }
    }
    // Find parent dir
    return findNearestNodemodulesByPath(path.resolve(filePath, '..'), tryRelativeFilePath);
}
//# sourceMappingURL=npm-finder.js.map