"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMonoAndNpmDepsByPath = exports.getMonoAndNpmDepsOnce = exports.ensurePackagesLinks = exports.getPackages = void 0;
var fs = require("fs-extra");
var _ = require("lodash");
var fp = require("lodash/fp");
var path = require("path");
var glob = require("glob");
var exec_1 = require("./exec");
var file_operate_1 = require("./file-operate");
var global_state_1 = require("./global-state");
var node_1 = require("../node");
var log_1 = require("./log");
var structor_config_1 = require("./structor-config");
exports.getPackages = (function () {
    var result = null;
    // Ensure run once in each command.
    return function foo(useCache) {
        if (useCache === void 0) { useCache = true; }
        return __awaiter(this, void 0, void 0, function () {
            var submoduleStatus, submodulePaths;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (useCache && result) {
                            return [2 /*return*/, result];
                        }
                        return [4 /*yield*/, exec_1.exec("git submodule status | awk '{ print $2 }'")];
                    case 1:
                        submoduleStatus = _a.sent();
                        submodulePaths = submoduleStatus
                            .split('\n')
                            .map(function (each) {
                            return each.trim();
                        })
                            .filter(function (each) {
                            return !!each;
                        });
                        return [4 /*yield*/, Promise.all(submodulePaths.map(function (submodulePath) { return __awaiter(_this, void 0, void 0, function () {
                                var packagesPathEndWithSep, submoduleName, submodulePackageJson;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            packagesPathEndWithSep = structor_config_1.packagesPath.dir.endsWith(path.sep)
                                                ? structor_config_1.packagesPath.dir
                                                : structor_config_1.packagesPath.dir + path.sep;
                                            submoduleName = submodulePath.replace(new RegExp("^" + packagesPathEndWithSep), '');
                                            return [4 /*yield*/, file_operate_1.getPackageJson(path.join(global_state_1.globalState.projectRootPath, submodulePath))];
                                        case 1:
                                            submodulePackageJson = _a.sent();
                                            return [2 /*return*/, {
                                                    name: submoduleName,
                                                    path: submodulePath,
                                                    packageJson: submodulePackageJson,
                                                }];
                                    }
                                });
                            }); }))];
                    case 2:
                        result = _a.sent();
                        result = result.filter(function (eachResult) {
                            return !_.isEmpty(eachResult.packageJson);
                        });
                        return [2 /*return*/, result];
                }
            });
        });
    };
})();
function ensurePackagesLinks(useCache) {
    return __awaiter(this, void 0, void 0, function () {
        var packages, _i, packages_1, packageInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exports.getPackages(useCache)];
                case 1:
                    packages = _a.sent();
                    _i = 0, packages_1 = packages;
                    _a.label = 2;
                case 2:
                    if (!(_i < packages_1.length)) return [3 /*break*/, 6];
                    packageInfo = packages_1[_i];
                    // linkEveryPackagesToRootNodeModules
                    return [4 /*yield*/, fs.ensureSymlink(path.join(global_state_1.globalState.projectRootPath, packageInfo.path), path.join(global_state_1.globalState.projectRootPath, 'node_modules', packageInfo.name), 'dir')];
                case 3:
                    // linkEveryPackagesToRootNodeModules
                    _a.sent();
                    // linkRootNodeModulesToEveryPackages
                    return [4 /*yield*/, fs.ensureSymlink(path.join(global_state_1.globalState.projectRootPath, 'node_modules'), path.join(global_state_1.globalState.projectRootPath, packageInfo.path, 'node_modules'), 'dir')];
                case 4:
                    // linkRootNodeModulesToEveryPackages
                    _a.sent();
                    _a.label = 5;
                case 5:
                    _i++;
                    return [3 /*break*/, 2];
                case 6: return [2 /*return*/];
            }
        });
    });
}
exports.ensurePackagesLinks = ensurePackagesLinks;
exports.getMonoAndNpmDepsOnce = _.once(getMonoAndNpmDeps);
function getMonoAndNpmDeps() {
    return __awaiter(this, void 0, void 0, function () {
        var depMap, _a, _b, _c, _i, _d, eachPackage, _e, _f, _g, selectedDepNpmPackages, selectedDepMonoPackagesDe, selectedDepMonoPackages, monoDepASC_1;
        return __generator(this, function (_h) {
            switch (_h.label) {
                case 0:
                    if (!(global_state_1.globalState.packages.length > 0)) return [3 /*break*/, 6];
                    depMap = new Map();
                    _b = (_a = depMap).set;
                    _c = ['root'];
                    return [4 /*yield*/, getMonoAndNpmDepsByPath(path.join(global_state_1.globalState.projectRootPath, node_1.srcPath.dir, '**/*.{ts,tsx}'))];
                case 1:
                    _b.apply(_a, _c.concat([_h.sent()]));
                    _i = 0, _d = global_state_1.globalState.packages;
                    _h.label = 2;
                case 2:
                    if (!(_i < _d.length)) return [3 /*break*/, 5];
                    eachPackage = _d[_i];
                    _f = (_e = depMap).set;
                    _g = [eachPackage.name];
                    return [4 /*yield*/, getMonoAndNpmDepsByPath(path.join(eachPackage.rootPath, node_1.srcPath.dir, '**/*.{ts,tsx}'))];
                case 3:
                    _f.apply(_e, _g.concat([_h.sent()]));
                    _h.label = 4;
                case 4:
                    _i++;
                    return [3 /*break*/, 2];
                case 5:
                    selectedDepNpmPackages = depMap.get(global_state_1.globalState.selectedSourceType).depNpmPackages;
                    selectedDepMonoPackagesDe = findNestedSelectedDepMonoPackages(global_state_1.globalState.selectedSourceType, depMap);
                    selectedDepMonoPackages = fp.uniqBy(function (each) { return each.name; }, selectedDepMonoPackagesDe);
                    monoDepASC_1 = getMonoDepASC(depMap);
                    // Sort selectedDepMonoPackages by deps DESC
                    selectedDepMonoPackages.sort(function (left, right) {
                        return monoDepASC_1.findIndex(function (name) { return name === left.name; }) - monoDepASC_1.findIndex(function (name) { return name === right.name; });
                    });
                    return [2 /*return*/, { depMonoPackages: selectedDepMonoPackages, depNpmPackages: selectedDepNpmPackages, depMap: depMap }];
                case 6: return [2 /*return*/, { depMonoPackages: [], depNpmPackages: [], depMap: null }];
            }
        });
    });
}
function getMonoDepASC(depMap) {
    var newMap = _.cloneDeep(depMap);
    var monoDepASC = [];
    // delete root, because it cannot participate in dependency analysis
    newMap.delete('root');
    var _loop_1 = function () {
        var zeroMonoDepsPackageName = null;
        newMap.forEach(function (value, key) {
            if (value.depMonoPackages.length === 0) {
                zeroMonoDepsPackageName = key;
            }
        });
        if (zeroMonoDepsPackageName === null) {
            // Find which packages have circular dependencies.
            newMap.forEach(function (value, key) {
                var cycleDepPackage = value.depMonoPackages.find(function (depMonoPackage) {
                    // dep package which depend to them.
                    if (newMap.has(depMonoPackage.name)) {
                        return newMap
                            .get(depMonoPackage.name)
                            .depMonoPackages.find(function (eachDepMonoPackage) { return eachDepMonoPackage.name === key; });
                    }
                    return false;
                });
                if (cycleDepPackage) {
                    log_1.logWarn("Cyclic dependence: " + cycleDepPackage.name + " <= " + key);
                }
            });
            log_1.logFatal('Cyclic dependence happend!');
        }
        monoDepASC.push(zeroMonoDepsPackageName);
        newMap.delete(zeroMonoDepsPackageName);
        newMap.forEach(function (value) {
            var zeroMonoDepsPackageCurrentIndex = value.depMonoPackages.findIndex(function (eachPackage) { return eachPackage.name === zeroMonoDepsPackageName; });
            if (zeroMonoDepsPackageCurrentIndex > -1) {
                value.depMonoPackages.splice(zeroMonoDepsPackageCurrentIndex, 1);
            }
        });
    };
    // Get mono sort by deps DESC
    while (newMap.size > 0) {
        _loop_1();
    }
    return monoDepASC;
}
function getMonoAndNpmDepsByPath(rootPath) {
    return __awaiter(this, void 0, void 0, function () {
        var ts, tsFiles, depMonoPackages, depNpmPackages;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, Promise.resolve().then(function () { return require('typescript'); })];
                case 1:
                    ts = _a.sent();
                    tsFiles = glob.sync(rootPath);
                    depMonoPackages = new Set();
                    depNpmPackages = new Set();
                    tsFiles.forEach(function (tsFile) {
                        var sourceFile = ts.createSourceFile(tsFile, fs.readFileSync(tsFile).toString(), ts.ScriptTarget.ESNext);
                        sourceFile.statements.forEach(function (statement) {
                            if ([ts.SyntaxKind.ImportDeclaration, ts.SyntaxKind.ExportDeclaration].includes(statement.kind)) {
                                statement.forEachChild(function (each) {
                                    if (each.kind === ts.SyntaxKind.StringLiteral) {
                                        var importStringLiteral_1 = _.trim(each.getText(sourceFile), '\'"');
                                        var targetPackage = global_state_1.globalState.packages.find(function (eachPackage) { return eachPackage.packageJson && eachPackage.packageJson.name === importStringLiteral_1; });
                                        if (targetPackage) {
                                            depMonoPackages.add(targetPackage);
                                        }
                                        else if (!importStringLiteral_1.startsWith('.')) {
                                            var importStringLiteralSplit = importStringLiteral_1.split('/');
                                            if (importStringLiteralSplit[0].startsWith('@')) {
                                                if (importStringLiteralSplit.length > 1) {
                                                    depNpmPackages.add(importStringLiteralSplit[0] + "/" + importStringLiteralSplit[1]);
                                                }
                                                else {
                                                    depNpmPackages.add(importStringLiteralSplit[0]);
                                                }
                                            }
                                            else {
                                                depNpmPackages.add(importStringLiteralSplit[0]);
                                            }
                                        }
                                    }
                                });
                            }
                        });
                    });
                    return [2 /*return*/, { depMonoPackages: Array.from(depMonoPackages), depNpmPackages: Array.from(depNpmPackages) }];
            }
        });
    });
}
exports.getMonoAndNpmDepsByPath = getMonoAndNpmDepsByPath;
function findNestedSelectedDepMonoPackages(sourceType, depMap) {
    var depMonoPackages = depMap.get(sourceType).depMonoPackages;
    var depMonoPackagesNames = depMonoPackages.map(function (depMonoPackage) { return depMonoPackage.name; });
    depMonoPackagesNames.forEach(function (packageName) {
        depMonoPackages = depMonoPackages.concat(findNestedSelectedDepMonoPackages(packageName, depMap));
    });
    return depMonoPackages;
}
//# sourceMappingURL=packages.js.map