"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPluginsByOrder = exports.loadPlugins = exports.plugin = exports.IPluginConfig = exports.loadedPlugins = void 0;
var fs = require("fs-extra");
var _ = require("lodash");
var path = require("path");
var gulp = require("gulp");
var gulpBabel = require("gulp-babel");
var global_state_1 = require("./global-state");
var log_1 = require("./log");
var babel_options_1 = require("./babel-options");
var node_1 = require("../node");
var pluginClientSsr = require("../built-in-plugins/client-ssr");
var pluginCommandAnalyse = require("../built-in-plugins/command-analyse");
var pluginCommandBuild = require("../built-in-plugins/command-build");
var pluginCommandBundle = require("../built-in-plugins/command-bundle");
var pluginCommandDev = require("../built-in-plugins/command-dev");
var pluginCommandDocs = require("../built-in-plugins/command-docs");
var pluginCommandInit = require("../built-in-plugins/command-init");
var pluginCommandPreview = require("../built-in-plugins/command-preview");
var pluginCommandPublish = require("../built-in-plugins/command-publish");
var pluginCommandLint = require("../built-in-plugins/command-lint");
var pluginCommandTest = require("../built-in-plugins/command-test");
var pluginEnsureProjectFiles = require("../built-in-plugins/ensure-project-files");
var pluginMocks = require("../built-in-plugins/mocks");
var pluginProjectAnalyseConfig = require("../built-in-plugins/project-analyse-config");
var pluginProjectAnalyseLayouts = require("../built-in-plugins/project-analyse-layouts");
var pluginProjectAnalyseNotFound = require("../built-in-plugins/project-analyse-not-found");
var pluginProjectAnalysePages = require("../built-in-plugins/project-analyse-pages");
var pluginServiceWorker = require("../built-in-plugins/service-worker");
var whiteFiles = require("../built-in-plugins/white-files");
exports.loadedPlugins = new Set();
var IPluginConfig = /** @class */ (function () {
    function IPluginConfig() {
        this.analyseInfo = {};
        this.commands = [];
        this.buildConfigPipes = [];
        this.bundleConfigPipes = [];
        this.buildConfigStyleLoaderOptionsPipes = [];
        this.buildConfigCssLoaderOptionsPipes = [];
        this.buildConfigSassLoaderOptionsPipes = [];
        this.buildConfigLessLoaderOptionsPipes = [];
        this.buildConfigBabelLoaderOptionsPipes = [];
        this.buildConfigJsLoaderIncludePipes = [];
        this.buildConfigSassLoaderIncludePipes = [];
        this.buildConfigLessLoaderIncludePipes = [];
        this.buildConfigJsLoaderExcludePipes = [];
        this.buildConfigSassLoaderExcludePipes = [];
        this.buildConfigLessLoaderExcludePipes = [];
        this.buildAfterProdBuild = [];
        this.projectAnalyses = [];
        this.projectCreateEntrys = [];
        this.whiteFileRules = [];
        this.ensureProjectFilesQueue = [];
        this.devServices = { socketListeners: [] };
        this.lintFilters = [];
        this.devDllPipes = [];
        this.devServerConfigPipes = [];
        this.jestConfigPipes = [];
        this.afterTestRunCallbacks = [];
        // Lock init type
        this.initType = null;
    }
    return IPluginConfig;
}());
exports.IPluginConfig = IPluginConfig;
exports.plugin = new IPluginConfig();
var hasInitPlugins = false;
var buildLocalPlugin = function (packagePath, outdir) {
    var targetPath = path.join(packagePath, node_1.srcPath.dir, '**/*.{ts,tsx}');
    return new Promise(function (resolve, reject) {
        gulp
            .src(targetPath)
            .pipe(gulpBabel(babel_options_1.getBabelOptions()))
            .on('error', reject)
            .pipe(gulp.dest(outdir))
            .on('end', resolve);
    });
};
var loadPlugins = function (pluginIncludeRoots) {
    if (pluginIncludeRoots === void 0) { pluginIncludeRoots = []; }
    return __awaiter(void 0, void 0, void 0, function () {
        var builtInPlugins, _i, _a, eachPlugin, pluginInstance;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (hasInitPlugins) {
                        return [2 /*return*/];
                    }
                    hasInitPlugins = true;
                    builtInPlugins = [
                        pluginClientSsr,
                        pluginCommandAnalyse,
                        pluginCommandBuild,
                        pluginCommandBundle,
                        pluginCommandDev,
                        pluginCommandDocs,
                        pluginCommandInit,
                        pluginCommandPreview,
                        pluginCommandPublish,
                        pluginCommandLint,
                        pluginCommandTest,
                        pluginEnsureProjectFiles,
                        pluginMocks,
                        whiteFiles,
                        pluginProjectAnalyseConfig,
                        pluginProjectAnalyseLayouts,
                        pluginProjectAnalyseNotFound,
                        pluginProjectAnalysePages,
                        pluginServiceWorker,
                    ];
                    builtInPlugins.forEach(function (eachPlugin) {
                        exports.loadedPlugins.add(eachPlugin);
                    });
                    if (!(global_state_1.globalState.sourceConfig.type !== 'plugin')) return [3 /*break*/, 2];
                    return [4 /*yield*/, getPriPlugins(global_state_1.globalState.projectRootPath, pluginIncludeRoots.concat(global_state_1.globalState.projectRootPath).map(function (pluginIncludeRoot) {
                            return path.join(pluginIncludeRoot, 'package.json');
                        }))];
                case 1:
                    _b.sent();
                    _b.label = 2;
                case 2:
                    if (!(exports.loadedPlugins.size > 1)) return [3 /*break*/, 7];
                    _i = 0, _a = getPluginsByOrder();
                    _b.label = 3;
                case 3:
                    if (!(_i < _a.length)) return [3 /*break*/, 7];
                    eachPlugin = _a[_i];
                    return [4 /*yield*/, eachPlugin.getPlugin()];
                case 4:
                    pluginInstance = _b.sent();
                    if (!pluginInstance.main) return [3 /*break*/, 6];
                    return [4 /*yield*/, pluginInstance.main()];
                case 5:
                    _b.sent();
                    _b.label = 6;
                case 6:
                    _i++;
                    return [3 /*break*/, 3];
                case 7: return [2 /*return*/];
            }
        });
    });
};
exports.loadPlugins = loadPlugins;
function getPriPlugins(pluginRootPath, packageJsonPaths) {
    return __awaiter(this, void 0, void 0, function () {
        var _loop_1, _i, _a, eachPackage, deps, allDependencies;
        var _this = this;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    // Do not load plugins when type is 'plugin'.
                    // Load plugin even when type is undefined.
                    if (global_state_1.globalState.sourceConfig.type === 'plugin') {
                        return [2 /*return*/];
                    }
                    if (!(pluginRootPath === global_state_1.globalState.projectRootPath)) return [3 /*break*/, 4];
                    _loop_1 = function (eachPackage) {
                        var distPath;
                        return __generator(this, function (_c) {
                            switch (_c.label) {
                                case 0:
                                    distPath = path.join(global_state_1.globalState.projectRootPath, node_1.tempPath.dir, 'plugins', eachPackage.name);
                                    return [4 /*yield*/, log_1.spinner("Build plugin " + eachPackage.name, function () { return __awaiter(_this, void 0, void 0, function () {
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4 /*yield*/, fs.remove(distPath)];
                                                    case 1:
                                                        _a.sent();
                                                        return [4 /*yield*/, buildLocalPlugin(eachPackage.rootPath, distPath)];
                                                    case 2:
                                                        _a.sent();
                                                        return [2 /*return*/];
                                                }
                                            });
                                        }); })];
                                case 1:
                                    _c.sent();
                                    addPluginFromEntry(distPath);
                                    return [2 /*return*/];
                            }
                        });
                    };
                    _i = 0, _a = global_state_1.globalState.plugins;
                    _b.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 4];
                    eachPackage = _a[_i];
                    return [5 /*yield**/, _loop_1(eachPackage)];
                case 2:
                    _b.sent();
                    _b.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4:
                    deps = packageJsonPaths.map(function (packageJsonPath) {
                        return getDependencesByPackageJsonPath(packageJsonPath);
                    });
                    allDependencies = deps.reduce(function (obj, next) {
                        Object.assign(obj, next);
                        return obj;
                    }, {});
                    Object.keys(allDependencies)
                        .filter(function (subPackageName) {
                        return subPackageName.startsWith('pri-plugin') || subPackageName.startsWith('@ali/pri-plugin');
                    })
                        .map(function (subPackageName) {
                        // Can't allowed same name plugins
                        if (Array.from(exports.loadedPlugins).some(function (loadedPlugin) {
                            return loadedPlugin.getConfig().name === subPackageName;
                        })) {
                            log_1.logFatal("There are two plugins named " + subPackageName + "!");
                        }
                        var subPackageVersion = allDependencies[subPackageName];
                        var subPackageRealEntry = subPackageVersion.startsWith('file:')
                            ? path.join(pluginRootPath, subPackageVersion.replace(/^file:/g, ''))
                            : subPackageName;
                        var subPackageRealEntryFilePath = require.resolve(subPackageRealEntry, {
                            paths: [__dirname, pluginRootPath],
                        });
                        var subPackageAbsolutePath = !subPackageVersion.startsWith('file:')
                            ? getPackageJsonPathByPathOrNpmName(subPackageName, pluginRootPath)
                            : path.resolve(pluginRootPath, subPackageVersion.replace(/^file:/g, ''), 'package.json');
                        addPluginFromEntry(subPackageRealEntryFilePath);
                        if (subPackageAbsolutePath) {
                            getPriPlugins(path.resolve(subPackageAbsolutePath, '..'), [subPackageAbsolutePath]);
                        }
                    });
                    return [2 /*return*/];
            }
        });
    });
}
function getPluginsByOrder() {
    var instantiatedPluginNames = new Set();
    var outputPlugins = [];
    // Check deps has been loaded
    exports.loadedPlugins.forEach(function (loadedPlugin) {
        if (loadedPlugin.getConfig().dependencies) {
            loadedPlugin.getConfig().dependencies.forEach(function (depPluginName) {
                if (!Array.from(exports.loadedPlugins).some(function (eachLoadedPlugin) {
                    return eachLoadedPlugin.getConfig().name === depPluginName;
                })) {
                    log_1.logFatal(loadedPlugin.getConfig().name + ": No dependent \"" + depPluginName + "\"\nTry: npm install " + depPluginName + ".");
                }
            });
        }
    });
    // Push to plugin quene.
    while (instantiatedPluginNames.size !== exports.loadedPlugins.size) {
        var currentInstantiatedPlugins = getPluginWithPreloadDependences(Array.from(instantiatedPluginNames));
        currentInstantiatedPlugins.forEach(function (eachPlugin) {
            return outputPlugins.push(eachPlugin);
        });
        if (currentInstantiatedPlugins.length === 0) {
            throw Error('Plugin loop dependency.');
        }
        currentInstantiatedPlugins.forEach(function (eachPlugin) {
            return instantiatedPluginNames.add(eachPlugin.getConfig().name);
        });
    }
    return outputPlugins;
}
exports.getPluginsByOrder = getPluginsByOrder;
function getPluginWithPreloadDependences(preInstantiatedDependences) {
    return (Array.from(exports.loadedPlugins)
        // Filter plugins who are not instantiated.
        .filter(function (loadedPlugin) {
        if (preInstantiatedDependences.length === 0) {
            return true;
        }
        return (preInstantiatedDependences.findIndex(function (pluginName) {
            return loadedPlugin.getConfig().name === pluginName;
        }) === -1);
    })
        // Filter plugins who satisfied the dependence condition.
        .filter(function (loadedPlugin) {
        // No dependences obvious can pass.
        if (!loadedPlugin.getConfig().dependencies) {
            return true;
        }
        if (loadedPlugin.getConfig().dependencies.every(function (depPluginName) {
            return preInstantiatedDependences.indexOf(depPluginName) > -1;
        })) {
            return true;
        }
        return false;
    })
        .map(function (loadedPlugin) {
        return loadedPlugin;
    }));
}
function getPackageJsonPathByPathOrNpmName(pathOrNpmName, currentRootPath) {
    try {
        return require.resolve(path.join(pathOrNpmName, 'package.json'), { paths: [__dirname, currentRootPath] });
    }
    catch (error) {
        return null;
    }
}
function getDependencesByPackageJsonPath(packageJsonPath) {
    var packageJsonExist = fs.existsSync(packageJsonPath);
    var packageJson = packageJsonExist ? fs.readJsonSync(packageJsonPath) : null;
    return __assign(__assign({}, _.get(packageJson, 'dependencies', {})), _.get(packageJson, 'devDependencies', {}));
}
function addPluginFromEntry(entryPath) {
    // eslint-disable-next-line import/no-dynamic-require,@typescript-eslint/no-var-requires,global-require
    var instance = require(entryPath);
    if (!instance.getConfig) {
        log_1.logFatal('Plugin must impletement getConfig method!');
    }
    if (!instance.getPlugin) {
        log_1.logFatal('Plugin must impletement getPlugin method!');
    }
    if (!instance.getConfig().name) {
        log_1.logFatal('Plugin must have name!');
    }
    exports.loadedPlugins.add(instance);
}
//# sourceMappingURL=plugins.js.map