"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasPackageChanged = exports.hasExtraVendorsChanged = exports.hasNodeModulesModified = exports.hasNodeModules = void 0;
var fs = require("fs-extra");
var path = require("path");
var yargs = require("yargs");
var global_state_1 = require("./global-state");
var projectState = require("./project-state");
var hasNodeModules = function () {
    return fs.existsSync(path.join(global_state_1.globalState.projectRootPath, 'node_modules'));
};
exports.hasNodeModules = hasNodeModules;
var hasNodeModulesModified = function () {
    var key = 'node_modules-modified-time';
    var nextModifiedTime = fs.statSync(path.join(global_state_1.globalState.projectRootPath, 'node_modules')).mtime.toString();
    return hasChanged(key, nextModifiedTime);
};
exports.hasNodeModulesModified = hasNodeModulesModified;
var hasExtraVendorsChanged = function () {
    var _a;
    var key = 'extraVendors';
    var newExtraVendors = JSON.stringify((_a = global_state_1.globalState.sourceConfig.extraVendors) !== null && _a !== void 0 ? _a : []);
    return hasChanged(key, newExtraVendors);
};
exports.hasExtraVendorsChanged = hasExtraVendorsChanged;
var hasPackageChanged = function () {
    var key = 'package';
    var newPackage = yargs.argv.package;
    return hasChanged(key, newPackage);
};
exports.hasPackageChanged = hasPackageChanged;
function hasChanged(key, nextValue) {
    var previewValue = projectState.get(key);
    if (!previewValue) {
        projectState.set(key, nextValue);
        return true;
    }
    projectState.set(key, nextValue);
    if (previewValue !== nextValue) {
        return true;
    }
    return false;
}
//# sourceMappingURL=project-helper.js.map