"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createConfig = exports.create404 = exports.createLayout = exports.addPage = void 0;
var fs = require("fs-extra");
var path = require("path");
var analyse_project_1 = require("./analyse-project");
var constants_1 = require("./constants");
var global_state_1 = require("./global-state");
var prettier_config_1 = require("./prettier-config");
var structor_config_1 = require("./structor-config");
function addPage(options) {
    return __awaiter(this, void 0, void 0, function () {
        var fileFullPath, prettier;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, analyse_project_1.analyseProject()];
                case 1:
                    _a.sent();
                    fileFullPath = path.join(global_state_1.globalState.sourceRoot, structor_config_1.pagesPath.dir, options.path, 'index') + ".tsx";
                    if (fs.existsSync(fileFullPath)) {
                        throw Error(options.path + " already exist!");
                    }
                    return [4 /*yield*/, Promise.resolve().then(function () { return require('prettier'); })];
                case 2:
                    prettier = _a.sent();
                    fs.outputFileSync(fileFullPath, prettier.format("\n      import * as React from \"react\"\n\n      export default () => (\n        <div>\n          New page for " + options.path + "\n        </div>\n      )\n    ", __assign(__assign({}, prettier_config_1.prettierConfig), { parser: 'typescript' })));
                    return [2 /*return*/];
            }
        });
    });
}
exports.addPage = addPage;
function createLayout() {
    return __awaiter(this, void 0, void 0, function () {
        var pathFullPath, prettier;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    pathFullPath = path.join(global_state_1.globalState.sourceRoot, path.format(structor_config_1.layoutPath));
                    if (fs.existsSync(pathFullPath)) {
                        throw Error('layout already exist!');
                    }
                    return [4 /*yield*/, Promise.resolve().then(function () { return require('prettier'); })];
                case 1:
                    prettier = _a.sent();
                    fs.outputFileSync(pathFullPath, prettier.format("\n      import * as React from \"react\"\n\n      export default (props: React.Props<any>) => (\n        <div>\n          {props.children}\n        </div>\n      )\n  ", __assign(__assign({}, prettier_config_1.prettierConfig), { parser: 'typescript' })));
                    return [2 /*return*/];
            }
        });
    });
}
exports.createLayout = createLayout;
function create404() {
    return __awaiter(this, void 0, void 0, function () {
        var pathFullPath, prettier;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    pathFullPath = path.join(global_state_1.globalState.sourceRoot, path.format(structor_config_1.notFoundPath));
                    if (fs.existsSync(pathFullPath)) {
                        throw Error('404 page already exist!');
                    }
                    return [4 /*yield*/, Promise.resolve().then(function () { return require('prettier'); })];
                case 1:
                    prettier = _a.sent();
                    fs.outputFileSync(pathFullPath, prettier.format("\n      import * as React from \"react\"\n\n      export default () => (\n        <div>\n        Page not found\n        </div>\n      )\n  ", __assign(__assign({}, prettier_config_1.prettierConfig), { parser: 'typescript' })));
                    return [2 /*return*/];
            }
        });
    });
}
exports.create404 = create404;
function createConfig() {
    return __awaiter(this, void 0, void 0, function () {
        var configFilePath;
        return __generator(this, function (_a) {
            configFilePath = path.join(global_state_1.globalState.projectRootPath, constants_1.CONFIG_FILE);
            if (fs.existsSync(configFilePath)) {
                throw Error('config already exist!');
            }
            fs.outputJSONSync(configFilePath, {});
            return [2 /*return*/];
        });
    });
}
exports.createConfig = createConfig;
//# sourceMappingURL=project-manager.js.map