"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ignoreScanFiles = exports.npmIgnores = exports.gitIgnores = exports.pluginEntry = exports.componentEntry = exports.layoutPath = exports.declarePath = exports.componentPath = exports.expandPath = exports.requestsPath = exports.utilPath = exports.tempJsAppPath = exports.tempEnvironmentPath = exports.tempJsEntryPath = exports.notFoundPath = exports.pagesPath = exports.tempTypesPath = exports.declarationPath = exports.pluginsPath = exports.packagesPath = exports.assetsPath = exports.tempPath = exports.typingsPath = exports.docsPath = exports.testsPath = exports.srcPath = void 0;
var fs = require("fs-extra");
var _ = require("lodash");
var path = require("path");
var global_state_1 = require("./global-state");
/**
 * Top level definition start
 */
exports.srcPath = { dir: 'src' };
exports.testsPath = { dir: 'tests' };
exports.docsPath = { dir: 'docs' };
exports.typingsPath = { dir: 'typings' };
exports.tempPath = { dir: '.temp' };
exports.assetsPath = { dir: 'assets' };
exports.packagesPath = { dir: 'packages' };
exports.pluginsPath = { dir: 'plugins' };
exports.declarationPath = { dir: 'declaration' };
/**
 * Sub level definition end
 */
exports.tempTypesPath = {
    dir: path.join(exports.tempPath.dir, 'types'),
};
exports.pagesPath = { dir: path.join(exports.srcPath.dir, 'pages') };
exports.notFoundPath = {
    dir: exports.pagesPath.dir,
    name: '404',
    ext: '.tsx',
};
exports.tempJsEntryPath = {
    dir: exports.tempPath.dir,
    name: 'entry',
    ext: '.tsx',
};
exports.tempEnvironmentPath = {
    dir: exports.tempPath.dir,
    name: 'environment',
    ext: '.ts',
};
exports.tempJsAppPath = { dir: exports.tempPath.dir, name: 'app', ext: '.tsx' };
exports.utilPath = {
    dir: path.join(exports.srcPath.dir, 'utils'),
};
exports.requestsPath = {
    dir: path.join(exports.srcPath.dir, 'requests'),
};
exports.expandPath = {
    dir: path.join(exports.srcPath.dir, 'expand'),
};
exports.componentPath = {
    dir: path.join(exports.srcPath.dir, 'components'),
};
exports.declarePath = {
    dir: path.join(exports.tempPath.dir, 'declare'),
};
exports.layoutPath = {
    dir: path.join(exports.srcPath.dir, 'layouts'),
    name: 'index',
    ext: '.tsx',
};
exports.componentEntry = {
    dir: path.join(exports.srcPath.dir),
    name: 'index',
    ext: getComponentEntryExt(),
};
exports.pluginEntry = {
    dir: path.join(exports.srcPath.dir),
    name: 'index',
    ext: '.ts',
};
/**
 * Ignores.
 */
var ignores = [
    'node_modules',
    '.cache',
    '.vscode',
    '.idea',
    '.temp',
    '.DS_Store',
    'coverage',
    '.nyc_output',
    'npm-debug.log',
    '.node',
];
// FIXME:
if (!global.priGitIgnores) {
    global.priGitIgnores = _.union(__spreadArray(__spreadArray([], ignores), [global_state_1.globalState.projectConfig.distDir, 'declaration']));
}
exports.gitIgnores = global.priGitIgnores;
// npm ignores extends git ingores.
exports.npmIgnores = _.union(__spreadArray(__spreadArray([], ignores), ['tests', 'packages']));
exports.ignoreScanFiles = _.union(__spreadArray(__spreadArray([], ignores), [
    '.eslintignore',
    '.gitignore',
    '.gitmodules',
    '.npmignore',
    '.git',
    'package.json',
    'tsconfig.json',
    '.eslintrc',
    '.prettierrc',
    '.npmrc',
    '.travis.yml',
    '.prettierignore',
    'assets',
    'license',
    'LICENSE',
    'readme.md',
    'README.md',
    'history.md',
    'HISTORY.md',
]));
function getComponentEntryExt() {
    // FIXME:
    if (!global.priProjectEntryExt) {
        global.priProjectEntryExt = path.join(global_state_1.globalState.sourceRoot, path.join(exports.srcPath.dir), 'index');
    }
    return fs.existsSync(global.priProjectEntryExt + ".ts") ? '.ts' : '.tsx';
}
//# sourceMappingURL=structor-config.js.map