"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tsPlusBabel = void 0;
var gulp = require("gulp");
var fs = require("fs-extra");
var gulpBabel = require("gulp-babel");
var gulpSass = require("gulp-dart-sass");
var gulpLess = require("gulp-less");
var gulpWatch = require("gulp-watch");
var gulpStripCssComments = require("gulp-strip-css-comments");
var gulpConcatCss = require("gulp-concat-css");
var gulpIf = require("gulp-if");
var gulpSourcemaps = require("gulp-sourcemaps");
var mergeStream = require("merge-stream");
var path = require("path");
var _ = require("lodash");
var webpack = require("webpack");
var node_1 = require("../node");
var plugins_1 = require("./plugins");
var babel_options_1 = require("./babel-options");
var global_state_1 = require("./global-state");
var babel_plugin_transfer_import_1 = require("./babel-plugin-transfer-import");
var webpack_1 = require("./webpack");
function getGulpByWatch(watch, filesPath) {
    if (watch) {
        return gulpWatch(filesPath);
    }
    /** 文件匹配 */
    return gulp.src(filesPath);
}
var buildTs = function (watch, outdir, babelOptions, wholeProject, sourcePath) {
    var targetPath = wholeProject
        ? path.join(node_1.pri.projectRootPath, '{src,packages}/**/*.{ts,tsx}')
        : path.join(sourcePath || node_1.pri.sourceRoot, node_1.srcPath.dir, '**/*.{ts,tsx}');
    return new Promise(function (resolve, reject) {
        if (global_state_1.globalState.isDevelopment) {
            getGulpByWatch(watch, targetPath)
                .pipe(gulpSourcemaps.init())
                .pipe(gulpBabel(babelOptions))
                .pipe(gulpSourcemaps.write())
                .on('error', reject)
                .pipe(gulp.dest(outdir))
                .on('end', resolve);
        }
        else {
            getGulpByWatch(watch, targetPath)
                .pipe(gulpBabel(babelOptions))
                .on('error', reject)
                .pipe(gulp.dest(outdir))
                .on('end', resolve);
        }
    });
};
/** 获取样式文件路径 */
function getStyleFilePath(suffix, wholeProject, sourcePath) {
    return wholeProject || (node_1.pri.selectedSourceType === 'root' && node_1.pri.sourceConfig.cssExtract)
        ? path.join(node_1.pri.projectRootPath, "{src,packages}/**/*." + suffix)
        : path.join(sourcePath || node_1.pri.sourceRoot, node_1.srcPath.dir, "**/*." + suffix);
}
var buildSass = function (wholeProject, sourcePath) {
    var targetScssPath = getStyleFilePath('scss', wholeProject, sourcePath);
    return gulp.src(targetScssPath).pipe(gulpSass(plugins_1.plugin.buildConfigSassLoaderOptionsPipes.reduce(function (options, fn) {
        return fn(options);
    }, { includePaths: path.join(node_1.pri.projectRootPath, 'node_modules') })));
};
var buildLess = function (wholeProject, sourcePath) {
    var targetLessPath = getStyleFilePath('less', wholeProject, sourcePath);
    return gulp.src(targetLessPath).pipe(gulpLess(plugins_1.plugin.buildConfigLessLoaderOptionsPipes.reduce(function (options, fn) {
        return fn(options);
    }, { paths: [path.join(node_1.pri.projectRootPath, 'node_modules', 'includes')] })));
};
var buildSassAndLess = function (watch, outdir, wholeProject, sourcePath) {
    var targetPath = getStyleFilePath('{scss,less}', wholeProject, sourcePath);
    var mergeStyle = function (resolve, reject) {
        return mergeStream(buildLess(wholeProject, sourcePath), buildSass(wholeProject, sourcePath))
            .pipe(gulpIf(node_1.pri.sourceConfig.cssExtract, gulpConcatCss(node_1.pri.sourceConfig.outCssFileName)))
            .pipe(gulpStripCssComments())
            .on('error', reject)
            .pipe(gulp.dest(outdir))
            .on('end', resolve);
    };
    if (watch) {
        return new Promise(function (resolve, reject) {
            gulpWatch(targetPath, function () {
                mergeStyle(resolve, reject);
            });
        });
    }
    return new Promise(mergeStyle);
};
var buildCssWithWebpack = function (outDir, copyDir) {
    var entryNames = Object.keys(node_1.pri.sourceConfig.componentEntries);
    var dllOutPath = path.join(global_state_1.globalState.projectRootPath, '.temp/static/dlls');
    var dllFileName = 'main.dll.js';
    var dllMainfestName = 'manifest.json';
    return webpack_1.bundleDlls({ dllOutPath: dllOutPath, dllFileName: dllFileName, dllMainfestName: dllMainfestName })
        .then(function () {
        return entryNames.reduce(function (promise, name) {
            return promise.then(function () {
                var _a;
                return webpack_1.runWebpack({
                    mode: 'production',
                    entryPath: (_a = {}, _a[name] = node_1.pri.sourceConfig.componentEntries[name], _a),
                    distDir: outDir,
                    outFileName: '[name].js',
                    outCssFileName: '[name].css',
                    pipeConfig: function (config) { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            _.set(config, ['optimization', 'splitChunks', 'cacheGroups', "styles"], {
                                name: name + "-styles",
                                test: /\.css|scss|less$/,
                                chunks: 'all',
                                enforce: true,
                            });
                            config.plugins.push(new webpack.DllReferencePlugin({
                                context: '.',
                                // eslint-disable-next-line import/no-dynamic-require,global-require
                                manifest: require(path.join(dllOutPath, dllMainfestName)),
                            }));
                            return [2 /*return*/, config];
                        });
                    }); },
                });
            });
        }, Promise.resolve());
    })
        .then(function () {
        var distFiles = fs.readdirSync(outDir);
        distFiles.forEach(function (file) {
            var fileEntryName = entryNames.find(function (name) { return name + "-styles.css" === path.basename(file); });
            if (fileEntryName) {
                fs.renameSync(path.join(outDir, file), path.join(outDir, fileEntryName + ".css"));
            }
            else {
                fs.removeSync(path.join(outDir, file));
            }
        });
        fs.copySync(outDir, copyDir);
    });
};
var mvResources = function (watch, outdir, wholeProject, sourcePath, sourceType, moveStyle) {
    var selectedSourceType = sourceType || node_1.pri.selectedSourceType;
    var targetPath = wholeProject || (selectedSourceType === 'root' && node_1.pri.sourceConfig.cssExtract)
        ? path.join(node_1.pri.projectRootPath, "{src,packages}/**/*.{js,json,png,jpg,jpeg,gif,woff,woff2,eot,ttf,svg" + (moveStyle ? ',css,scss,less' : '') + "}")
        : path.join(sourcePath || node_1.pri.sourceRoot, node_1.srcPath.dir, "**/*.{js,json,png,jpg,jpeg,gif,woff,woff2,eot,ttf,svg" + (moveStyle ? ',css,scss,less' : '') + "}");
    return new Promise(function (resolve, reject) {
        getGulpByWatch(watch, targetPath).on('error', reject).pipe(gulp.dest(outdir)).on('end', resolve);
    });
};
function importRename(packageAbsoluteToRelative) {
    if (packageAbsoluteToRelative === void 0) { packageAbsoluteToRelative = false; }
    return [
        babel_plugin_transfer_import_1.babelPluginTransformImport,
        {
            removeCssImport: node_1.pri.sourceConfig.cssExtract,
            pipeImport: function (text, filename) {
                var scssRegex = '^(.+?)\\.scss$';
                var scssPattern = new RegExp("^(" + scssRegex + "|" + scssRegex + "/.*)$");
                if (scssPattern.test(text)) {
                    var scssReplacePattern = new RegExp(scssRegex);
                    return text.replace(scssReplacePattern, '$1.css');
                }
                var lessRegex = '^(.+?)\\.less$';
                var lessPattern = new RegExp("^(" + lessRegex + "|" + lessRegex + "/.*)$");
                if (lessPattern.test(text)) {
                    var lessReplacePattern = new RegExp(lessRegex);
                    return text.replace(lessReplacePattern, '$1.css');
                }
                if (packageAbsoluteToRelative) {
                    // resolve absolute packages to relative path
                    for (var _i = 0, _a = global_state_1.globalState.packages; _i < _a.length; _i++) {
                        var eachPackage = _a[_i];
                        if (eachPackage.packageJson && eachPackage.packageJson.name) {
                            if (eachPackage.packageJson.name === text) {
                                return path.relative(path.parse(filename).dir, path.join(eachPackage.rootPath, node_1.srcPath.dir));
                            }
                        }
                    }
                }
                return text;
            },
        },
    ];
}
var tsPlusBabel = function (watch, wholeProject, packageInfo) {
    if (watch === void 0) { watch = false; }
    if (wholeProject === void 0) { wholeProject = false; }
    if (packageInfo === void 0) { packageInfo = null; }
    return __awaiter(void 0, void 0, void 0, function () {
        var packagePath, rootDistPath, mainDistPath, moduleDistPath, esm5DistPath, sourcePath, sourceType;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    packagePath = packageInfo ? packageInfo.name : '';
                    rootDistPath = path.join(global_state_1.globalState.projectRootPath, node_1.pri.sourceConfig.distDir, packagePath);
                    mainDistPath = path.join(rootDistPath, 'main');
                    moduleDistPath = path.join(rootDistPath, 'module');
                    esm5DistPath = path.join(rootDistPath, 'esm5');
                    if (node_1.pri.sourceConfig.materialComponent) {
                        mainDistPath = path.join(global_state_1.globalState.sourceRoot, 'lib');
                        moduleDistPath = path.join(global_state_1.globalState.sourceRoot, 'es');
                        esm5DistPath = '';
                    }
                    sourcePath = packageInfo ? packageInfo.rootPath : null;
                    sourceType = packageInfo ? packageInfo.name : null;
                    if (!node_1.pri.sourceConfig.componentEntries) return [3 /*break*/, 2];
                    return [4 /*yield*/, buildCssWithWebpack(mainDistPath, moduleDistPath)];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2 /*return*/, Promise.all([
                        node_1.pri.sourceConfig.componentEntries ? null : buildSassAndLess(watch, mainDistPath, wholeProject, sourcePath),
                        node_1.pri.sourceConfig.componentEntries ? null : buildSassAndLess(watch, moduleDistPath, wholeProject, sourcePath),
                        buildTs(watch, mainDistPath, plugins_1.plugin.buildConfigBabelLoaderOptionsPipes.reduce(function (options, fn) {
                            return fn(options);
                        }, babel_options_1.getBabelOptions({
                            plugins: [importRename(wholeProject)],
                        })), wholeProject, sourcePath),
                        buildTs(watch, moduleDistPath, plugins_1.plugin.buildConfigBabelLoaderOptionsPipes.reduce(function (options, fn) {
                            return fn(options);
                        }, babel_options_1.getBabelOptions({
                            modules: false,
                            plugins: [importRename(wholeProject)],
                        })), wholeProject, sourcePath),
                        esm5DistPath &&
                            buildTs(watch, esm5DistPath, plugins_1.plugin.buildConfigBabelLoaderOptionsPipes.reduce(function (options, fn) {
                                return fn(options);
                            }, babel_options_1.getBabelOptions({
                                modules: false,
                            })), wholeProject, sourcePath),
                        mvResources(watch, mainDistPath, wholeProject, sourcePath, sourceType),
                        mvResources(watch, moduleDistPath, wholeProject, sourcePath, sourceType),
                        esm5DistPath && mvResources(watch, esm5DistPath, wholeProject, sourcePath, sourceType, true),
                    ])];
            }
        });
    });
};
exports.tsPlusBabel = tsPlusBabel;
//# sourceMappingURL=ts-plus-babel.js.map