"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.typeChecker = void 0;
var child_process_1 = require("child_process");
var process = require("process");
var log_1 = require("./log");
function typeChecker() {
    var stashFileCnt = +child_process_1.execSync('git diff --cached --numstat --diff-filter=ACM | wc -l').toString('utf8');
    if (stashFileCnt > 0) {
        var debugFiles = '';
        try {
            debugFiles = child_process_1.execSync("grep -in '@DEBUG' --include *.ts --include *.tsx --include *.js --include *.scss --include *.css $(git diff --cached --name-only --diff-filter=ACM) /dev/null", {
                shell: 'bash',
                stdio: [0, 1],
            }).toString('utf8');
            // eslint-disable-next-line no-empty
        }
        catch (e) { }
        if (debugFiles) {
            log_1.logFatal('@DEBUG identifier exists, the commit is terminated');
            process.exit(1);
        }
    }
    log_1.logInfo('Checking TypeScript type, please wait');
    try {
        child_process_1.execSync("npx tsc -p . --isolatedModules false || exit 1", {
            stdio: [0, 1, 2],
        });
    }
    catch (e) {
        log_1.logFatal('Type checks error!');
        process.exit(1);
    }
    log_1.logSuccess('Type checks passed!');
}
exports.typeChecker = typeChecker;
//# sourceMappingURL=type-checker.js.map