"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWebpackConfig = void 0;
var HtmlWebpackPlugin = require("html-webpack-plugin");
var MiniCssExtractPlugin = require("mini-css-extract-plugin");
var OptimizeCssAssetsPlugin = require("optimize-css-assets-webpack-plugin");
var path = require("path");
var yargs = require("yargs");
var global_state_1 = require("./global-state");
var plugins_1 = require("./plugins");
var structor_config_1 = require("./structor-config");
var babel_options_1 = require("./babel-options");
var defaultSourcePathToBeResolve = __spreadArray(__spreadArray([], global_state_1.transferToAllAbsolutePaths(structor_config_1.srcPath.dir)), global_state_1.transferToAllAbsolutePaths(structor_config_1.tempPath.dir));
var selfAndProjectNodeModules = [
    path.join(global_state_1.globalState.projectRootPath, 'node_modules'),
    path.join(__dirname, '../../node_modules'),
];
var stats = {
    warnings: false,
    version: false,
    modules: false,
    entrypoints: false,
    hash: false,
};
var tsLoaderConfig = {
    include: plugins_1.plugin.buildConfigJsLoaderIncludePipes.reduce(function (options, fn) {
        return fn(options);
    }, defaultSourcePathToBeResolve),
    exclude: plugins_1.plugin.buildConfigJsLoaderExcludePipes.reduce(function (options, fn) {
        return fn(options);
    }, []),
};
var cssLoaderConfig = {
    include: defaultSourcePathToBeResolve,
};
// const scssLoaderConfig = {
//   include: plugin.buildConfigSassLoaderIncludePipes.reduce(
//     (options, fn) => fn(options),
//     defaultSourcePathToBeResolve
//   ),
//   exclude: plugin.buildConfigSassLoaderExcludePipes.reduce((options, fn) => fn(options), [])
// };
// const lessLoaderConfig = {
//   include: plugin.buildConfigLessLoaderIncludePipes.reduce(
//     (options, fn) => fn(options),
//     defaultSourcePathToBeResolve
//   ),
//   exclude: plugin.buildConfigLessLoaderExcludePipes.reduce((options, fn) => fn(options), [])
// };
/**
 * Get webpack config.
 */
var getWebpackConfig = function (opts) { return __awaiter(void 0, void 0, void 0, function () {
    var distDir, outFileName, outCssFileName, styleLoader, cssPureLoader, cssModuleLoader, sassLoader, lessLoader, babelLoader, extraCssInProd, publicPath, devtool, config;
    return __generator(this, function (_a) {
        distDir = opts.distDir || path.join(global_state_1.globalState.projectRootPath, global_state_1.globalState.sourceConfig.distDir);
        outFileName = opts.outFileName || global_state_1.globalState.sourceConfig.outFileName;
        outCssFileName = opts.outCssFileName || global_state_1.globalState.sourceConfig.outCssFileName;
        styleLoader = {
            loader: 'style-loader',
            options: plugins_1.plugin.buildConfigStyleLoaderOptionsPipes.reduce(function (options, fn) {
                return fn(options);
            }, {}),
        };
        cssPureLoader = {
            loader: 'css-loader',
            options: plugins_1.plugin.buildConfigCssLoaderOptionsPipes.reduce(function (options, fn) {
                return fn(options);
            }, {}),
        };
        cssModuleLoader = {
            loader: 'css-loader',
            options: plugins_1.plugin.buildConfigCssLoaderOptionsPipes.reduce(function (options, fn) {
                return fn(options);
            }, {
                importLoaders: 1,
                modules: {
                    localIdentName: '[path][name]-[local]-[hash:base64:5]',
                },
            }),
        };
        sassLoader = {
            loader: 'sass-loader',
            options: plugins_1.plugin.buildConfigSassLoaderOptionsPipes.reduce(function (options, fn) {
                return fn(options);
            }, 
            // eslint-disable-next-line global-require
            { implementation: require('sass') }),
        };
        lessLoader = {
            loader: 'less-loader',
            options: plugins_1.plugin.buildConfigLessLoaderOptionsPipes.reduce(function (options, fn) {
                return fn(options);
            }, {}),
        };
        babelLoader = {
            loader: 'babel-loader',
            options: plugins_1.plugin.buildConfigBabelLoaderOptionsPipes.reduce(function (options, fn) {
                return fn(options);
            }, __assign(__assign({}, babel_options_1.getBabelOptions()), { cacheDirectory: true })),
        };
        extraCssInProd = function () {
            var loaders = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                loaders[_i] = arguments[_i];
            }
            // Enable cssExtract, but not in bundle command.
            if (global_state_1.globalState.sourceConfig.cssExtract && yargs.argv._[0] !== 'bundle' && !yargs.argv._[0].startsWith('debug')) {
                if (global_state_1.globalState.isDevelopment) {
                    return __spreadArray([styleLoader], loaders);
                }
                return __spreadArray([MiniCssExtractPlugin.loader], loaders);
            }
            return __spreadArray([styleLoader], loaders);
        };
        publicPath = opts.publicPath || global_state_1.globalState.sourceConfig.publicPath || '/';
        if (!publicPath.endsWith('/')) {
            publicPath += '/';
        }
        devtool = opts.devtool;
        if (devtool === undefined) {
            devtool = opts.mode === 'development' ? 'cheap-module-eval-source-map' : false;
        }
        config = {
            mode: opts.mode,
            entry: opts.entryPath,
            devtool: devtool,
            externals: opts.externals,
            target: opts.target || 'web',
            output: {
                path: distDir,
                filename: outFileName,
                publicPath: publicPath,
                chunkFilename: '[name].[hash].chunk.js',
                hotUpdateChunkFilename: 'hot~[id].[hash].chunk.js',
                hotUpdateMainFilename: 'hot-update.[hash].json',
                hashDigestLength: 4,
                globalObject: "(typeof self !== 'undefined' ? self : this)",
                libraryTarget: opts.libraryTarget || 'var',
            },
            module: {
                rules: [
                    __assign({ test: /\.worker\.tsx?$/, use: [
                            {
                                loader: 'worker-loader',
                                options: {
                                    inline: true,
                                },
                            },
                        ] }, tsLoaderConfig),
                    __assign({ test: /\.tsx?$/, use: [babelLoader] }, tsLoaderConfig),
                    __assign({ test: /\.mdx?$/, use: [babelLoader, '@mdx-js/loader'] }, tsLoaderConfig),
                    {
                        test: /\.css$/,
                        use: extraCssInProd(cssPureLoader),
                        exclude: [/\.module\.css$/],
                        loader: "style-loader!css-loader?modules&localIdentName=[path][name]---[local]---[hash:base64:5]"
                    },
                    __assign({ test: /\.module\.css$/, use: extraCssInProd(cssModuleLoader) }, cssLoaderConfig),
                    {
                        test: /\.s[a|c]ss$/,
                        use: extraCssInProd(cssPureLoader, sassLoader),
                        include: plugins_1.plugin.buildConfigSassLoaderIncludePipes.reduce(function (options, fn) {
                            return fn(options);
                        }, defaultSourcePathToBeResolve),
                        exclude: plugins_1.plugin.buildConfigSassLoaderExcludePipes.reduce(function (options, fn) {
                            return fn(options);
                        }, [/\.module\.s[a|c]ss$/]),
                    },
                    {
                        test: /\.module\.s[a|c]ss$/,
                        use: extraCssInProd(cssModuleLoader, sassLoader),
                        include: plugins_1.plugin.buildConfigSassLoaderIncludePipes.reduce(function (options, fn) {
                            return fn(options);
                        }, defaultSourcePathToBeResolve),
                        exclude: plugins_1.plugin.buildConfigSassLoaderExcludePipes.reduce(function (options, fn) {
                            return fn(options);
                        }, []),
                    },
                    {
                        test: /\.less$/,
                        use: extraCssInProd(cssPureLoader, lessLoader),
                        include: plugins_1.plugin.buildConfigLessLoaderIncludePipes.reduce(function (options, fn) {
                            return fn(options);
                        }, defaultSourcePathToBeResolve),
                        exclude: plugins_1.plugin.buildConfigLessLoaderExcludePipes.reduce(function (options, fn) {
                            return fn(options);
                        }, [/\.module\.less$/]),
                    },
                    {
                        test: /\.module\.less$/,
                        use: extraCssInProd(cssModuleLoader, lessLoader),
                        include: plugins_1.plugin.buildConfigLessLoaderIncludePipes.reduce(function (options, fn) {
                            return fn(options);
                        }, defaultSourcePathToBeResolve),
                        exclude: plugins_1.plugin.buildConfigLessLoaderExcludePipes.reduce(function (options, fn) {
                            return fn(options);
                        }, []),
                    },
                    { test: /\.html$/, use: ['raw-loader'] },
                    {
                        test: /\.(png|jpg|jpeg|gif|woff|woff2|eot|ttf|svg)$/,
                        use: [
                            {
                                loader: 'url-loader',
                                options: {
                                    limit: 1024 * 100,
                                },
                            },
                        ],
                    },
                ],
            },
            resolve: {
                alias: __assign(__assign(__assign({}, (global_state_1.globalState.sourceConfig.type === 'project' && {
                    src: path.join(global_state_1.globalState.projectRootPath, '/src'),
                })), (global_state_1.globalState.isDevelopment && {
                    'react-dom': '@hot-loader/react-dom',
                })), global_state_1.globalState.packages.reduce(function (obj, eachPackage) {
                    var _a;
                    if (eachPackage.packageJson && eachPackage.packageJson.name) {
                        return __assign(__assign({}, obj), (_a = {}, _a[eachPackage.packageJson.name] = path.join(eachPackage.rootPath, 'src'), _a));
                    }
                    return obj;
                }, {})),
                extensions: [
                    '.js',
                    '.jsx',
                    '.tsx',
                    '.ts',
                    '.md',
                    '.mdx',
                    '.scss',
                    '.less',
                    '.css',
                    '.png',
                    '.jpg',
                    '.jpeg',
                    '.gif',
                    'woff',
                    'woff2',
                    'eot',
                    'ttf',
                    'svg',
                ],
            },
            resolveLoader: {
                modules: selfAndProjectNodeModules,
            },
            plugins: [],
            optimization: {
                namedChunks: false,
                splitChunks: {
                    cacheGroups: {
                        default: false,
                    },
                },
            },
            stats: stats,
        };
        if (global_state_1.globalState.isDevelopment) {
            if (opts.htmlTemplatePath) {
                config.plugins.push(new HtmlWebpackPlugin({
                    title: global_state_1.globalState.sourceConfig.title || global_state_1.globalState.projectRootPath.split(path.sep).pop(),
                    filename: 'index.html',
                    template: opts.htmlTemplatePath,
                    htmlTemplateArgs: opts.htmlTemplateArgs,
                }));
            }
        }
        if (!global_state_1.globalState.isDevelopment) {
            if (global_state_1.globalState.sourceConfig.cssExtract && yargs.argv._[0] !== 'bundle' && !yargs.argv._[0].startsWith('debug')) {
                config.plugins.push(new MiniCssExtractPlugin({
                    filename: outCssFileName,
                }));
            }
            config.plugins.push(new OptimizeCssAssetsPlugin());
        }
        if (global_state_1.globalState.isDevelopment) {
            // Turn off performance hints during development.
            if (!config.performance) {
                config.performance = {};
            }
            config.performance.hints = false;
            // Improve dev performance https://v4.webpack.js.org/guides/build-performance/#development
            config.optimization.removeAvailableModules = false;
            config.optimization.removeEmptyChunks = false;
            config.optimization.splitChunks = false;
            config.output.pathinfo = false;
        }
        return [2 /*return*/, plugins_1.plugin.buildConfigPipes.reduce(function (newConfig, fn) { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = fn;
                            return [4 /*yield*/, newConfig];
                        case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
                    }
                });
            }); }, Promise.resolve(config))];
    });
}); };
exports.getWebpackConfig = getWebpackConfig;
//# sourceMappingURL=webpack-config.js.map