"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runWebpackDevServer = void 0;
// eslint-disable-next-line import/no-extraneous-dependencies
var express = require("express");
var normalizePath = require("normalize-path");
var open = require("open");
var path = require("path");
var urlJoin = require("url-join");
var yargs = require("yargs");
var webpack = require("webpack");
var WebpackBar = require("webpackbar");
var CircularDependencyPlugin = require("circular-dependency-plugin");
var _ = require("lodash");
var WebpackDevServer = require("webpack-dev-server");
var SpeedMeasurePlugin = require("speed-measure-webpack-plugin");
var ForkTsCheckerWebpackPlugin = require("fork-ts-checker-webpack-plugin");
var global_state_1 = require("./global-state");
var plugins_1 = require("./plugins");
var structor_config_1 = require("./structor-config");
var log_1 = require("./log");
var webpack_config_1 = require("./webpack-config");
var smp = new SpeedMeasurePlugin();
var stats = {
    warnings: true,
    assets: false,
    version: false,
    modules: false,
    entrypoints: false,
    hash: false,
    colors: true,
    children: false,
};
var runWebpackDevServer = function (opts, configWrapper) { return __awaiter(void 0, void 0, void 0, function () {
    var webpackConfig, exclude, defaultWebpackDevServerConfig, webpackDevServerConfig, compiler, devServer, port, host, https;
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return __generator(this, function (_l) {
        switch (_l.label) {
            case 0: return [4 /*yield*/, webpack_config_1.getWebpackConfig(opts)];
            case 1:
                webpackConfig = _l.sent();
                if (!opts.pipeConfig) return [3 /*break*/, 3];
                return [4 /*yield*/, opts.pipeConfig(webpackConfig)];
            case 2:
                webpackConfig = _l.sent();
                _l.label = 3;
            case 3:
                webpackConfig.plugins.push(new webpack.HotModuleReplacementPlugin());
                webpackConfig.plugins.push(new WebpackBar());
                // If set open in project config, perform a circular dependency check
                if ((_a = global_state_1.globalState.projectConfig.circularDetect) === null || _a === void 0 ? void 0 : _a.enable) {
                    exclude = (_b = global_state_1.globalState.projectConfig.circularDetect) === null || _b === void 0 ? void 0 : _b.exclude;
                    webpackConfig.plugins.push(new CircularDependencyPlugin({
                        exclude: exclude ? new RegExp(exclude) : /node_modules/,
                        cwd: process.cwd(),
                    }));
                }
                if (((_d = (_c = global_state_1.globalState.sourceConfig.devChecker) === null || _c === void 0 ? void 0 : _c.typescript) === null || _d === void 0 ? void 0 : _d.enabled) !== false ||
                    ((_f = (_e = global_state_1.globalState.sourceConfig.devChecker) === null || _e === void 0 ? void 0 : _e.eslint) === null || _f === void 0 ? void 0 : _f.enabled)) {
                    webpackConfig.plugins.push(new ForkTsCheckerWebpackPlugin({
                        async: (_g = global_state_1.globalState.sourceConfig.devChecker) === null || _g === void 0 ? void 0 : _g.async,
                        typescript: __assign({ enabled: true, memoryLimit: 8192, mode: 'write-references' }, (_h = global_state_1.globalState.sourceConfig.devChecker) === null || _h === void 0 ? void 0 : _h.typescript),
                        eslint: __assign({ enabled: false, memoryLimit: 8192, files: ["./" + structor_config_1.srcPath.dir + "/**/*.{ts,tsx}", "./" + structor_config_1.packagesPath.dir + "/**/*.{ts,tsx}"] }, (_j = global_state_1.globalState.sourceConfig.devChecker) === null || _j === void 0 ? void 0 : _j.eslint),
                        issue: (_k = global_state_1.globalState.sourceConfig.devChecker) === null || _k === void 0 ? void 0 : _k.issue,
                    }));
                }
                defaultWebpackDevServerConfig = __assign(__assign({ host: global_state_1.globalState.sourceConfig.host, hot: opts.hot, hotOnly: opts.hot, publicPath: opts.publicPath, before: function (app) {
                        app.use(function (req, res, next) {
                            // CORS
                            res.setHeader('Access-Control-Allow-Origin', '*');
                            res.setHeader('Access-Control-Allow-Methods', 'GET, POST, OPTIONS, PUT, PATCH, DELETE');
                            res.setHeader('Access-Control-Allow-Headers', 'X-Requested-With,content-type');
                            res.setHeader('Access-Control-Allow-Credentials', true);
                            next();
                        });
                        app.use('/', express.static(path.join(global_state_1.globalState.projectRootPath, structor_config_1.tempPath.dir, 'static')));
                    }, compress: true }, (!opts.jsOnly && {
                    historyApiFallback: { rewrites: [{ from: '/', to: normalizePath(path.join(opts.publicPath, 'index.html')) }] },
                })), { https: _.defaults({ value: opts.https }, { value: global_state_1.globalState.sourceConfig.useHttps }).value, overlay: { warnings: false, errors: true }, stats: stats, watchOptions: __assign({}, (!global_state_1.globalState.sourceConfig.watchNodeModules && {
                        ignored: /node_modules/,
                    })), headers: {
                        'Access-Control-Allow-Origin': '*',
                        'Access-Control-Allow-Credentials': 'true',
                        'Access-Control-Allow-Methods': 'GET, POST, PUT, DELETE, PATCH, OPTIONS',
                        'Access-Control-Allow-Headers': 'X-Requested-With, content-type, Authorization, x-csrf-token',
                    }, clientLogLevel: 'warn', disableHostCheck: true, port: opts.devServerPort, contentBase: opts.contentBase });
                return [4 /*yield*/, plugins_1.plugin.devServerConfigPipes.reduce(function (newConfig, fn) { return __awaiter(void 0, void 0, void 0, function () {
                        var _a;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    _a = fn;
                                    return [4 /*yield*/, newConfig];
                                case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
                            }
                        });
                    }); }, Promise.resolve(defaultWebpackDevServerConfig))];
            case 4:
                webpackDevServerConfig = (_l.sent());
                WebpackDevServer.addDevServerEntrypoints(webpackConfig, webpackDevServerConfig);
                if (yargs.argv.measureSpeed) {
                    webpackConfig = smp.wrap(webpackConfig);
                }
                if (configWrapper) {
                    webpackConfig = configWrapper(webpackConfig);
                }
                compiler = webpack(webpackConfig);
                devServer = new WebpackDevServer(compiler, webpackDevServerConfig);
                port = webpackDevServerConfig.port, host = webpackDevServerConfig.host, https = webpackDevServerConfig.https;
                devServer.listen(port, host, function () {
                    var devUrl = null;
                    var localSuggestUrl = urlJoin((https ? 'https' : 'http') + "://" + host + ":" + port, global_state_1.globalState.sourceConfig.baseHref);
                    if (opts.devUrl === host) {
                        devUrl = localSuggestUrl;
                    }
                    else if (opts.devUrl !== undefined) {
                        (devUrl = opts.devUrl);
                    }
                    else if (global_state_1.globalState.sourceConfig.devUrl !== undefined && global_state_1.globalState.sourceConfig.devUrl !== null) {
                        (devUrl = global_state_1.globalState.sourceConfig.devUrl);
                    }
                    else {
                        devUrl = localSuggestUrl;
                    }
                    log_1.logInfo("Serve on " + devUrl);
                    if (opts.autoOpenBrowser && devUrl) {
                        open(devUrl);
                    }
                });
                return [2 /*return*/];
        }
    });
}); };
exports.runWebpackDevServer = runWebpackDevServer;
//# sourceMappingURL=webpack-dev-server.js.map