"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWebpackDllConfig = void 0;
var path = require("path");
var webpack = require("webpack");
var WebpackBar = require("webpackbar");
var constants_1 = require("./constants");
var global_state_1 = require("./global-state");
var plugins_1 = require("./plugins");
var stats = {
    warnings: false,
    version: false,
    modules: false,
    entrypoints: false,
    hash: false,
};
var vendors = __spreadArray([
    'react',
    'react-dom',
    'lodash',
    'highlight.js',
    'react-router',
    'history',
    constants_1.PRI_PACKAGE_NAME + "/client"
], ((_a = global_state_1.globalState.sourceConfig.extraVendors) !== null && _a !== void 0 ? _a : []));
var getWebpackDllConfig = function (opts) {
    var result = {
        mode: 'development',
        entry: {
            library: plugins_1.plugin.devDllPipes.reduce(function (all, fn) {
                return fn(all);
            }, vendors),
        },
        output: {
            filename: opts.dllFileName,
            path: opts.dllOutPath,
            library: 'library',
        },
        plugins: [
            new webpack.DllPlugin({
                path: path.join(opts.dllOutPath, opts.dllMainfestName),
                name: 'library',
            }),
            new WebpackBar(),
        ],
        module: {
            rules: [
                {
                    test: /\.css/,
                    use: ['style-loader', 'css-loader'],
                },
            ],
        },
        resolve: {
            modules: [
                // From project node_modules
                path.join(global_state_1.globalState.projectRootPath, 'node_modules'),
                // Self node_modules
                path.join(__dirname, '../../../node_modules'),
            ],
            extensions: ['.js', '.jsx', '.tsx', '.ts', '.scss', '.less', '.css'],
        },
        resolveLoader: {
            modules: [
                // From project node_modules
                path.join(global_state_1.globalState.projectRootPath, 'node_modules'),
                // Self node_modules
                path.join(__dirname, '../../node_modules'),
            ],
        },
        stats: stats,
    };
    return result;
};
exports.getWebpackDllConfig = getWebpackDllConfig;
//# sourceMappingURL=webpack-dll-config.js.map