"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WrapContent = void 0;
var ConcatSource = require("webpack-sources");
var path = require("path");
var _ = require("lodash");
var node_1 = require("../node");
var WrapContent = /** @class */ (function () {
    function WrapContent(header, footer) {
        if (header === void 0) { header = ''; }
        if (footer === void 0) { footer = ''; }
        this.header = '';
        this.footer = '';
        this.header = header;
        this.footer = footer;
    }
    WrapContent.prototype.apply = function (compiler) {
        var _this = this;
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-ignore
        compiler.hooks.compilation.tap('WrapContent', function (compilation) {
            compilation.hooks.optimizeChunkAssets.tapAsync('WrapContent', function (chunks, done) {
                chunks.forEach(function (chunk) {
                    chunk.files.forEach(function (fileName) {
                        // Ignore workers
                        if (fileName.indexOf('worker.js') > -1) {
                            return;
                        }
                        if (chunk.name === 'main' ||
                            chunk.name === path.basename(node_1.pri.sourceConfig.outFileName, '.js') ||
                            _.has(node_1.pri.sourceConfig.entries, chunk.name)) {
                            compilation.assets[fileName] = new ConcatSource.ConcatSource(_this.header, compilation.assets[fileName], _this.footer);
                        }
                    });
                });
                done();
            });
        });
    };
    return WrapContent;
}());
exports.WrapContent = WrapContent;
//# sourceMappingURL=webpack-plugin-wrap-content.js.map