"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.bundleDlls = exports.runWebpackDll = exports.watchWebpack = exports.runWebpack = void 0;
var fs = require("fs");
var path = require("path");
var webpack = require("webpack");
var WebpackBar = require("webpackbar");
var SpeedMeasurePlugin = require("speed-measure-webpack-plugin");
var yargs = require("yargs");
var webpack_config_1 = require("./webpack-config");
var webpack_dll_config_1 = require("./webpack-dll-config");
var project_helper_1 = require("./project-helper");
var log_1 = require("./log");
var smp = new SpeedMeasurePlugin();
var stats = {
    warnings: false,
    version: false,
    modules: false,
    entrypoints: false,
    hash: false,
    colors: true,
    children: false,
};
var runWebpack = function (opts) { return __awaiter(void 0, void 0, void 0, function () {
    var webpackConfig, compiler;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, webpack_config_1.getWebpackConfig(opts)];
            case 1:
                webpackConfig = _a.sent();
                if (!opts.pipeConfig) return [3 /*break*/, 3];
                return [4 /*yield*/, opts.pipeConfig(webpackConfig)];
            case 2:
                webpackConfig = _a.sent();
                _a.label = 3;
            case 3:
                webpackConfig.plugins.push(new WebpackBar());
                if (yargs.argv.measureSpeed) {
                    webpackConfig = smp.wrap(webpackConfig);
                }
                compiler = webpack(webpackConfig);
                return [2 /*return*/, runCompiler(compiler)];
        }
    });
}); };
exports.runWebpack = runWebpack;
var watchWebpack = function (opts) { return __awaiter(void 0, void 0, void 0, function () {
    var webpackConfig, compiler;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, webpack_config_1.getWebpackConfig(opts)];
            case 1:
                webpackConfig = _a.sent();
                if (!opts.pipeConfig) return [3 /*break*/, 3];
                return [4 /*yield*/, opts.pipeConfig(webpackConfig)];
            case 2:
                webpackConfig = _a.sent();
                _a.label = 3;
            case 3:
                webpackConfig.plugins.push(new WebpackBar());
                compiler = webpack(webpackConfig);
                compiler.watch({}, function (err, status) {
                    if (!err && !status.hasErrors()) {
                        process.stdout.write(status.toString(stats) + "\n\n");
                    }
                    else if (err && err.message) {
                        log_1.logWarn(err.message);
                    }
                    else {
                        log_1.logWarn(status.toString());
                    }
                });
                return [2 /*return*/];
        }
    });
}); };
exports.watchWebpack = watchWebpack;
var runWebpackDll = function (opts) { return __awaiter(void 0, void 0, void 0, function () {
    var webpackConfig, compiler;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                webpackConfig = webpack_dll_config_1.getWebpackDllConfig(opts);
                if (!opts.pipeConfig) return [3 /*break*/, 2];
                return [4 /*yield*/, opts.pipeConfig(webpackConfig)];
            case 1:
                webpackConfig = _a.sent();
                _a.label = 2;
            case 2:
                compiler = webpack(webpackConfig);
                return [2 /*return*/, runCompiler(compiler)];
        }
    });
}); };
exports.runWebpackDll = runWebpackDll;
/**
 * Bundle dlls when node_modules changed, dlls not exist, extraVendors changed, or package to dev changed;
 */
var bundleDlls = function (opts) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!(project_helper_1.hasPackageChanged() ||
                    project_helper_1.hasExtraVendorsChanged() ||
                    (project_helper_1.hasNodeModules() && project_helper_1.hasNodeModulesModified()) ||
                    !fs.existsSync(path.join(opts.dllOutPath, opts.dllFileName)))) return [3 /*break*/, 2];
                return [4 /*yield*/, exports.runWebpackDll(opts)];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2 /*return*/];
        }
    });
}); };
exports.bundleDlls = bundleDlls;
function runCompiler(compiler) {
    return new Promise(function (resolve) {
        compiler.run(function (err, status) {
            if (!err && !status.hasErrors()) {
                process.stdout.write(status.toString(stats) + "\n\n");
                resolve(status.toJson());
            }
            else if (err && err.message) {
                throw Error(err.message);
            }
            else {
                throw Error(status.toString());
            }
        });
    });
}
//# sourceMappingURL=webpack.js.map