"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addWhiteFilesByProjectType = void 0;
var path = require("path");
var node_1 = require("../node");
var global_state_1 = require("./global-state");
var structor_config_1 = require("./structor-config");
// For component/plugin, add `src` to white list.
function addWhiteFilesByProjectType() {
    if (global_state_1.globalState.sourceConfig.type === 'component' || global_state_1.globalState.sourceConfig.type === 'plugin') {
        node_1.pri.project.whiteFileRules.add(function (file) {
            return path.format(file).startsWith(path.join(global_state_1.globalState.projectRootPath, structor_config_1.srcPath.dir));
        });
    }
    global_state_1.globalState.packages.forEach(function (eachPackage) {
        if (eachPackage.config.type === 'component' || eachPackage.config.type === 'plugin') {
            node_1.pri.project.whiteFileRules.add(function (file) {
                return path.format(file).startsWith(path.join(eachPackage.rootPath, structor_config_1.srcPath.dir));
            });
        }
    });
}
exports.addWhiteFilesByProjectType = addWhiteFilesByProjectType;
//# sourceMappingURL=white-file-helper.js.map